2005-08-05  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      tests/array_type_hint_001.phpt
      tests/bug33996.phpt:
      Fixed bug #33996 (No information given for fatal error on passing invalid
      value to typed argument)

    * zend_operators.c
      tests/bug33999.phpt:
      Fixed bug #33999 (object remains object when cast to int)

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed memory leak in foreach() on undefined variable
      (Zend/tests/foreach_undefined.php)

2005-08-04  Antony Dovgal  <antony@zend.com>

    * tests/foreach_undefined.phpt:
      add test for the last Dmitry's fix

2005-08-04  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c:
      Fixed possible memory corryption during compilation of <?php foreach($a as
      $b); ?>

    * (PHP_5_0)
      zend_objects.c:
      Fixed clone bug in ze1_compatibility mode

    * zend_objects.c:
      Fixed clone bug in ze1_compatibilty mode

2005-08-03  Jani Taskinen  <jani.taskinen@sci.fi>

    * LICENSE:
      - Bumber up year

    * acconfig.h
      zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_alloc.c
      zend_alloc.h
      zend_builtin_functions.c
      zend_builtin_functions.h
      zend_compile.c
      zend_compile.h
      zend_config.nw.h
      zend_config.w32.h
      zend_constants.c
      zend_constants.h
      zend_default_classes.c
      zend_dynamic_array.c
      zend_dynamic_array.h
      zend_errors.h
      zend_exceptions.c
      zend_exceptions.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_extensions.c
      zend_extensions.h
      zend_fast_cache.h
      zend_globals.h
      zend_globals_macros.h
      zend_hash.c
      zend_hash.h
      zend_highlight.c
      zend_highlight.h
      zend_indent.c
      zend_indent.h
      zend_ini.c
      zend_ini.h
      zend_ini_parser.y
      zend_ini_scanner.h
      zend_ini_scanner.l
      zend_interfaces.c
      zend_interfaces.h
      zend_istdiostream.h
      zend_iterators.c
      zend_iterators.h
      zend_language_parser.y
      zend_language_scanner.h
      zend_language_scanner.l
      zend_list.c
      zend_list.h
      zend_llist.c
      zend_llist.h
      zend_mm.c
      zend_mm.h
      zend_modules.h
      zend_multibyte.c
      zend_multibyte.h
      zend_multiply.h
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects.c
      zend_objects.h
      zend_objects_API.c
      zend_objects_API.h
      zend_opcode.c
      zend_operators.c
      zend_operators.h
      zend_ptr_stack.c
      zend_ptr_stack.h
      zend_qsort.c
      zend_qsort.h
      zend_reflection_api.c
      zend_reflection_api.h
      zend_sprintf.c
      zend_stack.c
      zend_stack.h
      zend_static_allocator.c
      zend_static_allocator.h
      zend_stream.c
      zend_stream.h
      zend_strtod.h
      zend_ts_hash.c
      zend_ts_hash.h
      zend_types.h
      zend_variables.c
      zend_variables.h
      zend_vm.h:
      Bump up the year

    * README.ZEND_VM:
      Nuked DOS EOLs

2005-08-02  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute_API.c
      zend_execute_API.c:
      Fixed bug #33942 (the patch to #33156 crash cygwin except cli)

2005-08-02  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_exceptions.c:
      - Fixed bug #33967 (misuse of Exception constructor doesn\'t display
      errorfile)

2005-08-02  Dmitry Stogov  <dmitry@zend.com>

    * bench.php:
      Removed warnings

2005-07-29  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_vm_def.h
      zend_vm_execute.h:
      Fixed warning message generated when isset() or empty() are given invalid
      offset type.

2005-07-29  Anantha Kesari H Y  <hyanantha@novell.com>

    * acconfig.h
      acconfig.h:
      In NetWare few of the programs like apache2 and ldap use winsock inclusinf
      sys/socket.h is not desirable.
      --Kamesh

2005-07-29  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_vm_execute.h:
      update generated file

2005-07-28  Andi Gutmans  <andi@zend.com>

    * zend_vm_def.h:
      - Tiny fixlet

2005-07-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h:
      - Add convenience function zend_is_callable_ex() and base zend_is_callable
        and zend_make_callable on it. This functions allows to check if a php
        variable is a callable function and returns its function pointer as well
        as object if possible.

2005-07-26  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_execute_API.c:
      bug #33865

2005-07-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      - Fix #33853

2005-07-22  Dmitry Stogov  <dmitry@zend.com>

    * zend.c
      zend.c
      tests/bug33802.phpt
      tests/bug33802.phpt
      tests/bug33802.phpt:
      Fixed bug #33802 (throw Exception in error handler causes crash)

2005-07-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      - Fix error generation logic (found by johannes)

2005-07-21  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_def.h:
      Fixed bug with returning from internal function by reference

2005-07-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      - Dont't warn in case an exception is pending - in this case it'd
      superflous

2005-07-19  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c
      zend_compile.c
      zend_execute.c
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed bug #33710 (ArrayAccess objects doen't initialize $this)

2005-07-18  Rasmus Lerdorf  <rasmus@lerdorf.com>

    * zend_language_scanner.l:
      Valgrind is unhappy that this is not initialized

2005-07-18  Dmitry Stogov  <dmitry@zend.com>

    * zend_API.c
      zend_API.h:
      Fixed bug in new module statrup mechanism

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug33558.phpt:
      Fixed bug #33558 (warning with nested calls to functions returning by
      reference)

    * tests/bug33558.phpt
      tests/bug33558.phpt:
      
      Fixed bug #33558 (warning with nested calls to functions returning by
      reference)

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      Removed some compilation warnings.

2005-07-18  Jani Taskinen  <jani.taskinen@sci.fi>

    * tests/bug33710.phpt:
      typo

2005-07-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug33710.phpt:
      - Add new test

2005-07-17  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_compile.c:
      Added missing init.

2005-07-14  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev

    * (php_5_1_0b3)
      zend.h:
      - Beta 3

2005-07-12  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev

    * (php_5_1_0b3)
      zend.h:
      - Beta 3

2005-07-12  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_1_0b3)
      zend_execute_API.c
      zend_execute_API.c:
      Fixed bug #33156 (cygwin version of setitimer doesn't accept ITIMER_PROF).
      (Nuno)

2005-07-11  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_vm_def.h
      zend_vm_execute.h:
      Make references misuse emit E_NOTICE rather E_STRICT to be compatible with
      PHP 4.4.0

2005-07-08  Jani Taskinen  <jani.taskinen@sci.fi>

    * tests/unset_cv05.phpt
      tests/unset_cv06.phpt:
      fix test when session.save_handler is "user"

2005-07-07  Dmitry Stogov  <dmitry@zend.com>

    * zend.h
      zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_object_handlers.c
      zend_objects.c
      zend_reflection_api.c:
      Fixed bug #33512 (Add missing support for isset()/unset() overloading to
      complement the property get/set methods)

2005-07-07  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend_stream.c
      zend_stream.c:
      zend_stream_getc uses fread internally. NetWare LibC fread reads 4(Which I
      believe EOT) for EOF(^D) character. This happens when fread is asked to
      read one and only character as is the case with cl interactive mode.
      -- Kamesh

2005-07-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute_API.c
      zend_hash.c
      zend_hash.h
      tests/bug28072.phpt:
      Fixed bug #28072 (static array with some constant keys will be incorrectly
      ordered).

2005-07-04  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.h
      zend_execute.c
      zend_language_parser.y
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed SIGSEGV on 'global ${"{$blah}_ID"};'

    * zend_API.h
      zend_execute_API.c:
      Fixed bug #31158 (array_splice on $GLOBALS crashes)

2005-07-03  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed memory leak

2005-06-30  Dmitry Stogov  <dmitry@zend.com>

    * zend_API.c
      zend_API.h:
      Restored old behavior of zend_statup_module()

2005-06-29  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h:
      fix conditions for freeing

    * zend_API.c
      zend_API.c:
      add comment

    * (PHP_5_0)
      zend_execute.c:
      fix conditions

2005-06-28  Antony Dovgal  <antony@zend.com>

    * zend_execute.c:
      fix leak: when dup was <success>ful zend_std_object_get_class_name()
      returns SUCCESS aka 0

2005-06-28  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h:
      fix previous patch

    * zend_vm_execute.h:
      update

    * zend_execute.c
      zend_vm_def.h:
      fixes for non-php objects

    * (PHP_5_0)
      zend_execute.c:
      fixes fo rnon-php objects (John Coggeshall)

2005-06-27  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend.c:
      - Fixed bug #31358 (Older GCC versions do not provide portable va_copy()).

2005-06-27  Stanislav Malyshev  <stas@zend.com>

    * zend_API.c
      zend_API.c
      zend_API.h
      zend_API.h
      zend_builtin_functions.c
      zend_builtin_functions.c
      zend_exceptions.c
      zend_exceptions.c:
      fix various "Class entry requested for an object without PHP class"
      messages
      when working with non-PHP objects.

2005-06-27  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed SIGSEGV on assigment string offset by reference

    * zend_builtin_functions.c
      zend_builtin_functions.c:
      Fixed wrong include/requre occurrences in debug backtrace.

2005-06-24  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.h
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      Export zend_do_fcall() helper from executor

    * zend_compile.c
      zend_compile.c:
      Partial fix for bug #26584 (Class member - array key overflow)
      It doesn't fix integer overflow problem, but allows null, boolean and
      double keys in array constants in the same way as in runtime.

    * tests/bug30519.phpt
      tests/bug30519.phpt:
      
      Fixed bug #30519 (Interface not existing says Class not found)

    * zend_compile.c
      zend_compile.c
      zend_compile.h
      zend_compile.h
      zend_execute.c
      zend_execute_API.c
      zend_execute_API.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug30519.phpt:
      Fixed bug #30519 (Interface not existing says Class not found)

2005-06-23  Dmitry Stogov  <dmitry@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c
      tests/bug28377.phpt:
      Fixed bug #28377 (debug_backtrace is intermittently passing args)

    * tests/bug28377.phpt
      tests/bug28377.phpt:
      
      file bug28377.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug32660.phpt:
      Fixed bug #32660 (Assignment by reference causes crash when field access is
      overloaded (__get))

    * tests/bug32660.phpt
      tests/bug32660.phpt:
      
      Fixed bug #32660 (Assignment by reference causes crash when field access
      is overloaded (__get))

    * zend_builtin_functions.c
      zend_builtin_functions.c
      tests/bug30828.phpt:
      Fixed bug #30828 (debug_backtrace() reports incorrect class in overridden
      methods)

    * tests/bug30828.phpt
      tests/bug30828.phpt:
      
      file bug30828.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      tests/bug27268.phpt:
      Test for bug #27268. It is fixed in HEAD but not in PHP_5_0.

    * zend_execute.c
      tests/bug27268.phpt
      tests/bug27268.phpt:
      Fixed bug #27268 (Bad references accentuated by clone).

2005-06-23  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev

    * (php_5_1_0b2)
      zend.h:
      - Beta 2

2005-06-22  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_1_0b2)
      zend_builtin_functions.c
      zend_builtin_functions.c
      zend_execute_API.c
      zend_execute_API.c
      tests/bug29896.phpt:
      Fixed bug #29896 (Backtrace argument list out of sync)

    * tests/bug29896.phpt
      tests/bug29896.phpt:
      
      file bug29896.phpt was initially added on branch PHP_5_0.

2005-06-22  Stanislav Malyshev  <stas@zend.com>

    * (php_5_1_0b2)
      zend_vm.h
      zend_vm_execute.h
      zend_vm_gen.php:
      export zend_vm_set_opcode_handler

2005-06-22  Antony Dovgal  <antony@zend.com>

    * (php_5_1_0b2)
      zend_ini.c:
      - allow to use "yes" and "true" with ini_set() and in commandline (through
      -d flag)
      - fix #15854 that was caused by wrong consideration that
      zend_ini_boolean_displayer_cb()
      always recieves converted to "0"/"1" values.

2005-06-22  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_1_0b2)
      zend_compile.c
      zend_compile.c
      zend_compile.h
      zend_compile.h
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug33257.phpt:
      Fixed bug #33257 (array_splice() inconsistent when passed function instead
      of variable)

    * tests/bug33257.phpt
      tests/bug33257.phpt:
      
      file bug33257.phpt was initially added on branch PHP_5_0.

2005-06-22  Jani Taskinen  <jani.taskinen@sci.fi>

    * (php_5_1_0b2)
      tests/unset_cv05.phpt
      tests/unset_cv06.phpt:
      fix tests

2005-06-21  Dmitry Stogov  <dmitry@zend.com>

    * tests/unset_cv07.phpt:
      Fixed test file

2005-06-21  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev. Guys (n' Girls), give at least 1 hour before you start
      - complaining about not going back to -dev. I like checking the tarball
      - before I change it back.

    * (php_5_1_0b2)
      zend.h:
      - Take #3 :)

2005-06-21  Ilia Alshanetsky  <ilia@prohost.org>

    * (php_5_1_0b2)
      zend_reflection_api.c:
      Fixed memory leak.
      

2005-06-21  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_compile.c:
      Remove unnecessary ZEND_FETCH_CLASS together with
      ZEND_DECLARE_INHERITED_CLASS
      in case of early binding

    * (php_5_1_0b2)
      zend_compile.c:
      Remove unnecessary ZEND_FETCH_CLASS together with
      ZEND_DECLARE_INHERITED_CLASS in case of early binding

2005-06-20  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev

    * (php_5_1_0b2)
      zend.h:
      - Beta 2

2005-06-20  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_1_0b2)
      zend_object_handlers.c
      zend_object_handlers.c:
      Fixed possible crash on $x = $obj->$non_string

2005-06-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (php_5_1_0b2)
      zend_reflection_api.c:
      - Fix bug #33389 by fixing copying

    * zend_reflection_api.c:
      - Show true/flase

2005-06-19  Derick Rethans  <php@derickrethans.nl>

    * tests/bug32226.phpt:
      - Fixed layout of test description.

2005-06-17  Jani Taskinen  <jani.taskinen@sci.fi>

    * tests/bug29368.phpt
      tests/bug30856.phpt
      tests/bug30961.phpt
      tests/bug31720.phpt
      tests/bug32226.phpt
      tests/bug33277.phpt:
      No short-tags!

2005-06-17  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.h
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Removed EX(fbc_constructor) (it is no longer needed)

2005-06-17  Antony Dovgal  <antony@zend.com>

    * (PHP_5_0)
      zend_API.c
      zend_list.c:
      MFH: improve error messages in internal classes

    * zend_API.c
      zend_list.c:
      improve error messages when error raised from an internal class (do not
      hide class name)

2005-06-17  Dmitry Stogov  <dmitry@zend.com>

    * zend_object_handlers.c
      zend_object_handlers.c:
      Fixed bug #33277 (private method accessed by child class)

2005-06-17  Antony Dovgal  <antony@zend.com>

    * zend_hash.c:
      fix bug #33382 (array_reverse() fails after *sort())
      no need to MFH - the bug existed only in HEAD

2005-06-17  Dmitry Stogov  <dmitry@zend.com>

    * zend_API.c
      zend_API.h
      zend_extensions.h
      zend_modules.h:
      Improved PHP extension loading mechanism with support for module
      dependencies and conflicts.

2005-06-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Internal functions/methods can now return by reference

    * zend_execute.c:
      - Fix TSRM build

2005-06-16  Dmitry Stogov  <dmitry@zend.com>

    * bench.php:
      typo

    * zend.h
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute_API.c
      zend_extensions.h
      zend_modules.h
      zend_object_handlers.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Allowed return by refrence from internal functions

2005-06-16  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c
      zend_execute.h:
      rename to zend_

2005-06-16  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug33318.phpt:
      Fixed bug #33318 (throw 1; results in Invalid opcode 108/1/8)

2005-06-16  Zeev Suraski  <zeev@zend.com>

    * zend_language_scanner.l:
      Fixlet

2005-06-16  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Compilation warnings

    * zend_compile.c
      zend_compile.h
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      ZEND_UNSET_DIM_OBJ is splitted to ZEND_UNSET_DIM and ZEND_UNSET_OBJ.

2005-06-16  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c
      zend_execute.h:
      export zval getters

2005-06-16  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.h
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      USER_OPCODE API is improvet.
      Implemented ability to dispatch from user handler to internal handler of
      another opcode.

2005-06-15  Dmitry Stogov  <dmitry@zend.com>

    * zend.c
      zend.h:
      Fixed OS X compatibility

2005-06-15  Jani Taskinen  <jani.taskinen@sci.fi>

    * tests/bug32428.phpt:
      typofix

2005-06-14  Ilia Alshanetsky  <ilia@prohost.org>

    * bench.php:
      more accurate timing function.

2005-06-14  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      Removed old executor

2005-06-14  Jani Taskinen  <jani.taskinen@sci.fi>

    * Zend.m4:
      reordered + added msg to configure output for PHP_ZEND_VM

    * Zend.m4:
      typofix

    * Zend.m4
      acinclude.m4:
      fix standalone build

2005-06-13  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      Specializer optimization

    * zend.c
      zend.h
      zend_execute.c:
      Fixed bug #33212 ([GCC 4]: 'zend_error_noreturn' aliased to external symbol
      'zend_error').
      The fix is not tested on Solaris and DARWIN!

    * zend_reflection_api.c
      tests/bug33312.phpt:
      Fixed bug #33312 (ReflectionParameter methods do not work correctly)

2005-06-11  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev

    * (php_5_1_0b2)
      zend.h:
      - b2 (will post it to internals@)

2005-06-10  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to -dev

    * (php_5_1_0b1)
      zend.h:
      - Go with 5.1.0b1

2005-06-10  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_1_0b1)
      tests/bug30162.phpt:
      Added test for bug #30162 (it is already fixed but test file was forgotten)

    * (php_5_1_0b1)
      tests/bug31177.phpt:
      Added test file for bug #31177 (not fixed yet)

    * tests/bug31177.phpt
      tests/bug31177.phpt:
      
      file bug31177.phpt was initially added on branch PHP_5_0.

    * (php_5_1_0b1)
      tests/bug29689.phpt:
      typos

    * (php_5_1_0b1)
      zend_reflection_api.c
      zend_reflection_api.c:
      Fixed support for ZEND_ACC_SHADOW in ReflectionProperty constructor

    * (php_5_1_0b1)
      zend_execute.c
      zend_execute.h
      zend_extensions.h
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      Fix so that extensions like xdebug, can overload opcodes in all execution
      modes including goto/switch

    * (php_5_1_0b1)
      zend_compile.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Merge three opcodes (ZEND_NEW, ZEND_JMP_NO_CTOR, ZEND_INIT_CTOR) into one
      (ZEND_NEW). There was no real reason for this anymore and API should be
      changed before 5.1

2005-06-09  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_object_handlers.c
      zend_reflection_api.c
      tests/bug29689.phpt:
      MF50:  fix #29689 and more private property problems

    * tests/bug33277.phpt:
      add test for this TBF bug

    * zend_compile.c:
      disallow abstrace private methods

    * (PHP_5_0)
      zend_compile.c:
      Disallow abstract privae methods

    * (PHP_5_0)
      zend_compile.c
      zend_compile.h
      zend_object_handlers.c
      zend_reflection_api.c
      tests/bug29689.phpt:
      fix #29689 and more private property problems

2005-06-09  Dmitry Stogov  <dmitry@zend.com>

    * zend.c
      zend.c
      zend_execute_API.c
      zend_execute_API.c:
      Fixed double call to php_stream_close() on compiler errors

2005-06-09  Stanislav Malyshev  <stas@zend.com>

    * tests/bug33277.phpt
      tests/bug33277.phpt:
      
      file bug33277.phpt was initially added on branch PHP_5_0.

2005-06-09  Dmitry Stogov  <dmitry@zend.com>

    * zend.c
      zend.c:
      Fixed bug #25922 (In error handler, modifying 5th arg (errcontext) may
      result in seg fault)

    * zend_language_scanner.l
      zend_language_scanner.l:
      Fixed bug (Crash on Windows and ZTS) that was introduced with fix for bug
      #26456

2005-06-08  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed exception handling in getIterator() callback (bugs #26229 & #30725)

    * zend_compile.c
      zend_compile.c:
      Fixed valgrind errors

    * zend_reflection_api.c:
      Fixed ReflectionClass::setStaticPropertyValue()

2005-06-08  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_config.w32.h:
      Hopefully fixes win32 builds

2005-06-08  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c:
      Fixed lookups for previos opcodes

    * zend_execute_API.c
      zend_execute_API.c
      tests/bug30140.phpt:
      Fixed bug #30140 (Problem with array in static properties)

    * tests/bug30140.phpt
      tests/bug30140.phpt:
      
      file bug30140.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      tests/bug32322.phpt:
      Added test for bug #32322 (Return values by reference broken( using
      self::),example singleton instance)

    * tests/bug32322.phpt
      tests/bug32322.phpt:
      
      Added test for bug #32322 (Return values by reference broken( using
      self::),example singleton instance)

    * zend_object_handlers.c
      zend_object_handlers.c
      tests/bug30820.phpt:
      Fixed bug #30820 (static member conflict with $this->member silently
      ignored)

    * tests/bug30820.phpt
      tests/bug30820.phpt:
      
      file bug30820.phpt was initially added on branch PHP_5_0.

    * zend_compile.c
      zend_compile.c
      zend_language_parser.y
      zend_language_parser.y
      tests/bug30961.phpt:
      Fixed bug #30961 (Wrong linenumber in ReflectionClass getStartLine())

    * tests/bug30961.phpt
      tests/bug30961.phpt:
      
      file bug30961.phpt was initially added on branch PHP_5_0.

2005-06-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c
      zend_compile.c
      zend_compile.h
      zend_compile.h
      zend_language_scanner.l
      zend_language_scanner.l:
      Fixed bug #26456 (Wrong results from Reflection-API getDocComment() when
      called via STDIN)

2005-06-07  Jani Taskinen  <jani.taskinen@sci.fi>

    * Zend.m4:
      -Moved --disable-zend-memory-manager where it belongs

    * acinclude.m4:
      - Show "none" when nothing is found

2005-06-07  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_objects.c:
      Fixed ZTS build.

2005-06-07  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_alloc.h:
      - MFH: Added the --disable-zend-memory-manager switch to disable the Zend
        memory manager.

    * zend_alloc.h:
      - Added the --disable-zend-memory-manager switch to disable the Zend memory
        manager.

2005-06-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c:
      Fixed memory leak in debug_print_backtrace()

    * zend_execute.c
      zend_execute.c:
      fixed memory leak in bug #28972 ([] operator overflow treatment is
      incorrect), not the bug itself.

2005-06-07  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      - MF44: Problems with user defined error handler and references

2005-06-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_objects.c
      zend_objects.c
      tests/bug33243.phpt:
      Fixed bug #33243 (ze1_compatibility_mode does not work as expected)

    * tests/bug33243.phpt
      tests/bug33243.phpt:
      
      file bug33243.phpt was initially added on branch PHP_5_0.

2005-06-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c
      zend_compile.c
      zend_compile.h
      zend_compile.h
      zend_language_scanner.l
      zend_language_scanner.l:
      Fixed bug #26456 (Wrong results from Reflection-API getDocComment() when
      called via STDIN)

2005-06-07  Jani Taskinen  <jani.taskinen@sci.fi>

    * Zend.m4:
      -Moved --disable-zend-memory-manager where it belongs

    * acinclude.m4:
      - Show "none" when nothing is found

2005-06-07  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_objects.c:
      Fixed ZTS build.

2005-06-07  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_alloc.h:
      - MFH: Added the --disable-zend-memory-manager switch to disable the Zend
        memory manager.

    * zend_alloc.h:
      - Added the --disable-zend-memory-manager switch to disable the Zend memory
        manager.

2005-06-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c:
      Fixed memory leak in debug_print_backtrace()

    * zend_execute.c
      zend_execute.c:
      fixed memory leak in bug #28972 ([] operator overflow treatment is
      incorrect), not the bug itself.

2005-06-07  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      - MF44: Problems with user defined error handler and references

2005-06-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_objects.c
      zend_objects.c
      tests/bug33243.phpt:
      Fixed bug #33243 (ze1_compatibility_mode does not work as expected)

    * tests/bug33243.phpt
      tests/bug33243.phpt:
      
      file bug33243.phpt was initially added on branch PHP_5_0.

2005-06-06  Derick Rethans  <php@derickrethans.nl>

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      - Regenerate VM files and add warning about regeneration

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h:
      - MH44: Problems with user defined error handler and wrong usage of
      references

2005-06-06  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c
      tests/bug32428.phpt:
      Fixed bug #32428 (The @ warning error supression operator is broken)

    * zend_objects_API.c
      zend_objects_API.c
      tests/bug32799.phpt:
      Fixed bug #32799 (crash: calling the corresponding global var during the
      destruct)

    * tests/bug32799.phpt
      tests/bug32799.phpt:
      
      file bug32799.phpt was initially added on branch PHP_5_0.

    * tests/bug32596.phpt:
      Added test for bug #32596 (Segfault/Memory Leak by getClass (etc) in
      __destruct)

    * tests/bug32596.phpt
      tests/bug32596.phpt:
      
      file bug32596.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute_API.c:
      Fixed bug #32596 (Segfault/Memory Leak by getClass (etc) in __destruct)

    * (PHP_5_0)
      tests/bug32993.phpt:
      Added test for bug #32993 (implemented Iterator function current() don't
      throw
        exception)

    * tests/bug32993.phpt
      tests/bug32993.phpt:
      
      Fixed bug #32993 (implemented Iterator function current() don't throw
      exception)

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed bug #32993 (implemented Iterator function current() don't throw
      exception)

    * zend_object_handlers.c
      zend_object_handlers.c
      tests/bug33171.phpt:
      Fixed bug #33171 (foreach enumerates private fields declared in base
      classes)

    * tests/bug33171.phpt
      tests/bug33171.phpt:
      
      file bug33171.phpt was initially added on branch PHP_5_0.

2005-06-06  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_language_scanner.l:
      Avoid double-freeing streams.
      This can happen because all streams are registered as resources;
      the engine also tracks them in the open_files global.
      
      Avoid the potential for double-freeing by simply making streams exposed to
      the
      engine have no closer for the engine to call; they will already be in the
      resource list, and thus will be shut down properly at request end.

2005-06-04  Zeev Suraski  <zeev@zend.com>

    * zend_compile.h
      zend_language_parser.y
      zend_language_scanner.l
      zend_stream.c
      zend_stream.h
      tests/halt01.phpt
      tests/halt02.phpt
      tests/halt03.phpt:
      Thought I committed it ages ago...  Anyway, without further delays, the
      final
      __halt_compiler() patch

2005-06-03  Dmitry Stogov  <dmitry@zend.com>

    * tests/bug30394.phpt:
      Added test for 5.0 specific bug #30394 (Assignment operators yield wrong
      result with __get/__set)

    * (PHP_5_0)
      zend.c
      zend_execute_API.c
      tests/bug30394.phpt
      tests/bug30394.phpt:
      Fixed bug #30394 (Assignment operators yield wrong result with __get/__set)

    * zend_compile.c
      zend_compile.c
      tests/bug30080.phpt:
      Fixed bug #30080 (Passing array or non array of objects)

    * tests/bug30080.phpt
      tests/bug30080.phpt:
      
      file bug30080.phpt was initially added on branch PHP_5_0.

    * zend_compile.c
      zend_compile.c
      zend_execute.c
      tests/bug27598.phpt:
      Fixed bug #27598 (list() array key assignment causes HUGE memory leak)

    * tests/bug27598.phpt
      tests/bug27598.phpt:
      
      file bug27598.phpt was initially added on branch PHP_5_0.

    * zend_execute.c
      zend_object_handlers.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/object_handlers.phpt:
      Fixed memory allocation bugs related to magic object handlers (__get(),
      __set(),
       ...)

    * tests/object_handlers.phpt
      tests/object_handlers.phpt:
      
      file object_handlers.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute.c
      zend_object_handlers.c:
      Fixed memory allocation bugs related to magic object handlers (__get(),
      __set(), ...)

2005-06-01  Dmitry Stogov  <dmitry@zend.com>

    * zend_object_handlers.c
      zend_object_handlers.c
      tests/bug30791.phpt:
      Fixed bug #30791 (magic methods (__sleep/__wakeup/__toString) call __call
      if object is overloaded)

    * tests/bug30791.phpt
      tests/bug30791.phpt:
      
      file bug30791.phpt was initially added on branch PHP_5_0.

2005-05-31  Magnus Määttä  <novell@kiruna.se>

    * tests/bug27304.phpt:
      Fix test

2005-05-31  Dmitry Stogov  <dmitry@zend.com>

    * zend_operators.c:
      Reverted wrong fix for bug #30572.
      Seems the bug was already fixed in other way.
      But reverted patch produced a lot of valgrind errors, because IS_TMP_VAR
      operands don't initialize refcount.

2005-05-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      - Only allow changing return ref agnostic when a script method overrides an
        internal method (found by dmitry)

2005-05-29  Jani Taskinen  <jani.taskinen@sci.fi>

    * Zend.m4:
      - Unify the "configure --help" texts

2005-05-29  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * acinclude.m4:
      forgot to re-add 1.875 as a valid bison version after testing

    * acinclude.m4:
      bison may be installed under a different executable name, e.g.
      
        YACC="bison-1.75" configure ...
      
      removing the check for "bison -y" allows for this
      the check was redundant anyway as the following one filters
      for "GNU Bison" in the --version output

    * Zend.m4
      acinclude.m4:
      avoid code duplication in bison version test

2005-05-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_compile.h:
      - Make zend_do_inheritance ZEND_API

2005-05-27  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug22836.phpt
      tests/bug22836.phpt:
      Fixed bug #22836 (returning reference to uninitialized variable)

2005-05-26  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_execute_API.c
      tests/bug33116.phpt:
      Fixed bug #33116 (crash when assigning class name to global variable in
      __autoload)

    * tests/bug33116.phpt
      tests/bug33116.phpt:
      
      Fixed bug #33116 (crash when assigning class name to global variable in
      __autoload).

    * zend_execute_API.c:
      Fixed bug #33116 (crash when assigning class name to global variable in
      __autoload).

    * zend_API.h
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_language_parser.y
      zend_reflection_api.c
      tests/array_type_hint_001.phpt:
      Added array type hinting. (This patch requires full re-make)

2005-05-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      tests/bug27304.phpt
      tests/bug32981.phpt:
      - Add new tests

    * tests/bug27304.phpt
      tests/bug27304.phpt
      tests/bug32981.phpt
      tests/bug32981.phpt:
      
      - Add new tests

2005-05-22  Ilia Alshanetsky  <ilia@prohost.org>

    * (PHP_5_0)
      zend_highlight.c:
      MFH: Fixed bug #29338 (unencoded spaces get ignored after certain tags).

    * zend_highlight.c:
      Fixed bug #29338 (unencoded spaces get ignored after certain tags).

2005-05-22  Stanislav Malyshev  <stas@zend.com>

    * zend.c
      zend.c:
      fix leak

2005-05-19  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_object_handlers.c:
      Backported fix for bug #30451

    * tests/bug31828.phpt
      tests/bug31828.phpt
      tests/bug32080.phpt
      tests/bug32080.phpt:
      Strict warnings

2005-05-18  Stanislav Malyshev  <stas@zend.com>

    * zend.c
      zend.c:
      fix for #29890 - part 2

    * (PHP_5_0)
      tests/bug29890.phpt:
      test

    * tests/bug29890.phpt
      tests/bug29890.phpt:
      
      test

    * zend_execute_API.c
      zend_execute_API.c:
      fix #29890 - crash when function call fails

    * zend_object_handlers.c:
      revert - seems to be fixed elsewhere

    * zend_object_handlers.c:
      fix #30451  	static properties don't work properly

    * tests/bug29689.phpt
      tests/bug30451.phpt:
      tests

    * tests/bug29689.phpt
      tests/bug29689.phpt
      tests/bug30451.phpt
      tests/bug30451.phpt:
      
      file bug29689.phpt was initially added on branch PHP_5_0.

2005-05-17  Magnus Määttä  <novell@kiruna.se>

    * tests/bug31828.phpt
      tests/bug32080.phpt:
      Fix tests.

2005-05-13  Antony Dovgal  <tony2001@phpclub.net>

    * (PHP_5_0)
      zend.c:
      MFH: fix bug #29975 (memory leaks when set_error_handler() is used inside
      error handler)

    * zend.c:
      fix bug #29975 (memory leaks when set_error_handler() is used inside error
      handler)

2005-05-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Make ReflectionObject::hasProperty() recognize dynamically added props

2005-05-06  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_object_handlers.h:
      typofix :)

2005-05-05  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c
      zend_compile.c
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug31525.phpt:
      Fixed bug #31525 (object reference being dropped. $this getting lost)

    * tests/bug31525.phpt
      tests/bug31525.phpt:
      
      file bug31525.phpt was initially added on branch PHP_5_0.

2005-05-04  Stanislav Malyshev  <stas@zend.com>

    * zend.c:
      fix bug #32924:	prepend does not add file to included files

    * (PHP_5_0)
      zend_execute.c:
      clarify some magic

2005-05-04  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c:
      Fixed bug #30641 (Compile error: error: symbol "zend_error" is used but not
      defined)

    * tests/bug30707.phpt
      tests/bug30707.phpt:
      
      file bug30707.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug30707.phpt:
      Fixed bug #30707 (Segmentation fault on exception in method)

    * (PHP_5_0)
      zend_execute.c:
      ws

    * tests/bug30162.phpt
      tests/bug30162.phpt:
      
      file bug30162.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug30161.phpt:
      Fixed bug #30162 (Catching exception in constructor couses lose of $this)

2005-05-03  Dmitry Stogov  <dmitry@zend.com>

    * tests/unset_cv07.phpt:
      Fixed notice message

2005-05-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      tests/bug32252.phpt:
      - Add test

2005-05-03  Dmitry Stogov  <dmitry@zend.com>

    * zend_object_handlers.c:
      Fixed destruction of zval after returning from __call()

    * zend_builtin_functions.c
      zend_builtin_functions.c
      tests/bug32296.phpt:
      Fixed bug #32296 (get_class_methods output has changed between 5.0.2 and
      5.0.3)
      Now get_class_methods() shows accessible private and protected methods if
      it is called from class scope.

    * tests/bug32296.phpt
      tests/bug32296.phpt:
      
      file bug32296.phpt was initially added on branch PHP_5_0.

2005-05-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c
      zend_object_handlers.c
      zend_object_handlers.h:
      - Extend API to support real existance test without the need to add any new
        functions or change any behavior

    * zend_execute_API.c:
      -  Part 2 of #30126: Enhancement for error message for abstract classes

    * zend_execute_API.c:
      - Part 1 of #30126: Enhancement for error message for abstract classes

2005-04-29  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_object_handlers.c:
      compile fix

    * tests/bug30332.phpt
      tests/bug32852.phpt:
      Make sure E_STRICT is set always

2005-04-29  Dmitry Stogov  <dmitry@zend.com>

    * zend_API.c
      zend_API.c
      tests/bug30332.phpt:
      Fixed bug #30332 (zend.ze1_compatibility_mode isnt fully compatable with
      array_push())

    * tests/bug30332.phpt
      tests/bug30332.phpt:
      
      file bug30332.phpt was initially added on branch PHP_5_0.

    * zend_execute.c
      zend_execute.c
      tests/bug31828.phpt
      tests/bug32080.phpt
      tests/bug32852.phpt:
      Fixed bug #32852 (Crash with singleton and __destruct when
      zend.ze1_compatibility_mode = On)
      Fixed bug #31828 (Crash with zend.ze1_compatibility_mode=On)
      Fixed bug #32080 (segfault when assigning object to itself with
      zend.ze1_compatibility_mode=On)

    * tests/bug31828.phpt
      tests/bug31828.phpt
      tests/bug32080.phpt
      tests/bug32080.phpt
      tests/bug32852.phpt
      tests/bug32852.phpt:
      
      file bug31828.phpt was initially added on branch PHP_5_0.

2005-04-29  Jani Taskinen  <jani.taskinen@sci.fi>

    * tests/bug22836.phpt
      tests/bug27641.phpt:
      - Unify error_reporting setting + make sure E_STRICT is set when wanted

2005-04-28  Dmitry Stogov  <dmitry@zend.com>

    * zend_object_handlers.c
      zend_object_handlers.c
      tests/bug29015.phpt:
      Fixed bug #29015 (Incorrect behavior of member vars(non string
      ones)-numeric mem vars und others)

    * tests/bug29015.phpt
      tests/bug29015.phpt:
      
      file bug29015.phpt was initially added on branch PHP_5_0.

2005-04-27  Dmitry Stogov  <dmitry@zend.com>

    * zend_API.c
      zend_API.h
      zend_object_handlers.c
      zend_object_handlers.h
      tests/bug29210.phpt:
      Fixed bug #29210 (Function: is_callable - no support for private and
      protected classes)

    * (PHP_5_0)
      zend_API.c
      zend_API.h
      zend_object_handlers.c
      zend_object_handlers.h
      tests/bug29210.phpt
      tests/bug29210.phpt:
      Fixed bug #29210 (Function: is_callable - no support for private and
      protected classes).

    * zend_compile.c
      zend_compile.c
      tests/bug29104.phpt
      tests/bug29104.phpt
      tests/bug29104.phpt:
      Fixed bug #29104 (Function declaration in method doesn't work)

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug32833.phpt:
      Fixed bug #32833 (Invalid opcode)

    * tests/bug32674.phpt
      tests/bug32674.phpt:
      
      file bug32674.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug32674.phpt:
      Fixed bug #32674 (exception in iterator causes crash)

2005-04-26  Dmitry Stogov  <dmitry@zend.com>

    * tests/bug30889.phpt
      tests/bug30889.phpt:
      
      file bug30889.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug30889.phpt:
      Fixed bug #30889 (Conflict between __get/__set and ++ operator)

    * tests/bug32429.phpt:
      fix

    * zend_API.c
      zend_API.c
      tests/bug30702.phpt:
      Fixed bug #30702 (cannot initialize class variable from class constant)

    * tests/bug30702.phpt
      tests/bug30702.phpt:
      
      file bug30702.phpt was initially added on branch PHP_5_0.

    * zend_compile.c
      tests/bug32427.phpt:
      Fixed bug #32427 (Interfaces are not allowed 'static' access modifier).

    * zend_builtin_functions.c
      tests/bug32429.phpt:
      Fixed bug #32429 (method_exists() always return TRUE if __call method
      exists)

2005-04-25  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_object_handlers.c:
      Reverting. Let's not introduce major BC breakage like this without a
      good reason.

2005-04-25  Dmitry Stogov  <dmitry@zend.com>

    * tests/bug29944.phpt
      tests/bug29944.phpt:
      
      Fixed bug #29944 (Function defined in switch, crashes).

    * zend_compile.c
      zend_compile.c
      tests/bug29944.phpt:
      Fixed bug #29944 (Function defined in switch, crashes).

2005-04-25  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_hash.c:
      ws

2005-04-25  Dmitry Stogov  <dmitry@zend.com>

    * zend_hash.c:
      Fixed call to estrndup() with invalid length

    * (PHP_5_0)
      zend_hash.c:
      Fixed call to estrndup() with invalid lengt

2005-04-25  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      Correct grammar.

2005-04-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      - Need to copy doc comments correct for properties

2005-04-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug29674.phpt
      tests/bug30161.phpt
      tests/bug30346.phpt:
      - Add new tests

2005-04-21  Jani Taskinen  <jani.taskinen@sci.fi>

    * tests/unset_cv05.phpt:
      Fix test when register_long_arrays is off in your php.ini

2005-04-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_reflection_api.c:
      - Add ReflectionProperty::getDocComment()

2005-04-19  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_compile.c
      zend_exceptions.c:
      No c++ comments in C code

2005-04-18  Dmitry Stogov  <dmitry@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c
      zend_execute.c:
      Fixed memory leak in debug_backtrace()

2005-04-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      - Fix special cases of property_exists()

    * zend_object_handlers.c:
      - Fix logic

2005-04-16  Sara Golemon  <php@alphaweb.net>

    * tests/method_exists.phpt:
      method_exists() regression test

    * zend_builtin_functions.c:
      Fix method_exists(), pce is fetched, but ce is used

2005-04-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      - Fix even though we already know that the function will be renamed

2005-04-15  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fix certain operations to stop relying on presence of read_property and
      write_property handlers. They may be NULL'ed out by certain objects
      pretending to be pure arrays, for example. Do checks first.

2005-04-12  Stanislav Malyshev  <stas@zend.com>

    * zend_ini.c:
      fix memory corruption if one on the on_modify handlers errors out

    * (PHP_5_0)
      zend_ini.c:
      fi memory corruption if one on the on_modify handlers errors out

2005-04-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_operators.c:
      - Fix memory corruption found by rob

    * tests/bug22836.phpt:
      - Ensure we see all errors. No need for () in return

    * zend_builtin_functions.c:
      - Add property_exits()

    * zend_object_handlers.c:
      - No E_ERROR when we just check (where did my 0->1 change go on first
      commit?)

    * zend_object_handlers.c:
      - No E_ERROR when we just check, here visibility simply means there is none

    * zend_object_handlers.c
      zend_object_handlers.h:
      - Simplify getting property info and make it an api function

2005-04-07  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_alloc.c
      zend_alloc.h:
      - Nuke the code duplication

    * zend_alloc.h:
      Fix build when USE_ZEND_ALLOC is 0

2005-04-07  Zeev Suraski  <zeev@zend.com>

    * (PHP_5_0)
      zend_alloc.c
      zend_alloc.h:
      MFH (Fix strdup() bug when USE_ZEND_ALLOC was disabled)

    * zend_alloc.c
      zend_alloc.h:
      Fix strdup() bug when USE_ZEND_ALLOC is disabled

2005-04-05  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      - Just return FAILURE & allow NULL without emmidiate error

2005-04-04  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c:
      MF50: fix backtraces - non-Zend classes have names too

    * (PHP_5_0)
      zend_builtin_functions.c:
      fix backtraces - non-Zend classes have names too

2005-04-03  Jani Taskinen  <jani.taskinen@sci.fi>

    * (PHP_5_0)
      zend_execute_API.c:
      MFH: - Fixed bug #28839 (SIGSEGV in interactive mode (php -a)).
      MFH:   (kameshj at fastmail dot fm)

2005-03-31  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_API.c:
      - MFH: internal_function->fn_flags is not initialized at this point

2005-03-26  Jani Taskinen  <jani.taskinen@sci.fi>

    * zend_execute_API.c:
      - Fixed bug #28839 (SIGSEGV in interactive mode (php -a))
        (kameshj at fastmail dot fm)

2005-03-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_vm_execute.h:
      - Second part of removing temp solution

    * zend_vm_def.h:
      - Remove potential bad solution for now

2005-03-23  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_execute.c:
      Consolidate: call _get_zval_ptr_var() for IS_VAR case in
      _get_zval_ptr().

2005-03-21  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend_execute.c:
      - Fix memset() bug (Joe Orton)

2005-03-21  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_API.c:
      internal_function->fn_flags is not initialized at this point

2005-03-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug31102.phpt:
      - Added missing description (thanks jani)

    * tests/bug31102.phpt:
      - Add new test

2005-03-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_object_handlers.c:
      - More fixes to gracefully act on exception thrown in overload methods

    * zend_object_handlers.c:
      - Fix #31185

    * zend_execute_API.c:
      - Fix all incarnations of bug #30266

2005-03-19  Andi Gutmans  <andi@zend.com>

    * zend_interfaces.c
      zend_interfaces.h:
      - Fix typos

2005-03-16  Wez Furlong  <wez.php@thebrainroom.net>

    * (PHP_5_0)
      zend_API.c:
      MFH: don't call rshutdown twice for dl()'d modules.

    * zend_API.c:
      don't call rshutdown twice for dl()'d modules.
      Spotted by Andrei.

2005-03-15  Wez Furlong  <wez.php@thebrainroom.net>

    * zend.c
      zend_API.c
      zend_modules.h:
      fix shutdown so that dl()'d modules are unloaded after all the dtors have
      been called.

2005-03-14  Zeev Suraski  <zeev@zend.com>

    * zend_ini.c:
      Clarify logic

2005-03-14  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c:
      ws

2005-03-13  Stanislav Malyshev  <stas@zend.com>

    * zend_stream.c
      zend_stream.c:
      Do not convert ZEND_HANDLE_FP to ZEND_HANDLE_STREAM but allow using
      reader/closer
      on it

2005-03-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      - More exact signatures (even though complete correct not possible atm)

2005-03-13  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c:
      Fix get_extension_funcs() - extension names are now lowercased, so should
      be function arguments.

2005-03-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      - Actually this is a much better error decription

    * zend_execute_API.c
      tests/bug32290.phpt
      tests/bug32290.phpt:
      - Bugfix #32290

2005-03-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_vm_def.h
      zend_vm_execute.h:
      - If an exception is pending we don't bail out but show the unhandled
      exception

2005-03-11  Anantha Kesari H Y  <hyanantha@novell.com>

    * (PHP_5_0)
      acconfig.h:
      NetWare LibC's sys/types.h does not include sys/select.h implicitly as it
      is the case with Linux LibC

2005-03-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug32252.phpt:
      - Add new test

    * tests/bug27145.phpt
      tests/bug27145.phpt:
      - Irrelevant

    * zend_object_handlers.c:
      - Don't touch refcount/is_ref

2005-03-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug28442.phpt
      tests/bug28442.phpt:
      
      - Bugfix #28442

    * zend_compile.c:
      - Bugfix #28442

2005-03-10  Anantha Kesari H Y  <hyanantha@novell.com>

    * (PHP_5_0)
      acconfig.h:
      Autoconf based build can be used for NetWare

    * (PHP_5_0)
      zend.h:
      NetWare can make use of ./configure generated zend_config.h

    * (PHP_5_0)
      Zend.m4:
      This patch is needed for cross compilation to go through

2005-03-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_vm_execute.h:
      - #31562 2nd part

    * zend_vm_def.h:
      - Fix #31562

2005-03-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.h
      zend_compile.c
      zend_interfaces.c
      zend_interfaces.h:
      - New Interface Serializeable
      - Change signature of unserialize() callback to ease inheritance and
        support code reuse of handlers

    * tests/bug32226.phpt
      tests/bug32226.phpt:
      
      - Add updated description

    * zend_builtin_functions.c
      tests/bug32226.phpt:
      - Fix #32226

2005-03-07  Zeev Suraski  <zeev@zend.com>

    * zend_language_scanner.l
      zend_language_scanner.l:
      Revert // </script> patch

2005-03-06  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Fix by Tim

2005-03-06  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_compile.c
      zend_compile.c:
      Fixed compile warning (bug #32046)

    * zend_mm.c:
      Fix compile warning (bug #32047)

2005-03-01  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      - Support statuc methods/functions

2005-03-01  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      zend_language_scanner.l:
      MFH: - Fixed bug #31672 (</script> not considered closing tag if
      MFH:   preceded by one-line comment)

    * zend_language_scanner.l:
      Fix the fix for one line comments with <script..> </script> tags

2005-02-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      - Add support for methods dynamically added through object handlers

2005-02-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_object_handlers.c:
      - If silence if wanted we do not error out

    * zend_reflection_api.c:
      - Add two new methods
      - Fix signature, no need to cast it

    * zend_API.h:
      - These must be initailized

    * zend_builtin_functions.c:
      - Update method_exists to new handlers and allow first parameter as string

2005-02-27  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * Zend.m4:
      - Cache the version check results

2005-02-24  Andi Gutmans  <andi@zend.com>

    * zend_language_scanner.l:
      - Make one line comments work the same with <script ...> </script> as with
      - other tags. This will break scripts that have whitespace at the end
      - of the closing tag </script    > but this is barely used as it is
      - and I doubt ppl used whitespace. (patch by Jani)

    * zend_objects_API.h:
      - This part of the patch was right

2005-02-24  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      Fixed bug in ZEND_POST_INC/ZEND_POST_DEC handlers.
      These opcodes assume IS_TMP_VAR as result.

2005-02-24  Andi Gutmans  <andi@zend.com>

    * zend_modules.h:
      - Need zend_Compile.h for struct _zend_arg_info  definiton (thanks to Joe
      Orton)

    * zend_objects.c
      zend_objects.h
      zend_objects_API.h:
      - Revert following patch until we decide what is the right way to handle
      - this:
       - Fix signatures they are all meant to be able to deal with any type in
      any
          object storage (though we are still missing several parts)

2005-02-23  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_reflection_api.c:
      - MFH: fixed bug #32076 (ReflectionMethod :: isDestructor() always return
        true).

    * zend_reflection_api.c:
      - Fixed bug #32076 (ReflectionMethod :: isDestructor() always return true)
        (Patch by Antony Dogval)

2005-02-23  Stanislav Malyshev  <stas@zend.com>

    * zend.h
      zend_compile.c:
      Custom object serializer infrastructure

2005-02-23  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * Zend.m4:
      Hack the planet

2005-02-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      - Allow to convert Traversable into Aggregate

2005-02-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects_API.c:
      - We cannot provide this fallback becuase it requires zend_object ptr's.

2005-02-22  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * Zend.m4:
      Fix cross-compile

    * acconfig.h:
      Fix build (it was #ifNdef NETWARE..)

2005-02-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c
      zend_objects.h
      zend_objects_API.h:
      - Fix signatures they are all meant to be able to deal with any type in any
        object storage (though we are still missing several parts)

    * zend_objects_API.c:
      - Force calling of dtors unless otherwise specified (fixes several
      __destruct bugs)

2005-02-22  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend.h:
      NetWare can include autoconf generated config headers

    * acconfig.h:
      NetWare can make use of the configure script generated header file.

2005-02-21  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * Makefile.am:
      - Add missing entry.

2005-02-20  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c:
      Fixed possible memory corruption

2005-02-19  Rui Hirokawa  <rui_hirokawa@ybb.ne.jp>

    * (PHP_5_0)
      zend_language_scanner.l:
      MFH: fixed #31987 zend-multibyte in ZTS.

    * zend_language_scanner.l:
      fixed #31987 zend-multibyte in ZTS.

2005-02-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      - A little optimization to prevent problems when trying to reimplement an
        interface inherited from an interfaces that was just implemented......

    * zend_API.c:
      - No C++ ruleZ here

    * zend_API.c:
      - Actually we must do this in two steps: 1st resize the table and set all
        interfaces, 2nd implement the interfaces

    * zend_API.c:
      - Incrementation is done elsewhere

    * zend_API.c:
      - Fix windows build (funny MS compiler)

2005-02-17  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      Zend.m4
      zend_strtod.c:
      MFH: - Compile fix for systems without int32_t typedef

    * Zend.m4
      zend_strtod.c:
      - Compile fix for systems without int32_t typedef

2005-02-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c
      zend_reflection_api.c:
      - Be more gracious in reflection API

    * zend_language_scanner.l:
      - Fix doc comment handling

2005-02-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      - Bugfix #30682 (autoconversion from false/true to 0/1 missing in case of
        static property default value)

2005-02-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y:
      - Cleanup foreach handling

2005-02-10  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_strtod.c
      zend_strtod.c:
      - Fixed bug #31920 (zend_strtod.c error: conflicting types for 'int8_t')

2005-02-10  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug30407.phpt:
      Fixed bug #30407 (Strange behaviour of default arguments)

2005-02-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c:
      Fixed bug introduced with foreach() optimization patch

    * zend_compile.c:
      Fixed FE_RESET/FE_FETCH bug.
      Now FE_RESET instruction takes jump-address from itself, not from the
      following FE_FETCH instruction.

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      foreash($a as $key => $val) optimization
      Removed temorary array creation on each iteration.

2005-02-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y:
      - Remove part of the cleanup which causes a problem with unnormal code
        like tests/lang/040.phpt

2005-02-06  Zeev Suraski  <zeev@zend.com>

    * (PHP_5_0)
      zend_ini_scanner.l:
      Correct fix for #28803

    * zend_ini_scanner.l:
      Correct fix for #28804

2005-02-05  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h:
      - Cleanup foreach statement

2005-02-04  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * zend_API.c
      zend_API.h:
      added some missing zend_[declare|update]_property_...() convenience
      functions for bool, double and binary safe string data

2005-02-03  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      zend_ini_scanner.l:
      MFH: Fixed bug #28804 (ini-file section parsing pattern is buggy).

    * zend_ini_scanner.l:
      - Fixed bug #28804 (ini-file section parsing pattern is buggy).

    * zend_ini_scanner.l
      zend_ini_scanner.l:
      ws fix

2005-02-02  Stanislav Malyshev  <stas@zend.com>

    * zend_execute_API.c:
      Fix #31720    Invalid object callbacks not caught in array_walk() (patch
      from Antony Dovgal)

    * tests/bug31720.phpt:
      test for Bug #31720

    * tests/bug31720.phpt
      tests/bug31720.phpt:
      
      file bug31720.phpt was initially added on branch PHP_5_0.

    * (PHP_5_0)
      zend_execute_API.c:
      Fix #31720  	Invalid object callbacks not caught in array_walk() (patch
      from Antony Dovgal)

2005-02-02  Dmitry Stogov  <dmitry@zend.com>

    * zend.h
      zend.h
      zend_object_handlers.c
      zend_object_handlers.c
      tests/bug31683.phpt:
      Fixed bugs #29767 and #31683 (__get and __set methods must not modify
      property name).

    * tests/bug31683.phpt
      tests/bug31683.phpt:
      
      file bug31683.phpt was initially added on branch PHP_5_0.

2005-02-01  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c
      zend_builtin_functions.c:
      Fix debug_trace with eval (patch from Antony Dovgal)

    * tests/bug_debug_backtrace.phpt:
      test for eval debug_backtrace bug

    * tests/bug_debug_backtrace.phpt
      tests/bug_debug_backtrace.phpt:
      
      file bug_debug_backtrace.phpt was initially added on branch PHP_5_0.

2005-01-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Add ReclectionClass:hasProperty(), ReflectionClass::hasConstant()
        to complete api (johannes@php.net)

2005-01-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      - Fix severity (found by johannes)

2005-01-25  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend.h:
      New versions of glibc support a RTLD_DEEPBIND flag to dlopen.  The
      effect of this flag when loading a "foo.so" with undefined symbols is
      that the search that symbol starts at foo.so and its dependencies
      *before* the loading process' global symbol table.
      
      This is an effective workaround for symbol namespace collisions between
      various modules and the libraries on which they depend (where fixing the
      respective modules or libraries is not possible e.g. due to API
      constraints).
      
      (By: Joe Orton)

2005-01-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_execute.c
      zend_interfaces.c
      tests/bug26229.phpt:
      - MFH #26229 (getIterator() segfaults when it returns arrays or scalars)

    * zend_interfaces.c
      zend_vm_def.h
      zend_vm_execute.h
      tests/bug26229.phpt:
      - Bugfix #26229 (getIterator() segfaults when it returns arrays or scalars)

    * Makefile.frag:
      - Fix dependency

    * zend_vm_def.h
      zend_vm_execute.h:
      - Use correct freeing (thx Dmitry)

2005-01-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_vm_def.h
      zend_vm_execute.h
      tests/bug30725.phpt:
      - Second and last part of #30725 fix

    * zend_interfaces.c:
      - Allow getIterator() to fail

    * tests/bug30725.phpt:
      
      - Add new test

2005-01-22  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      Zend.m4
      configure.in
      zend_strtod.c:
      MFH: Compile fix for systems without uint32_t typedef

    * Zend.m4
      configure.in
      zend_strtod.c:
      - Compile fix for systems without uint32_t typedef

2005-01-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h
      zend_reflection_api.c:
      - Fix #31651 (ReflectionClass::getDefaultProperties segfaults with arrays.)

2005-01-22  Andi Gutmans  <andi@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute.h:
      - Two new API calls for Derick (retreive CV name and value) by Dmitry

2005-01-20  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend.h
      zend_constants.c:
      - Revert the weird change of ZEND_STRS() macro and use the correct
        ZEND_STRL() macro.

2005-01-19  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_object_handlers.c:
      - Fixed bug #29183 (Undefined symbol zend_check_private with Solaris CC)

2005-01-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_ini_parser.y:
      - Fix memleak

2005-01-18  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c:
      Fixed patch for bug #31478 (SegFault/Memory Leak with empty())

    * zend_execute.c:
      Fixed bug #28444 (Cannot access undefined property for object with
      overloaded property access).

    * (PHP_5_0)
      zend_execute.c:
      Fixed bug #28444 (Cannot access undefined property for object with
      overloaded property access). (Dmitry)

2005-01-18  Ilia Alshanetsky  <ilia@prohost.org>

    * (PHP_5_0)
      zend_operators.h:
      MFH: Fixed bug #30726 (-.1 like numbers are not being handled correctly).

    * zend_operators.h:
      Fixed bug #30726 (-.1 like numbers are not being handled correctly).

2005-01-17  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      zend_language_scanner.l:
      MFH: - Fixed bug #31444 (Memory leak in zend_language_scanner.c)

    * zend_language_scanner.l:
      - Fixed bug #31444 (Memory leak in zend_language_scanner.c)

2005-01-15  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend_API.c:
      - Fix WS

    * (PHP_5_0)
      zend_API.c:
      - Change to using DL_UNLOAD macro.

    * zend_API.c:
      - Unload on MAC OS X (shouldn't be a reason not to)

2005-01-14  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug31098.phpt:
      Restore behavior of $str["str"]. (Now $str["str"] is equivalent to $str[0]
      again)

    * (PHP_5_0)
      tests/bug31098.phpt:
      Path -> pattern

    * (PHP_5_0)
      zend_execute.c
      tests/bug31098.phpt:
      Revert to old behavior of $str["str"]. ($str["str"] is equivalent of
      $str[0])

2005-01-13  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      zend_execute.c:
      Additional fix for fix of bug #29883

2005-01-12  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_opcodes.h
      tests/bug31098.phpt
      tests/bug31098.phpt:
      Fixed bug #31098 (isset false positive)

2005-01-11  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * (PHP_5_0)
      zend_execute.c
      tests/bug31098.phpt:
      - MFH: fix for bug #31098.

    * tests/bug31098.phpt
      tests/bug31436.phpt:
      
      - Test renaming

    * zend_vm_execute.h
      tests/bug31436.phpt:
      - Fix bug #31436 (isset() incorrectly returns true in dereference of a
      wrong type)

    * zend_compile.c:
      - Fix bug #31478 (segfault with empty())

2005-01-10  Rasmus Lerdorf  <rasmus@lerdorf.com>

    * zend.h
      zend_API.c:
      Fix OSX DL_UNLOAD macro and actually use it to make shared extensions
      work on OSX.

2005-01-10  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * header
      zend_arg_defs.c
      zend_strtod.c
      zend_vm_def.h
      zend_vm_execute.h
      zend_vm_gen.php
      zend_vm_opcodes.h:
      - Added missing header sections.

    * acinclude.m4
      configure.in:
      - Added AC_ZEND_C_BIGENDIAN macro (as requested by Andi)

2005-01-09  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      zend.h:
      MFH: - Fix outside-source-tree builds. Always include generated header
      files
             with #include <some_header.h> to make sure the correct file is
      used.

    * zend.h:
      - Fix outside-source-tree builds. Always include generated header files
        with #include <some_header.h> to make sure the correct file is used.

    * zend.c:
      MFB: - Rationalize code a bit

2005-01-03  Stanislav Malyshev  <stas@zend.com>

    * (PHP_5_0)
      zend_language_scanner.l:
      MFH:
      Fix the following nasty bug:
      - if compile bails out from the middle of compiling, current_buffer is not
      restored
      - if current_buffer is not null, yy_switch_to_buffer will do: *yy_c_buf_p
      = yy_hold_char; on
      the next request
      - which would lead to memory corruption on next request

    * zend_language_scanner.l:
      Fix the following nasty bug:
      - if compile bails out from the middle of compiling, current_buffer is not
      restored
      - if current_buffer is not null, yy_switch_to_buffer will do: *yy_c_buf_p
      = yy_hold_char; on
      the next request
      - which would lead to memory corruption on next request

2005-01-02  Ilia Alshanetsky  <ilia@prohost.org>

    * (PHP_5_0)
      zend_highlight.c:
      MFH: Fixed bug #31371 (highlight_file() trims new line after heredoc).

    * zend_highlight.c:
      Fixed bug #31371 (highlight_file() trims new line after heredoc).

2004-12-30  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      zend_compile.c
      zend_highlight.c
      zend_indent.c
      zend_ini_scanner.l
      zend_language_scanner.l:
      MFH: - Fixed bug #28930 (PHP sources pick wrong header files generated by
      bison).

    * zend_compile.c
      zend_highlight.c
      zend_indent.c
      zend_ini_scanner.l
      zend_language_scanner.l:
      - Fixed bug #28930 (PHP sources pick wrong header files generated by bison)

    * Zend.m4
      acinclude.m4:
      MFB_4_3: Quote macro names in AC_DEFUN()

2004-12-27  Zeev Suraski  <zeev@zend.com>

    * zend_builtin_functions.c:
      MFB

    * (PHP_5_0)
      zend_builtin_functions.c:
      Fix desc

2004-12-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_reflection_api.c:
      - MFH: Need to unmangle the class name here

    * zend_reflection_api.c:
      - Need to unmangle the class name here

2004-12-27  Zeev Suraski  <zeev@zend.com>

    * (PHP_5_0)
      zend_exceptions.c:
      Add descriptions

2004-12-27  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      tests/bug22836.phpt
      tests/bug22836.phpt
      tests/unset_cv01.phpt
      tests/unset_cv02.phpt
      tests/unset_cv03.phpt
      tests/unset_cv04.phpt
      tests/unset_cv06.phpt
      tests/unset_cv08.phpt
      tests/unset_cv09.phpt
      tests/unset_cv10.phpt:
      "Undefined variable:  %s" noticies were fixed to use one space

2004-12-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - More proto/error message fixes

    * zend_reflection_api.c:
      - Small fixlet (by Tony)

2004-12-24  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_def.h
      zend_vm_execute.h:
      New sarbage collector's bug was fixed (the behavior should be the same as
      in PHP_5_0)

    * zend_execute.c
      tests/unset_cv01.phpt
      tests/unset_cv02.phpt
      tests/unset_cv03.phpt
      tests/unset_cv04.phpt
      tests/unset_cv06.phpt
      tests/unset_cv08.phpt
      tests/unset_cv09.phpt
      tests/unset_cv10.phpt:
      "Undefined variable:  %s" noticies were fixed to be compatible with PHP_5_0

2004-12-21  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      zend_strtod.c:
      MFH: - Use correct header files (in c99 compliant way). uint32_t is
      preferred.

    * zend_strtod.c:
      - Use correct header files (in c99 compliant way). uint32_t is preferred.

2004-12-20  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_strtod.c:
      Better fix for endian compile problems.

2004-12-17  Andi Gutmans  <andi@zend.com>

    * zend_object_handlers.c:
      - Fixed Bug #30562  	Segmentation fault with __call()

2004-12-17  Derick Rethans  <php@derickrethans.nl>

    * zend_strtod.c
      zend_strtod.c:
      - MF43: Fixed strtod for Irix and some other strange platform

2004-12-16  Derick Rethans  <php@derickrethans.nl>

    * zend_strtod.c
      zend_strtod.c:
      - MF43: Make it compile on HPUX on Itanium 2

    * zend_strtod.c
      zend_strtod.c:
      - MF43: Fixed bug #31107 (strtod on solaris9/intel)

2004-12-16  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * (PHP_5_0)
      ChangeLog:
      - MFH: Fix typo (avaliable -> available). (bug #28725)

    * ChangeLog:
      - Fix typo (avaliable -> available). (bug #28725)

2004-12-16  Derick Rethans  <php@derickrethans.nl>

    * zend_strtod.c:
      - MF43: Fixed bug #31110 and #31111 (Zend/zend_strtod.c problems)

    * (PHP_5_0)
      zend_strtod.c:
      - Fixed bug #31110 and #31111 (Zend/zend_strtod.c problems)

2004-12-15  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - 5.0.4-dev

    * (PHP_5_0)
      zend.h:
      - Redo 5.0.3

    * (PHP_5_0)
      zend.h:
      - Back to -dev

    * (PHP_5_0)
      zend.h:
      - Roll PHP 5.0.3

2004-12-14  Derick Rethans  <php@derickrethans.nl>

    * zend_strtod.c
      zend_strtod.c:
      - MFH: Fixed compile error related to bug #28605.

2004-12-13  Derick Rethans  <php@derickrethans.nl>

    * zend_operators.c:
      - Added "G" modifier to ini setting number format.

2004-12-10  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - Back to -dev

    * (PHP_5_0)
      zend.h:
      - 5.0.3RC2

2004-12-07  Dmitry Stogov  <dmitry@zend.com>

    * zend_exceptions.c
      zend_exceptions.c:
      Fixed bug #30904 (segfault when recording soapclient into session).

2004-12-06  Stanislav Malyshev  <stas@zend.com>

    * tests/bug30998.phpt:
      add test

    * zend.c
      zend.c:
      port fix for #30998: Crash when user error handler returns false on amd64

2004-12-06  Dmitry Stogov  <dmitry@zend.com>

    * zend_compile.c
      zend_compile.c
      tests/bug30922.phpt:
      Fixed bug #30922 (reflective functions crash PHP when interfaces extend
      themselves)

    * tests/bug30922.phpt
      tests/bug30922.phpt:
      
      file bug30922.phpt was initially added on branch PHP_5_0.

2004-12-06  Stanislav Malyshev  <stas@zend.com>

    * (PHP_5_0)
      zend_builtin_functions.c:
      if fetch called not from PHP function, ptr can be NULL

2004-12-01  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_strtod.c:
      MFB: Removed extra space that causes problems for some compilers.

    * (PHP_5_0)
      zend_strtod.c:
      Removed extra space that causes problems for some compilers.

2004-12-01  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_strtod.c:
      - revert unwanted change

    * zend_strtod.c
      zend_strtod.c:
      - Fixed MacOSX compilation  (Patch by Christian)

    * (PHP_5_0)
      zend.h:
      - And in Zend/ too.

2004-12-01  Dmitry Stogov  <dmitry@zend.com>

    * (PHP_5_0)
      zend_execute.c
      zend_vm_def.h
      zend_vm_execute.h
      tests/bug29883.phpt
      tests/bug29883.phpt
      tests/bug29883.phpt:
      Fixed bug #29883 (isset gives invalid values on strings).

2004-11-30  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - Go with 5.0.3RC1

2004-11-29  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_operators.c:
      - MF43: Revert Joe's work around a bug in GCC patch as it breaks too many
      things.

    * zend_operators.c:
      - MFH: Revert Joe's work around a bug in GCC patch as it breaks too many
      things.

2004-11-25  Zeev Suraski  <zeev@zend.com>

    * (PHP_5_0)
      zend_execute.c
      zend_execute_API.c
      zend_extensions.h
      zend_object_handlers.c
      zend_object_handlers.h:
      Reverting get_method() signature change

2004-11-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Fix Bug #30856 (ReflectionClass::getStaticProperties segfaults)

    * tests/bug30856.phpt:
      
      - Add new test

2004-11-17  Stanislav Malyshev  <stas@zend.com>

    * (PHP_5_0)
      zend_execute_API.c:
      fix #30543

    * zend_execute_API.c:
      fix crash

2004-11-16  Derick Rethans  <php@derickrethans.nl>

    * zend_strtod.c
      zend_strtod.c:
      - Make this compile for the Mac again

2004-11-15  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_strtod.c:
      - MFH: Fixed bug #30779 (Compile of Zend/zend_strtod.c fails on Sparc)

    * zend_strtod.c:
      - Fixed bug #30779 (Compile of Zend/zend_strtod.c fails on Sparc)

2004-11-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_reflection_api.c:
      MFH #30783 Apache crash when using ReflectionFunction::getStaticVariables()
      MFH proto fixes

    * zend_reflection_api.c:
      - Bugix #30783: Apache crash when using
      ReflectionFunction::getStaticVariables()

2004-11-09  Andrei Zmievski  <andreiz@gravitonic.com>

    * zend_ini_parser.y:
      Revert inadvertent commit.

    * zend_ini_parser.y:
      .dylib extension are Mach-O shared libraries that meant for linking
      against. Loadable modules (aka bundles) can have any extension, so we
      should probably stick with .so
      
      http://fink.sourceforge.net/doc/porting/shared.php?phpLang=en#lib-and-mod

2004-11-05  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_execute_API.c:
      - Fix for bug #30367, #30490 and possibly #30011.

2004-11-04  Edin Kadribasic  <edink@emini.dk>

    * Zend.dsp
      ZendTS.dsp:
      Added zend_strtod.* to the build

    * zend_strtod.c
      zend_strtod.h:
      Make zend_strtod compile on windows

2004-11-04  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * (PHP_5_0)
      Makefile.am:
      - MFH: Add entry for zend_strtod.c in belief that this is still active.

    * Makefile.am:
      - Add entry for zend_strtod.c in belief that this is still active.

2004-11-03  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * Zend.m4:
      - Don't show grep outputs

2004-11-03  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_execute_API.c
      zend_globals.h
      zend_ini.c
      zend_language_scanner.l
      zend_operators.c
      zend_operators.h
      zend_strtod.c
      zend_strtod.h:
      - MFH: Fixed bug #30630: Added a BSD based strtod function that is
        locale-independent.

    * zend_execute_API.c
      zend_globals.h
      zend_ini.c
      zend_language_scanner.l
      zend_operators.c
      zend_operators.h
      zend_strtod.c
      zend_strtod.h:
      - Fixed bug #30630: Added a BSD based strtod function that is
        locale-independent.

2004-11-03  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * Zend.m4
      zend.h
      zend_execute.c:
      - Checks for Darwin'ish systems that uses Mach-O, which apparently doesn't
        support weak symbol aliasing at this time.

2004-11-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Trying to invoke function not methot here

    * zend_reflection_api.c:
      - Fix invokeargs() with static methods

2004-11-03  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_def.h
      zend_vm_execute.h:
      Fixed "isset() and the new VM" bug.

2004-11-02  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * (PHP_5_0)
      zend_API.c:
      MFH: Patch by Joe Orton <jorton@redhat.com>.

    * zend_API.c:
      Patch by Joe Orton <jorton@redhat.com>.

2004-10-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Add ReflectionFunction::invokeArgs(array)
      - Add ReflectionMethod::invokeArgs(obj, array)

2004-10-31  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      Invokation -> Invocation

2004-10-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.h:
      Bump version (as discussed with Andi)

    * (PHP_5_0)
      zend_execute.c:
      - Fix (readd function name which got lost during earlier comit)

    * zend_reflection_api.c:
      - Be consistent and use names as keys (found by johannes)

    * zend_extensions.h
      zend_modules.h:
      - Bump API version

    * (PHP_5_0)
      zend_extensions.h
      zend_modules.h:
      Bump api after latest changes

    * (PHP_5_0)
      zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h:
      MFH change zend_object_handlers->get_method()

    * zend_execute_API.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_vm_def.h
      zend_vm_execute.h:
      - Change zend_object_handlers->get_method() to allow aggregation for
      internal classes

    * Makefile.frag:
      - New architecture needs one more dependency

    * zend_exceptions.c
      zend_reflection_api.c:
      - Fix protos

2004-10-29  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - For Ilia:
      - MFH: Fixed bug #30572 (crash when comparing SimpleXML attribute to a
      boolean).
      - Hope this works well. I will MFH tomorrow if no one complains.

2004-10-28  Dmitry Stogov  <dmitry@zend.com>

    * README.ZEND_VM
      zend_vm_gen.php:
      --without-lines changed to --with-lines

2004-10-28  Andi Gutmans  <andi@zend.com>

    * zend_vm_execute.skl
      zend_vm_gen.php:
      - Fix typo

2004-10-27  Andi Gutmans  <andi@zend.com>

    * zend_vm_opcodes.h:
      - Oops missed this one

    * zend_operators.c:
      - Revert   Fixed bug #30228 (crash when comparing SimpleXML attribute to a
      boolean).
      - Need to discuss where the real problem is.

    * README.ZEND_VM:
      - Tiny fixes

    * README.ZEND_VM
      zend_compile.h
      zend_vm_execute.h
      zend_vm_gen.php:
      - Improve comments, docs, code...

2004-10-26  Andi Gutmans  <andi@zend.com>

    * zend_builtin_functions.c:
      - Patch from Andrey Hristov:
      I have cooked a small patch which allows is_subclass_of() the accept
      not only an object as first parameter but a string as well. When string
      is passed the function checks whether the class specified is subclass of
      the second parameter
      class a{}
      class b{} extends a{}
      is_subclass_of("a", "a") //false
      is_subclass_of("b", "a") //true
      currently only objects are allowed as first parameter

2004-10-26  Ilia Alshanetsky  <ilia@prohost.org>

    * (PHP_5_0)
      zend_operators.c:
      MFH: Fixed bug #30572 (crash when comparing SimpleXML attribute to a
      boolean).

    * zend_operators.c:
      Fixed bug #30228 (crash when comparing SimpleXML attribute to a boolean).

2004-10-23  Andi Gutmans  <andi@zend.com>

    * zend_vm_execute.h:
      - Add missing file

2004-10-22  Andi Gutmans  <andi@zend.com>

    * zend_vm_handlers.h
      zend_vm_spec.h:
      - Nuke another two files

    * Makefile.frag
      zend_execute.c
      zend_vm.h
      zend_vm_def.h
      zend_vm_execute.skl
      zend_vm_gen.php:
      - Commit new VM
      - Old one is tagged as PRE_NEW_VM_GEN_PATCH
      - Still doing work so more commits to come. Don't complain (yet) :)

    * (PRE_NEW_VM_GEN_PATCH)
      zend_execute.c:
      - Fix crash (MFB PHP5_0)

2004-10-21  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend_execute.c:
      - Fix bug #30395 (Apache Child Segmentation fault in specific PHP-Code)

2004-10-20  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - If object handles are equal then save the comparison of properties in
      - the == operator.

2004-10-18  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend_modules.h:
      including zend_compile.h for NetWare as NetWare uses MetroWerks Code
      warrior compiler which does not allow declarations of following kind
      before defining the types.
      extern struct _zend_arg_info first_arg_force_ref[2];

2004-10-16  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - One more test (WS)

    * zend_compile.c:
      - WS fix to test commit

2004-10-16  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend_compile.c
      zend_compile.c:
      Fix for 30457

2004-10-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      - Allow to omit object/classname in get_parent_class() which makes it
        compatible with the signature and behavior of get_class()

2004-10-13  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Don't allow access modifiers in interfaces. Explicitly stating public
      - should also be disallowed but we don't have a way to detect it today.

2004-10-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      Bug #30381 Strange results with get_class_vars()

    * (PHP_5_0)
      zend_builtin_functions.c:
      MFH Fix visibility of get_class_vars() and get_class_methods()

    * zend_builtin_functions.c:
      - Fix visibility in get_class_vars() and get_class_methods()

    * zend_builtin_functions.c:
      - Fix set_exception_handler

2004-10-10  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * .cvsignore
      tests/.cvsignore:
      Add *.gcda and *.gcno (from gcc -fprofile-{use|generate}) to .cvsignore.

2004-10-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_compile.h
      zend_vm_handlers.h:
      - Revert automatic pass arg_info

2004-10-08  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fix BC break with default in switch() having to be at the end.

2004-10-08  Anantha Kesari H Y  <hyanantha@novell.com>

    * acconfig.h
      zend_config.nw.h:
      explicitly including sys/select.h as NetWare LibC sys/types.h does not
      include sys/select.h implicitly as other LibC

2004-10-06  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Fix Bug #30344

2004-10-05  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_compile.h
      zend_vm_handlers.h:
      - Add arginfo ZEND_ARG_SEND_AUTOMATIC which lets the compiler automatically
        determine whether pass by ref is possible or pass by value is needed.

2004-10-05  Dmitry Stogov  <dmitry@zend.com>

    * tests/unset_cv06.phpt
      tests/unset_cv07.phpt
      tests/unset_cv07.phpt:
      Test files are fixed.

    * zend_execute.c
      zend_vm_handlers.h
      tests/unset_cv11.phpt:
      Fixed unset() bug that was introduced with CV optimization patch

    * zend_execute_API.c
      zend_vm_handlers.h
      tests/unset.inc
      tests/unset_cv01.phpt
      tests/unset_cv02.phpt
      tests/unset_cv03.phpt
      tests/unset_cv04.phpt
      tests/unset_cv05.phpt
      tests/unset_cv06.phpt
      tests/unset_cv07.phpt
      tests/unset_cv08.phpt
      tests/unset_cv09.phpt
      tests/unset_cv10.phpt:
      Added test cases for CV optimization patch

2004-10-04  Andi Gutmans  <andi@zend.com>

    * zend_API.h
      zend_execute_API.c:
      - Rename delete_global_variable() to zend_delete_global_variable()

    * Zend.m4
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute_API.c
      zend_language_parser.y
      zend_opcode.c
      zend_vm.h
      zend_vm_handlers.h
      zend_vm_spec.h:
      - Commit the variable fetch optimization.
      - Extensions which delete global variables need to use new special
      function
      - delete_global_variable() (I'm about to rename it) to remove them.
      - Will post to internals@ or via commit messages if there's anything else.

2004-10-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      - Bugfix #27798

    * tests/bug27798.phpt:
      
      - Add new test

2004-10-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      tests/bug28444.phpt
      tests/bug29368.phpt:
      - Add new tests

    * tests/bug28444.phpt
      tests/bug29368.phpt:
      
      - Add new test

2004-10-01  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * Makefile.frag:
      - Add makefile fragment which simplifies working on the executer

2004-09-30  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - Small improvement to DVAL_TO_ZVAL macro

2004-09-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      - MFB (synch correctly not only for one problem)

    * zend_API.c:
      - Refix the fix

2004-09-29  Andi Gutmans  <andi@zend.com>

    * bench.php
      tests/bench.php:
      - Move bench.php to Zend/

2004-09-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h
      zend_object_handlers.c
      zend_objects.c:
      Simplify/Optmize magic method calls (__get/__set/__call/__clone/__destruct)

2004-09-28  Andi Gutmans  <andi@zend.com>

    * zend_execute_API.c:
      - Return the warning until we check if we can change the type of str.len

2004-09-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c
      zend_reflection_api.h:
      - publish reflection_class_factory() as zend_reflection_class_factory()

2004-09-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_reflection_api.c:
      MFH fix several property handling issues

    * zend_reflection_api.c:
      - Make internally used properties read-only and fix default properties

    * zend_exceptions.c:
      - Fix memeleak

    * zend_reflection_api.c:
      - Declare properties

2004-09-27  Andi Gutmans  <andi@zend.com>

    * README.ZEND_VM:
      - Document zend_vm_use_old_executor() for Derick.

2004-09-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Fix Reflection_Class to ReflectionClass in docu/messages

    * zend_execute_API.c:
      - Fix warning

    * zend_compile.c
      zend_stream.c:
      - Fix warning

    * zend_builtin_functions.c
      zend_reflection_api.c:
      - Fix warnings

    * zend_interfaces.c:
      Fix warnign

2004-09-27  Andi Gutmans  <andi@zend.com>

    * zend_variables.c
      zend_variables.h:
      - Use zval_ctor_func() for wrapper and update the prototype to void

    * zend_variables.c
      zend_variables.h:
      - Make zval_copy_ctor() return void like dtor(). No one ever checks the
      - return value which is SUCCESS always.

2004-09-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.h
      zend_variables.h:
      - Fix build

2004-09-26  Andi Gutmans  <andi@zend.com>

    * zend.h
      zend_variables.c
      zend_variables.h:
      - Apply Thies and Sterling's patch which doesn't call ctor/dtor functions
      - for types which don't require it (BOOL/NULL/LONG/DOUBLE)
      - Breaks serialization!!!

2004-09-24  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend_API.c:
      selectively avoiding module cleanup code for apache 1 build and removing a
      duplicate code

2004-09-24  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_spec.h:
      Fixed specializer bug.

2004-09-23  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - PHP 5.0.3-dev

    * zend_compile.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_opcode.c
      zend_vm.h:
      - Commit new VM architecture. This one allows people (aka Derick) to
      - ask the engine to use function handler mode. Will update the README
      - about that.

    * (PHP_5_0)
      zend.h:
      - Roll 5.0.2

2004-09-23  Ilia Alshanetsky  <ilia@prohost.org>

    * tests/bug20240.phpt:
      Fixed test.

2004-09-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Bugfix # 30209

2004-09-23  Andi Gutmans  <andi@zend.com>

    * tests/bench.php:
      - Commit synthetic benchmark

2004-09-23  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend_execute.c
      zend_execute_API.c
      zend_globals.h:
      Reverted the NetWare Specific Stack limit related patches as asked by Andi

2004-09-22  Anantha Kesari H Y  <hyanantha@novell.com>

    * zend_execute_API.c
      zend_globals.h:
      NetWare specific stack limit checks

    * zend_API.c:
      Aligned the ifdef NETWARE blocks to first column.

    * zend_execute.c:
      Stack limit will be checked while executing the script

    * zend_config.nw.h:
      To avoid redefinition (of free, alloca etc.) compilation errors in Zend.

    * zend_API.c:
      When Apache is unloaded, it calls dlclose on all the PHP extensions
      that are loaded in memory. In the case of Apache 1.3, this call is
      blocking indefinitely. As a work around, this call is bypassed for Apache
      1.3 build on NetWare only. This means that none of the loaded PHP
      extensions are unloaded. They will have to be manually unloaded before
      re-loading the Apache 1.3 again.

    * zend.h:
      defined ZEND_PATHS_SEPERATOR to semicolon for NetWare

    * acconfig.h:
      enabled macros to call the proper LibC functions

2004-09-22  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm_handlers.h
      zend_vm_spec.h:
      Specializer was updated with executor's fixes.

    * zend_execute.c
      zend_execute.c:
      Fixed bug #29566 (foreach/string handling strangeness (crash)).

    * zend_execute.c:
      Fixed bug in fix for bug #29707

2004-09-21  Andi Gutmans  <andi@zend.com>

    * zend_execute.c
      zend_execute.h:
      - Fix for bug #29707

2004-09-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Bugfix #30146 (ReflectionProperty->getValue() requires instance for static
      property)

    * zend_reflection_api.c:
      Bugfix #30148 (ReflectionMethod->isConstructor() fails for inherited
      classes)

2004-09-17  Stanislav Malyshev  <stas@zend.com>

    * zend_execute_API.c
      zend_objects_API.c
      zend_objects_API.h:
      fix crash when dtor is fialing on shutdown

2004-09-16  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - Go with PHP 5.0.2RC1

    * tests/bug27669.phpt:
      - Add test for bug #27669

2004-09-16  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_language_parser.y:
      ZTS fix.

2004-09-16  Andi Gutmans  <andi@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y:
      - Fix bug #27669 (Dmitry).
      Fixes:
      <?
              class A
              {
                      function hello()
                      {
                              echo "Hello World\n";
                      }
              }
              $y[0] = 'hello';
              A::$y[0]();
      ?>

2004-09-15  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_operators.h:
      MFH: Fixed a bug causing ".123" * "90" and alike to return a 0.

    * (PHP_5_0)
      zend_operators.h:
      Fixed a bug causing ".123" * "90" and alike to return a 0.

2004-09-15  Derick Rethans  <php@derickrethans.nl>

    * zend_config.w32.h:
      - Windows support strcoll too.

2004-09-13  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      Antony Dovgal's error message improvement - #27290

2004-09-11  Derick Rethans  <php@derickrethans.nl>

    * zend_operators.c
      zend_operators.h:
      - MFB: Added the sorting flag SORT_LOCALE_STRING to the sort() functions
      which
        makes them sort based on the current locale. (Derick)

    * (PHP_5_0)
      zend_operators.c
      zend_operators.h:
      - Added the sorting flag SORT_LOCALE_STRING to the sort() functions which
      makes
        them sort based on the current locale. (Derick)

2004-09-11  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - Resolve undefined behavior (joe at redhat)

2004-09-10  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - This one fixes rather strange problem - ZE allows multiple declarations
      of the same class constant.
      - It could be a minor BC break, but I'm sure it's a bug. (Antony Dovgal
      aka tony2001)

2004-09-09  Andi Gutmans  <andi@zend.com>

    * zend_extensions.h:
      - Revert API bump

    * README.ZEND_VM:
      - Commit VM explanation.

    * zend.c:
      - Recommit

    * zend_API.c
      zend_API.h
      zend_compile.c:
      - Recommit:
        - Check signature of magic methods
        - Register __get/__set/__call for internal classes

    * zend_extensions.h:
      - Recommit:
        - Bump the API number to work around this major breakage.

    * ChangeLog
      zend.c
      zend_API.c
      zend_API.h
      zend_builtin_functions.c
      zend_compile.c
      zend_compile.h
      zend_exceptions.c
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_extensions.h
      zend_opcode.c:
      - Roll back VM commit

2004-09-09  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      - Drop namespace relict

    * (PHP_5_0)
      zend_API.c
      zend_API.h
      zend_compile.c:
      MFH signature check/method registration

    * zend_API.c
      zend_API.h
      zend_compile.c:
      - Check signature of magic methods
      - Register __get/__set/__call for internal classes

2004-09-09  Derick Rethans  <php@derickrethans.nl>

    * zend_extensions.h:
      - Bump the API number to work around this major breakage.

2004-09-09  Dmitry Stogov  <dmitry@zend.com>

    * zend_vm.h:
      We will use CALL dispatch method for compilers other then GCC. It is more
      safe.

2004-09-09  Andi Gutmans  <andi@zend.com>

    * zend_API.c:
      - Fix the fix.

2004-09-06  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c:
      - Fix handling of exceptions in dtors

2004-09-05  Zeev Suraski  <zeev@zend.com>

    * zend.c
      zend.h
      zend_ini_parser.y:
      Fix reverse dependency

2004-09-04  Andi Gutmans  <andi@zend.com>

    * zend_API.c:
      - Don't destroy object when calling overloaded cast method in
      - zend_parse_parameters()

2004-09-02  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_compile.c:
      Fugbix typo.

2004-08-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      ZEND_CHANGES:
      MFH: Add some information about array overloading

    * ZEND_CHANGES:
      Add some information about array overloading

2004-08-30  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      fix crash #29893

2004-08-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      String offset starts with 0, fix isset($str[$len])

    * (PHP_5_0)
      zend_compile.c:
      MFH: Bugfix #29882 isset crashes on arrays

    * zend_compile.c:
      Bugfix #29882 isset crashes on arrays

2004-08-27  Andi Gutmans  <andi@zend.com>

    * zend_alloc.c:
      - Fix leak report for 0 byte allocations (Dmitry)

2004-08-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_compile.c:
      MFH: Enforce semantics: Classes cannot extend Interfaces

    * zend_compile.c:
      Enforce semantics: Classes cannot extend Interfaces

    * tests/bug29828.phpt:
      Fix test: Classes cannot extend Interfaces

    * zend_compile.c:
      Drop doubled check

    * zend_compile.c:
      - Bugfix #29828 Interfaces no longer work

    * tests/bug29828.phpt:
      
      Add new test

2004-08-25  Andi Gutmans  <andi@zend.com>

    * zend_builtin_functions.c:
      - Add interface_exists() and differentiate between classes and interfaces
        (Andrey Hristov)

2004-08-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      - Add missing brackets

2004-08-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      - Drop unused variable

    * zend_execute_API.c
      zend_globals.h:
      - Boost up __autoload() calls by caching the lookup

2004-08-23  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Improve performance of switch()

2004-08-23  Zeev Suraski  <zeev@zend.com>

    * (PHP_5_0)
      zend_reflection_api.c:
      Fix names

2004-08-21  Sara Golemon  <php@alphaweb.net>

    * zend_compile.c:
      Bugfix#29777 Some compilers don't like // style comments

2004-08-20  Sara Golemon  <php@alphaweb.net>

    * zend_ini_parser.y:
      Fix compile

2004-08-19  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Cleanup

    * zend.c
      zend_execute_API.c
      zend_globals.h:
      - Second wave of garbage removal.

    * zend_compile.h
      zend_execute.c:
      - Stop using garbage. Please let me know if you find any bugs resulting
      - of this patch (very likely). (Dmitry, Andi)

2004-08-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Implement #29728: Reflection API Feature: Default parameter value.
        . ReflectionParameter::isDefaultValueAvailable()
        . ReflectionParameter::getDefaultValue()

    * zend_reflection_api.c:
      - Nedd to work on copy

2004-08-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Show default value of optional parameters of user defined functions.

2004-08-18  Andrei Zmievski  <andreiz@gmail.com>

    * zend_ini_parser.y:
      Forgot to turn off debugging.

    * zend_ini_parser.y
      zend_ini_scanner.l:
      Re-add my patch for .ini variable access.

2004-08-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_reflection_api.c:
      MFH: Fix bug #29447: Reflection API issues

    * zend_reflection_api.c:
      - Fix bug #29447: Reflection API issues

2004-08-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Remove unnecessary check

2004-08-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Add missing check

2004-08-12  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - Back to 5.0.2-dev

    * (PHP_5_0)
      zend.h:
      - Roll 5.0.1

    * (PHP_5_0)
      zend.h:
      - Back to -dev

    * (PHP_5_0)
      zend.h:
      - 5.0.1RC2

    * zend_compile.c
      zend_compile.h
      zend_execute.c:
      - Don't use magic numbers

    * zend_compile.c
      zend_execute.c:
      - Significantly improve performance of foreach($arr as $data). (Marcus)

2004-08-11  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_highlight.c:
      MFH: Fixed bug #29607 (highlighting code with HEREDOC produces invalid
      output).

    * (PHP_5_0)
      zend_highlight.c:
      Fixed bug #29607 (highlighting code with HEREDOC produces invalid output).

2004-08-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      More meaningfull error message

2004-08-11  Derick Rethans  <php@derickrethans.nl>

    * (PHP_5_0)
      zend_alloc.h:
      - MFH: Patch to allow the Zend memory allocators to be disabled.

    * zend_alloc.h:
      - Added missing defines.

2004-08-10  Ilia Alshanetsky  <ilia@prohost.org>

    * (PHP_5_0)
      zend_highlight.c:
      MFH: Fixed bug #29606 (php_strip_whitespace() prints to stdout rather then
      returning the value).

    * zend_highlight.c:
      Fixed bug #29606 (php_strip_whitespace() prints to stdout rather then
      returning the value).

2004-08-10  Andi Gutmans  <andi@zend.com>

    * (PHP_5_0)
      zend.h:
      - Back to -dev

    * (PHP_5_0)
      zend.h:
      - 5.0.1RC1

2004-08-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      - Fix warnings

2004-08-07  Andi Gutmans  <andi@zend.com>

    * zend_alloc.h:
      - Commit Derick's patch for allowing Zend to use regular libc memory
      - allocation functions. Mainly useful in conjunction with tools such as
      - valgrind which enables us to find bugs we might not find with the
      - current memory managers boundary protection.

2004-08-05  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_builtin_functions.c:
      Eliminate unneeded variable.

2004-08-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c
      tests/bug29523.phpt:
      - Fix bug #29523 (ReflectionParameter::isOptional() is incorrect)

2004-08-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES:
      Update

    * (PHP_5_0)
      zend_builtin_functions.c
      tests/bug29505.phpt:
      - MFH Bug #29505 get_class_vars() severely broken when used with arrays

    * tests/bug29505.phpt:
      
      Add new test

    * zend_builtin_functions.c:
      - Fixed Bug #29505 get_class_vars() severely broken when used with arrays

2004-08-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Add methods to check parameter count

    * (PHP_5_0)
      zend_compile.c:
      MFH Change to use memcmp instead of strcmp

    * zend_compile.c:
      - Change to use memcmp instead of strcmp

2004-08-02  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fix typo

2004-08-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_parser.y
      zend_language_scanner.l:
      - Remove all for now

    * zend_compile.c
      zend_compile.h
      zend_execute_API.c:
      MFB: Enforce protocol on magic methods/functions

2004-08-02  Ilia Alshanetsky  <ilia@prohost.org>

    * (PHP_5_0)
      zend_execute.c:
      MFH: A gentler (performance wise) allocation of buffer for temp variables.

    * zend_execute.c:
      A gentler (performance wise) allocation of buffer for temp variables.

2004-08-01  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_compile.c
      zend_compile.h
      zend_execute_API.c:
      - Enforce protocol on magic methods/functions

2004-07-30  Andi Gutmans  <andi@zend.com>

    * zend_execute.c
      zend_execute_API.c
      zend_ptr_stack.c
      zend_ptr_stack.h:
      - More ptr_stack optimizations and cleanups

    * zend_alloc.c
      zend_alloc.h
      zend_execute.c
      zend_fast_cache.h
      zend_ptr_stack.h:
      - Improve performance by inlining zend_ptr_stack_n_push(). var_args can
        usually not be inlined by compilers.

2004-07-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_hash.c:
      - Increase performance of *sort() and some internal sort operations.

2004-07-29  Sara Golemon  <php@alphaweb.net>

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_language_parser.y
      zend_language_scanner.l
      zend_opcode.c:
      Revert goto opcode

    * zend_execute.c:
      &tmp and label are the same thing, don't free it till we're done with it.

    * zend_compile.c
      zend_execute.c:
      Plug some memory leaks and promote unknown label to E_ERROR.
      If someone tries to jump to a non-existant label execution really
      shouldn't try to carry on.

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_language_parser.y
      zend_language_scanner.l
      zend_opcode.c:
      Add goto operator by popular request.

2004-07-28  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_ini.c:
      Fix: ini entries for dl()'d modules now work under ZTS
      Side-effect: avoid possible crashes when multiple threads load/unload
      modules and mess with the global hash table.

2004-07-28  Andi Gutmans  <andi@zend.com>

    * zend.h
      zend.h:
      - Fix MAC OSX to always use native DSO loading

2004-07-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_exceptions.c:
      - Be specific about visibility

2004-07-27  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_builtin_functions.c:
      Fix two possible crashes.  Latter is unlikely unless you are doing scary
      things, but former looks nasty.

2004-07-26  Stanislav Malyshev  <stas@zend.com>

    * zend_interfaces.c:
      quick fix for #29382

2004-07-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Show visibility errors (try to fix #29354)

    * (PHP_5_0)
      zend_execute.c
      zend_objects_API.c
      zend_objects_API.h:
      - MFH: Fix bug #29368 : The destructor is called when an exception is
        thrown from the constructor

    * zend_execute.c
      zend_objects_API.c
      zend_objects_API.h:
      - Fix bug #29368 : The destructor is called when an exception is thrown
      from the constructor

    * zend.c
      zend.h
      zend_execute.h
      zend_execute_API.c:
      - Execute destructors earlier (Florian Schaper, fschaper at intux org)

    * zend_reflection_api.c:
      - Add ReflectionParameter::isOptional() to test whether a parameter is
        optional and also show this information in export.

    * zend_exceptions.c:
      - Add optional parameters $filename and $lineno to ErrorException
        constructor to allow overwriting automatically retrieved information.

2004-07-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Fix 0 Byte leak after alloca to emalloc change

2004-07-22  Zeev Suraski  <zeev@zend.com>

    * zend_object_handlers.c:
      Fix bug in handling of protected properties

2004-07-21  Edin Kadribasic  <edink@emini.dk>

    * zend_builtin_functions.c:
      Fixed build

2004-07-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * (PHP_5_0)
      zend_builtin_functions.c:
      MFH: Fixded #29291: get_class_vars() return names with NULLs

    * zend_builtin_functions.c:
      - Fixded #29291: get_class_vars() return names with NULLs

2004-07-20  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_alloc.c
      zend_alloc.h:
      - Add safe_pemalloc()

2004-07-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Fixed bug 28895 again (long live the dead)

2004-07-20  Zeev Suraski  <zeev@zend.com>

    * zend_exceptions.c:
      Fix prototypes

    * zend_exceptions.c:
      Add descriptions

2004-07-20  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c:
      add todo

    * (PHP_5_0)
      zend_ini.h
      zend_ini_parser.y:
      export ini parser

2004-07-19  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      Fix prototypes: Reflection_* -> Reflection*.

    * zend_reflection_api.c:
      Make ReflectionClass::getMethod() and ReflectionClass::getProperty() raise
      an ReflectionException instead of returning NULL on failure.

    * zend_reflection_api.c:
      Do not use contracted forms.

2004-07-19  Stanislav Malyshev  <stas@zend.com>

    * zend_ini.h
      zend_ini_parser.y:
      export INI parser

    * zend_object_handlers.c:
      __set and __get will be called not only when variable doesn't exist but
      also when it's
      invisible

2004-07-19  Andi Gutmans  <andi@zend.com>

    * zend_extensions.h
      zend_modules.h:
      - Bump API number due to empty_string change

    * zend.c
      zend.h
      zend_API.h
      zend_alloc.h
      zend_execute.c
      zend_object_handlers.c
      zend_operators.c
      zend_variables.c:
      - Nuke empty_string. It is a reminanent from the time where RETURN_FALSE()
        used to return "" and not bool(false). It's not worth keeping it because
        STR_FREE() and zval_dtor() always have to check for it and it slows down
        the general case. In addition, it seems that empty_string has been
      abused
        quite a lot, and was used not only for setting zval's but generally in
        PHP code instead of "", which wasn't the intention. Last but not least,
        nuking empty_string should improve stability as I doubt every place
        correctly checked if they are not mistakenly erealloc()'ing it or
        calling efree() on it.
        NOTE: Some code is probably broken. Each extension maintainer should
        check and see that my changes are OK. Also, I haven't had time to touch
        PECL yet. Will try and do it tomorrow.

2004-07-18  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_execute_API.c:
      No point allocating 0 bytes

2004-07-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_parser.y
      zend_language_scanner.l:
      - Speed up by making null/false/true reserved word which allows to drop
        an opcode (FETCH_CONSTANT) for every usage.

    * zend_execute.c:
      Bugfix #28464 catch() does not catch exceptions by interfaces

2004-07-16  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_operators.h:
      MFB: Fixed bug #28800 (strings beginning with "inf" improperly converted).

    * (PHP_5_0)
      zend_operators.h:
      Fixed bug #28800 (strings beginning with "inf" improperly converted).

2004-07-15  Andi Gutmans  <andi@zend.com>

    * zend_alloc.c
      zend_alloc.h:
      - Improve performance of zend_alloc by stopping the size from being a bit
      - field.

2004-07-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_exceptions.c
      zend_exceptions.h:
      - Add new class ErrorException to encapsulate errors in exceptions

    * zend_dynamic_array.h:
      - Fix prototype

2004-07-14  Stanislav Malyshev  <stas@zend.com>

    * zend_object_handlers.c:
      be consistent with write_dimension

    * zend_object_handlers.c:
      fix #28957

2004-07-13  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - 5.0.1-dev

2004-07-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_constants.c:
      Bugfix #29116 Zend constant warning uses memory after free (jdolecek at
      NetBSD dot org)

2004-07-13  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0)
      zend.h:
      - Roll PHP 5.0.0

2004-07-12  Ilia Alshanetsky  <ilia@prohost.org>

    * (php_5_0_0RC4)
      zend_execute.c:
      Fixed bug #29086 & #28064 (PHP crashes on extremly long scripts).

2004-07-12  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0RC4)
      zend.c:
      - Convert zend_class_entry -> zend_class_entry *

2004-07-10  Jon Parise  <jon+php@csh.rit.edu>

    * zend.c:
      DragonFly BSD is derived from FreeBSD and requires the same floating point
      precision fix.

2004-07-10  Andi Gutmans  <andi@zend.com>

    * zend_alloc.c
      zend_hash.c
      zend_variables.c:
      - Better stability during premature shutdown of request startup

2004-07-05  Andi Gutmans  <andi@zend.com>

    * zend_mm.h:
      - Disable zend_mm for 5.0.0

2004-07-03  Andi Gutmans  <andi@zend.com>

    * zend_alloc.c:
      - Should fix mem leak with ZEND_MM. I made this change a while ago and
      - rolled it back but I don't remember why. Please test!

2004-07-01  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_constants.c:
      Do not use alloca() where it can be easily abused by the users.
      

2004-06-25  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_stream.c
      zend_stream.h:
      export zend stream functions for zend extensions under windows

2004-06-24  Sara Golemon  <php@alphaweb.net>

    * zend_execute.c:
      Ease off on severity of new error (Using Resources as array offsets)

2004-06-23  Sara Golemon  <php@alphaweb.net>

    * zend_execute.c:
      BugFix #28879  Inconsistent behavior between explicit and implicit array
      creation.
      
      Changes:
      
      Throw E_WARNING "Illegal offset type" when explicitly creating
      array elements with objects, arrays, or resorces as indexes.
      This matches implicit creation w/ obj/arr indices.
      
      Throw E_WARNING "Resource ID#%ld used as offset, casting to integer (%ld)"
      when implicitly creating array with resource as index. (BC)

2004-06-19  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      Reflection_* -> Reflection*. Patch by Timm Friebe.

2004-06-18  Sara Golemon  <php@alphaweb.net>

    * zend_execute.c:
      Another typo in converting array index doubles to long.

2004-06-18  George Schlossnagle  <george@omniti.com>

    * zend_builtin_functions.c:
      fix for 28213.
      
      class_name and call_type should be reinitialized on every loop iter.

2004-06-17  Sara Golemon  <php@alphaweb.net>

    * zend_builtin_functions.c:
      String length in parse_parameters should be int

2004-06-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      

2004-06-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_scanner.l:
      Need {} here

2004-06-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_scanner.l:
      - Require a single white-space char after /** to start a doc comment that
        way we prevent /*** from becoming a doc comment (as requested Derick).

    * zend_API.h:
      Add missing declaration

    * zend_reflection_api.c:
      Small code layout change

    * zend_language_scanner.l:
      Do not require NEWLINE at start of doccomment

    * zend_reflection_api.c:
      Bugfix #28699: Reflection api bugs

2004-06-09  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Fix Bug #28694 ReflectionExtension::getFunctions() crashes PHP

2004-06-07  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Go back to -dev (Shouldn't need another RC)

    * (php_5_0_0RC3)
      zend.h:
      - Roll RC3

2004-06-06  Stefan Esser  <sesser@suspekt.org>

    * zend_compile.h
      zend_opcode.c:
      Fixed Zend Function Destructor to use correct TSRM handle.

2004-06-05  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Fix #28641: Instance of Interface

2004-06-03  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0RC3RC2)
      zend.h:
      - Prepare for RC3RC2

2004-06-02  Andi Gutmans  <andi@zend.com>

    * zend_mm.h:
      - Don't use ZEND_MM in Windows

2004-06-02  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      fix incdec - make value's refcount non-zero when passing to
      write_property - otherwise __set caller cleanup could kill it.

2004-06-01  Andi Gutmans  <andi@zend.com>

    * zend.c:
      - If user error handler returns "false" then we relay to the built in error
        handler

2004-05-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Refcount must not be set separatley again.

    * zend_reflection_api.c
      zend_reflection_api.c:
      Add missing initialization

    * zend_compile.c:
      

2004-05-28  Andrei Zmievski  <andreiz@gmail.com>

    * zend.c:
      Allow user-defined error handlers to indicate whether default error
      handler should be re-invoked, by returning true or false.

2004-05-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Prevent possible problems with illegal properties

2004-05-28  Derick Rethans  <php@derickrethans.nl>

    * zend_builtin_functions.c:
      - Make the default mask for user defined error handlers include ALL errors,
        including E_STRICT.

2004-05-27  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to RC3-dev until we roll final

    * (php_5_0_0RC3RC1)
      zend_execute.c:
      - Fix problem with exceptions returning from include(). (Dmitry)

    * (php_5_0_0RC3RC1)
      zend.h:
      - RC3RC1

2004-05-26  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_object_handlers.c:
      Fix leak on systems where alloca isn't really alloca.

2004-05-26  Andrei Zmievski  <andreiz@gmail.com>

    * zend_constants.c:
      Avoid unnecessary and silly copying of constant name when registering.

2004-05-26  Andi Gutmans  <andi@zend.com>

    * zend_alloc.c:
      - Fix memory manager problem

2004-05-26  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * ZEND_CHANGES:
      Update Reflection API class names. Whitespace fixes.

2004-05-25  Andi Gutmans  <andi@zend.com>

    * zend_objects_API.h:
      - Nuke unused decleration

    * zend_alloc.c
      zend_alloc.h:
      - More fixes

    * zend_alloc.c
      zend_alloc.h:
      - Make fix compile.

    * zend_alloc.c
      zend_alloc.h:
      - Fix memory leak in mem cache in conjunction with Zend MM. How come no one
      - noticed this? :)

2004-05-23  Andi Gutmans  <andi@zend.com>

    * zend_objects_API.c:
      - Fix problem with object being destroyed more than once

    * zend_builtin_functions.c:
      - Fix the following script (it crashed):
      <?php
         class ErrorHandler {
           function __construct() {
             set_error_handler(array(&$this, 'handle'));
           }
      
           function __destruct() {
             restore_error_handler();
           }
      
           function handle($code, $msg, $file, $line, $locals) {
           }
         }
      
         new ErrorHandler();
      ?>

2004-05-20  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_exceptions.c
      zend_exceptions.h:
      Revert; obviously I missed the function at the bottom of the file...

    * zend_exceptions.c
      zend_exceptions.h:
      Export this, so extensions may throw their own exception objects that
      they have already instantiated.

2004-05-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      - Need to operate on module pointer in hash table

2004-05-18  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_execute_API.c:
      Fix bug #28438: win32 build fails in non-zts mode

2004-05-18  Stanislav Malyshev  <stas@zend.com>

    * zend_API.c:
      Z_TYPE_P is for zvals

2004-05-18  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_API.c:
      Register according to the type specified by the module.
      (Helps to fix dl() bug)

2004-05-18  Sara Golemon  <php@alphaweb.net>

    * zend_execute.c:
      Bugfix#28404 When type is double we need to access dval, not lval

2004-05-17  Andrei Zmievski  <andreiz@gmail.com>

    * zend_ini_parser.y
      zend_ini_scanner.l:
      Revert the .ini vars patch. Will have to try again next Christmas
      apparently.

    * zend_ini_parser.y:
      Fix the apparent bug (; at the end of parse rule block).

2004-05-17  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_objects_API.c
      zend_objects_API.h:
      As discussed with Andi, add this helper API for setting the object pointer
      from
      within the constructor.
      
      Please read the comment for notes about how to use it; in general, you
      don't
      need it, so don't use it.

2004-05-14  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_ini_parser.y
      zend_ini_scanner.l:
      Adding ability to refer to existing .ini variables from within .ini
      files. Example:
      
      open_basedir = ${open_basedir} ":/new/dir"

2004-05-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      - Centralize register and hash operations for startup/register_module
        in new zend_register_module_ex().

    * zend_API.c:
      - Revert to 1.249

2004-05-11  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Don't allow passing NULL to type hinted parameter.

2004-05-10  Zeev Suraski  <zeev@zend.com>

    * zend_operators.c:
      - Fix comparison of objects
      - Clarify convert_object_to_type()

2004-05-10  Stefan Esser  <sesser@suspekt.org>

    * zend_alloc.c:
      Checking MEMORY_LIMIT before doing emalloc/erealloc solves several ugly
      problems.

2004-05-04  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_iterators.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects_API.c:
      Add count_elements handler for overloaded objects.

2004-05-02  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - Fix comparison of two objects in non-compatibility mode.

2004-05-01  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Don't load modules twice

2004-04-29  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      Fix bug #27876

2004-04-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_exceptions.h:
      Fix c++ builds

2004-04-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      - Optional parameter to class_exists() that can be used to bypass
        __autoload() which can be helpfull in __autoload() itself.

    * zend_interfaces.c:
      - Fix warnings

    * zend_interfaces.c
      zend_interfaces.h
      zend_iterators.h:
      - no unneccessary retval initialization
      - new c-level iterator handler invalidate_current that is optionally
        used to clear internal caching like in implementation of Iterator

2004-04-27  Andi Gutmans  <andi@zend.com>

    * zend_reflection_api.c:
      - Fix prototypes

2004-04-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Fix prototype

2004-04-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      Skip correct amount of stack entries

    * zend_interfaces.c:
      Capture potential problem by error message

    * zend_reflection_api.c:
      Show number of classes

2004-04-25  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - RC3-dev

    * (php_5_0_0RC2)
      zend.h:
      - RC2

2004-04-23  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fixed bug #27923. foreach() without a key should not check if the key
      - is a reference (Adam)

2004-04-21  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - RC2-dev

    * (php_5_0_0RC2RC2)
      zend.h:
      - Prepare for RC2RC2 (if everything is OK especially Zeev's interface
      - patch I'll roll RC2 tomorrow).

2004-04-21  Zeev Suraski  <zeev@zend.com>

    * (php_5_0_0RC2RC2)
      zend_compile.c:
      Restore fatal error in case a method that's supposed to implement an
      interface/abstract method, breaks its prototype

2004-04-20  Andi Gutmans  <andi@zend.com>

    * zend_language_parser.y:
      - Fix bug #27283 - Exceptions where the last catch() statement was
      sometimes
      - skipped.

2004-04-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      show ini entries and classes for extensions.

2004-04-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      Retval may not be set when zend_execute() is overloaded

2004-04-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Handle failure in get_current_data

2004-04-14  Andi Gutmans  <andi@zend.com>

    * zend_extensions.h:
      - Add comment

    * zend.h:
      - RC2-dev

    * (php_5_0_0RC2RC1)
      zend.h:
      - RC2RC1

2004-04-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_exceptions.c:
      Classnames shall start with an uppercase character

2004-04-13  Zeev Suraski  <zeev@zend.com>

    * zend_builtin_functions.c:
      Fix debug_backtrace to show arguments again
      We need to merge code from debug_backtrace & debug_print_backtrace at
      some point!

2004-04-13  Andi Gutmans  <andi@zend.com>

    * zend_extensions.h:
      - Fix API no of Engine 2. The first number is the engine version and the
      - rest is the API_NO. This way engine2_api_no is always greater than
      - engine1_api_no.

    * zend.c
      zend_exceptions.c
      zend_exceptions.h:
      - Add hook for exception handler (Derick)

2004-04-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h:
      Fix order of macro parameter (synch with other macros)

2004-04-12  Andi Gutmans  <andi@zend.com>

    * OBJECTS2_HOWTO
      zend_extensions.h
      zend_ini.c
      zend_ini.h
      zend_modules.h:
      - modifyable -> modifiable

2004-04-09  Andi Gutmans  <andi@zend.com>

    * zend_object_handlers.c:
      - Fix bug #26441 (When __set() returned a value it corrupted it)

2004-04-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Bugfix #27519 Reflection_Function constructor crashes with non-existant
      function's name

2004-04-07  Andi Gutmans  <andi@zend.com>

    * zend_builtin_functions.c:
      - Hopefully fix the debug_backtrace() code.

    * zend_builtin_functions.c:
      - Fix crash bug in zend_debug_backtrace(). No idea how come this survived
      - for so long....

2004-04-04  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_objects_API.c:
      Removed unused variable.

2004-04-03  Andi Gutmans  <andi@zend.com>

    * zend_builtin_functions.c:
      Patch by Timm Friebe:
      It changes
      set_exception_handler() to accept the pseudo-type "callable" (instead of
      a string referring to a global function).
      
      
      Examples:
        set_exception_handler('function_name');
        set_exception_handler(array('class_name', 'static_method'));
        set_exception_handler(array($instance, 'instance_method'));
      
      
      This also makes set_exception_handler() more consistent with all the
      other callback functionality, e.g. set_error_handler().

    * zend_operators.c:
      - Nuke more old junk

    * zend.h
      zend_operators.c
      zend_operators.h:
      - Nuke code which hasn't been in use for ages.

2004-04-01  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_builtin_functions.c:
      MFB: Revert patch for bug #27782.

    * zend_execute.c
      tests/bug27731.phpt:
      Fixed reversed condition for error reporting.

2004-03-31  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c:
      Fixed BUG in zend_post_incdec_property

2004-03-31  Andi Gutmans  <andi@zend.com>

    * zend_reflection_api.c:
      - Fix typo

2004-03-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug26695.phpt:
      Fix test

2004-03-30  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_builtin_functions.c:
      Fixed bug #27782 (Wrong behaviour of next(), prev() and each()).

2004-03-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      TSRM fix

    * zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_globals.h
      zend_reflection_api.c:
      - Fix Reflection class names
      - Add ability to get the extension an internal class was defined in

2004-03-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * acconfig.h:
      NAN==NAN doest work (Ard)

    * zend_builtin_functions.c:
      Allow mixed case search for extensions

2004-03-29  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_execute.c:
      -clonning+cloning

2004-03-29  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c:
      Implicit clonning strict warning was added for ze1_compatibility_mode

2004-03-29  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c
      tests/bug27731.phpt:
      Fixed bug #27731 (error_reporting() inside @ block fails to set
      error_reporting level).

2004-03-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Use lowercasing here

    * zend.c:
      Initialize the complete struct

2004-03-28  Stanislav Malyshev  <stas@zend.com>

    * zend_language_parser.y:
      check writability on =& too

    * zend_execute.c:
      - call set handler if assigning to object having this handler
      - cleanup: use macros to access object internal vars

    * zend_interfaces.c:
      preserve ZEND_API in definition

    * zend_interfaces.h:
      declare as extern

2004-03-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Fix memleak found by Timm

2004-03-28  Stanislav Malyshev  <stas@zend.com>

    * zend_operators.c:
      centralize object-to-scalar conversion, make it work with get handler

    * zend.c:
      try get handler on printable conversion

    * zend_object_handlers.h:
      some more clear comments

    * zend_operators.c:
      Use macros for object parts access

2004-03-28  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute_API.c:
      fix of fix related to __autoload. (ext/standard/tests/network/bug20134.phpt
      passes again)

2004-03-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      Even though it is uncommented it should be right

2004-03-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_compile.c:
      Force destructors to have empty signatures

2004-03-26  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Fix build (thanks to Timm)

2004-03-25  Derick Rethans  <php@derickrethans.nl>

    * zend_language_scanner.l:
      - Remove old and deprecated <?php_track_vars?> scanner token.

2004-03-25  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - If __construct() is defined then it will always take precedence over
      - old style constructors.

2004-03-25  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      no need to use result for RECV's - as in PHP4

    * zend_execute.c:
      Use get/set handlers for increment.decrement ops on objects

2004-03-25  Andi Gutmans  <andi@zend.com>

    * zend_execute_API.c:
          /* The compiler is not-reentrant. Make sure we __autoload() only during
      run-time
           * (doesn't impact fuctionality of __autoload()
           */

2004-03-25  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute_API.c:
      Using ALLOC_HASHTABLE/FREE_HASHTABLE instead of emalloc/free.

2004-03-24  Dmitry Stogov  <dmitry@zend.com>

    * zend.c
      zend_execute_API.c
      zend_globals.h:
      New autoload protection schema was implemented (Using HashTable instead of
      boolean flag)

2004-03-24  Derick Rethans  <php@derickrethans.nl>

    * zend_operators.c:
      - Revert bogus commit

    * zend_operators.c:
      - Fixed NEWS

2004-03-24  Dmitry Stogov  <dmitry@zend.com>

    * tests/bug27641.phpt:
      Fixed bug #27641 (Object cloning in ze1_compatibility_mode was
      reimplemented)

    * zend_execute.c
      zend_variables.c:
      Object cloning in ze1 compatibility mode (zend.ze1_compatibility_mode) was
      reimplemented (Dmitry, Andi)

2004-03-22  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fix bug

    * zend_execute.c:
      - Remove whitespace

2004-03-21  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Improve consistency

2004-03-21  Stanislav Malyshev  <stas@zend.com>

    * zend_objects_API.c
      zend_objects_API.h:
      return zval *, to make it useful for read_property

    * zend_objects_API.c:
      update to new API

    * zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h:
      API change for read_property:
      instead of bool silent it now gets fetch type
      This can be used for creating proxy objects for write contexts

2004-03-21  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Nuke unused code

2004-03-18  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Back to RC2-dev

2004-03-18  Zeev Suraski  <zeev@zend.com>

    * (php_5_0_0RC1)
      zend.h:
      Prepare to roll RC1

    * (php_5_0_0RC1)
      zend_execute.c:
      Fix possible data corruption with __set()

2004-03-18  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      Improve error message - on E_STRICT, method is actually called,
      so the error shouldn't say it cannot be called.

2004-03-18  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0RC1)
      zend_compile.c:
      - Change redefinition of constructor from E_COMPILE_ERROR to E_STRICT.

    * (php_5_0_0RC1)
      ZEND_CHANGES:
      - Update Changes

2004-03-17  Sascha Schumann  <sascha@schumann.cx>

    * zend_multiply.h:
      Readd x86 implementation

2004-03-17  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0RC1RC2)
      zend_multiply.h:
      - Improved patch for support multiplication on 64bit machines

    * (php_5_0_0RC1RC2)
      zend_execute.c:
      - Fix tiny bug (one of the reasons we can't support __toString() for
      - regular objects).

    * (php_5_0_0RC1RC2)
      zend.c:
      - Stop make_printable_zval() from calling __toString()

    * zend_execute.c:
      - Fixed problem with __toString(). Due to the engine's architecture it is
      - currently not possible to call __toString() anywhere besides print &
      eval.
      - Follow up will be on internals@

2004-03-17  Stanislav Malyshev  <stas@zend.com>

    * (php_5_0_0RC1RC2)
      zend_compile.c:
      fix typo

2004-03-17  Andi Gutmans  <andi@zend.com>

    * zend_multiply.h
      zend_operators.c:
      - Apply Ard's patch to support multiplication & overflow on both 32bit
        and 64bit machines

2004-03-16  Derick Rethans  <php@derickrethans.nl>

    * zend.c
      zend.h
      zend_API.h
      zend_modules.h:
      - Replaced the exec_finished hook by the zend_post_deactive hook for
        extensions. The new hook will be run after the symbol table and
      destructors
        are run. (Derick)

    * zend_modules.h:
      - Bump API number so that it actually differs from PHP 4. This is needed
        because we don't want PHP 4 and PHP 5 extensions to be in the same
      directory
        when doing "make install" for shared, or phpize'd extensions.

2004-03-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      Fix SEGV in certain conditions while calling static methods

2004-03-16  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_compile.h:
      Add ability to disable JIT for a particular auto global

2004-03-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      TSRM fix

2004-03-16  Sascha Schumann  <sascha@schumann.cx>

    * zend.h:
      Enable ptr format check for GCC 3.1 and higher

2004-03-16  Ilia Alshanetsky  <ilia@prohost.org>

    * zend.h:
      Do not allow 3.0.4 for __attribute__.

    * zend.h:
      Fixed bug #27600 (GCC 3.0.4 does not like __attribute__ directive)

2004-03-16  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fix problem when using old-style constructors it wasn't being inherited
        correctly.

2004-03-16  Derick Rethans  <php@derickrethans.nl>

    * zend_execute_API.c:
      - Spaces to tabs

2004-03-16  Andi Gutmans  <andi@zend.com>

    * zend_execute_API.c:
      - If the called method is static then don't define $this

    * zend_execute.c
      zend_execute_API.c:
      - Error out if get_method() isn't defined.
      - Use calling scope of internal function callee when calling a method
        using static syntax (array("A", "func"));

2004-03-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_execute.h
      zend_execute_API.c:
      Improve error message

2004-03-15  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - Restore E_NOTICE for longs and doubles.

2004-03-15  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend.h:
      - Fixed bug #24582 (extensions can not be loaded dynamically in
      Solaris/iPlanet)

2004-03-15  Andi Gutmans  <andi@zend.com>

    * zend_operators.c:
      - Nuke E_NOTICE. This caused a notice when doing if ($obj == NULL)

2004-03-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      Make object parameter optional

2004-03-14  Ilia Alshanetsky  <ilia@prohost.org>

    * zend.c:
      Fixed bug #27590 (crash during shutdown when freeing persistent resources
      in ZTS mode).

2004-03-14  Andi Gutmans  <andi@zend.com>

    * zend_execute_API.c:
      - Fix windows build

    * zend_execute_API.c:
      - Fix for bug #27504

    * zend_builtin_functions.c:
      - Fixing bug #27123

    * zend_operators.c:
      - Improve compatibility mode and compare objects according to property
      - comparison (sucky but this is how PHP 4 behaved).

    * zend.c:
      - Fix flow of logic

    * zend_operators.c:
      - Support old style of converting objects to long/double/bool.
      - This is only enabled in compatibility mode, else it calls cast_object()
      - and if that is not available we return 1 (true) so that the following
      - code would work:
      if ($obj) {
      }

2004-03-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_operators.c:
      Fix: Add return type void

2004-03-14  Andi Gutmans  <andi@zend.com>

    * zend.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_operators.c:
      - Support Cast operator in convert_to_* so that we support internal
      - extensions such as SimpleXML. This is for Sterling.

    * zend_operators.c:
      - Fix memory leak in the following code (Dmitry):
      <?php
      $a = array();
      $a .= "x";
      ?>

    * zend_operators.c:
      - Initial commit which allows comparing overloaded objects with native
      - types (only for internal classes and not for user-land classes).

2004-03-11  Andi Gutmans  <andi@zend.com>

    * zend_objects_API.c:
      - Real fix for bug #27535 (Dmitry)

    * zend_objects_API.c:
      - Attempt to fix bug #27535

2004-03-09  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES:
      Rename hasMore() to valid() as discussed. (Part VI)

    * zend_API.c
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute_API.c
      zend_interfaces.c
      zend_language_parser.y
      zend_reflection_api.c:
      Clearify the different method/class flags (as discussed with Andi).

    * zend.h:
      No longer needed

2004-03-09  Andi Gutmans  <andi@zend.com>

    * zend_constants.c:
      - Fix crash:
      <?php
      class ResourceFormat
      {
           const IMG           = 1;
      }
      
      class Image
      {
           const RESOURCE_FORMAT   = ResourceFormat::IMG;
      }
      
      print_r(constant('Image::RESOURCE_FORMAT'));
      ?>

    * zend_compile.c
      zend_compile.h
      zend_execute.c:
      - Nuke unused code.

2004-03-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_interfaces.c
      zend_iterators.h:
      Rename hasMore() to valid() as discussed. (Part II)

    * zend_interfaces.c:
      Rename hasMore() to valid() as discussed. (Part I)

    * zend_execute_API.c:
      Check count.

    * zend_reflection_api.c:
      Add another missing conversion

2004-03-05  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fix some small problems I introduce in last patch.

    * zend_compile.c:
      - Finally fix the following:
      $xml_mem =
      simplexml_load_string('<bookbody><part><chapter><page>1</page></chapter></part></bookbody>');
      /* The following works fine */
      foreach ($xml_mem->part as $part) {
        foreach($part->chapter->page as $page) {
       print $page;
        }
      }
      /* The following segfaults */
      foreach ($xml_mem->part as $part) {
        foreach($part->chapter as $chapter) { // Difference here from previous
      example
       print $chapter;
        }
      }

2004-03-04  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_language_scanner.l:
      - Fix memleak when scanner is called from within tokenizer extension.

2004-03-04  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.h:
      fix the fix

    * zend_execute.h:
      oops, fix cut&paste gone bad

    * zend_execute.h:
      Fix object true value: if we are in compat mode and it's Zend object -
      use PHP4 rules. Otherwise, object is always true.

2004-03-04  Derick Rethans  <php@derickrethans.nl>

    * zend_constants.h
      zend_operators.h:
      - Fixed a 64bit issue (for zend_builtin_functions.c, module_number is an
      int).
      - Change the MAX_LENGTH_OF_LONG constant to 20, as LONG_MAX is 20
      characters.
        (Patches by Ard Biesheuven)

    * tests/zend_operators.phpt:
      - Added instance_of test (patch by Ard Biesheuvel)

2004-03-04  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c:
      Disallow redefining ctors and cleanup

    * zend_mm.c:
      Handle out of memory/bad size situation gracefully, without getting into
      loop

2004-03-03  Andi Gutmans  <andi@zend.com>

    * zend_objects_API.c:
      - Fix crash:
      <?
      class foo {
              function __destruct() {
                      foreach ($this->x as $x);
              }
      }
      new foo();
      echo 'OK';
      ?>

2004-03-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h:
      Fix zend_parse_method_parameters_ex() and make it consistant with
      zend_parse_method_parameters().

2004-03-02  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Fix leaks (although there might be still a problem here).

    * zend_execute.c:
      - Fix leak (Dmitry)

    * zend_compile.c:
      - Fix crash in:
      <?php
        class Foo {
          public $attributes=  array();
      
          function export() {
            foreach ($this->attributes as $name => $attr) {
            }
          }
        }
      
        $f= new Foo();
        $f->export();
      ?>

    * zend_objects.c:
      - Improve fix for protecting destructor's from exceptions.
      - I was killing the current exception completely which was wrong.

2004-03-01  Andi Gutmans  <andi@zend.com>

    * zend_objects.c:
      - Fix crash in destructors(). You can't throw an exception in destructors
        as there is no guaranteed time when the destructor will be called.

    * zend_reflection_api.c:
      - Fix leak

    * zend_reflection_api.c:
      - Fix crash in reflection API (pierre)

    * zend.c
      zend_exceptions.c
      zend_execute_API.c:
      - Fix crash in exception handling (zend_exception_error(...) and
        zend_eval_string_ex() were buggy (Dmitry, Andi)

2004-03-01  Derick Rethans  <php@derickrethans.nl>

    * zend_compile.h:
      - Typo fix (by Jan)

    * zend_builtin_functions.c:
      - Fixed bug #27443 (defined() returns wrong type).

2004-02-29  Andi Gutmans  <andi@zend.com>

    * zend_reflection_api.c:
      - Apply fixes by Timm.

    * zend_compile.c:
      - Change prototype isA check not to check the constructor.
      - Only give an E_STRICT for non-isA compliant code as opposed to
        E_COMPILE_ERROR.

2004-02-29  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.h:
      add ZEND_API there too for opcode handlers

2004-02-29  Derick Rethans  <php@derickrethans.nl>

    * zend_execute.c:
      - Initialize memory to \0 so that we can reliable detect whether a specific
        opcode element is in use.

2004-02-29  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      export opcode table

2004-02-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_compile.h:
      Add some comments

    * zend_API.c
      zend_compile.c
      zend_execute.c:
      Fixes for abstract classes/methods

2004-02-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_parser.y
      zend_language_scanner.l:
      Fix __METHOD__ (noticed by Davey Sahfik)

    * zend_reflection_api.c:
      Fix problem with Reflection_Property (patch from Timm slightly modified).

2004-02-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects_API.c:
      As Andi found out the dtor may increase the refcount.

2004-02-25  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_builtin_functions.c:
      ws + cs

2004-02-25  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_execute.c:
      Fix leak in foreach ($o->mthd()->arr)

    * zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_execute.c:
      - Improve ARG_INFO() macros to support supplying required_num_args
      - Initial fix for foreach($o->mthd()->arr) crash (now leaks)

2004-02-25  Derick Rethans  <php@derickrethans.nl>

    * zend_highlight.c:
      - Use <span> instead of <font> in highlight_string(). (Patch by
      mg@iceni.pl)

2004-02-25  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_exceptions.c:
      Improve error messages

2004-02-25  Zeev Suraski  <zeev@zend.com>

    * zend.c
      zend_compile.c
      zend_execute.c
      zend_execute_API.c
      zend_globals.h
      zend_variables.c:
      - Rename compatiblity mode to zend.ze2_compatibility_mode (it doesn't  
      only affect auto-clone).
      - Perform implementation checks even with simple inheritance (off when
        compatibility mode is enabled).
      - Restore default arguments in interfaces and handle it correctly.
      - Move registration of internal classes later in the startup sequence
        in order to have INI options available.

2004-02-25  Derick Rethans  <php@derickrethans.nl>

    * zend_exceptions.c:
      - Fixed bug #27391 (typo in Fatal Error message).

2004-02-25  Zeev Suraski  <zeev@zend.com>

    * zend_API.c
      zend_compile.c
      zend_compile.h
      zend_opcode.c:
      - Abstract methods cannot have defaults for arguments
      - Make function foo($a, $b=null) satisfy both foo($a) and foo($a, $b)
        prototypes

2004-02-25  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      Proto fixes.

2004-02-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects_API.c:
      Fix object destruction/free in shutdown
      - set destructor_called even when no dtor is given
      - use free_storage even when no dtor hat to be called

    * zend_objects_API.c:
      Checking once for dtor is enough

2004-02-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Fix class flags when handling abstract methods

2004-02-23  Andi Gutmans  <andi@zend.com>

    * zend_language_parser.y:
      - Improve precendence:
      
      <?php
      
      $obj->foo = "Blah";
      
      if (!$obj instanceof StdClass) {
          print "No";
      } else {
          print "Yes";
      }

    * zend_language_parser.y:
      - Decrease precedence of instanceof so that the following is true:
      php -r 'var_export((object)1 instanceof stdClass);';
      Patch by Jan Lehnardt

2004-02-22  Derick Rethans  <php@derickrethans.nl>

    * zend_operators.c:
      - Fixed bug #27354 (Modulus operator crashes PHP).

2004-02-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES:
      Add some more obviously needed information

2004-02-20  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * zend.h
      zend_API.h
      zend_iterators.h
      zend_operators.h
      zend_variables.h:
      more EXTERN_C wrapping of ZEND_API prototypes

2004-02-20  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_opcode.c:
      ws fix

2004-02-18  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * zend.h
      zend_builtin_functions.h
      zend_extensions.h
      zend_indent.h
      zend_interfaces.h
      zend_object_handlers.h
      zend_objects.h
      zend_objects_API.h
      zend_ptr_stack.h
      zend_stack.h
      zend_stream.h:
      wrap ZEND_API prototypes into BEGIN_EXTERN_C/END_EXTERN_C
      for C++ extension support

2004-02-18  Zeev Suraski  <zeev@zend.com>

    * zend.c:
      Forward-port fixlet from PHP 4 (thanks to Michael Sisolak)

2004-02-17  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_list.c:
      MFB: - Fix bug #26753 (zend_fetch_list_dtor_id() does not check NULL
      strings)

2004-02-16  Derick Rethans  <php@derickrethans.nl>

    * ZEND_CHANGES:
      - Clearify clone behavior, fixed clone example (Patch by Jan Lehnardt)

2004-02-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Bugfix #27227 Mixed case class names causes Fatal Error in Constructor call

2004-02-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_iterators.c:
      dtor's may not be called from free_storage handlers

2004-02-12  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0b4)
      zend_execute.c:
      - Remove old code

2004-02-12  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * (php_5_0_0b4)
      ZEND_CHANGES:
      making sure that the provided examples actualy work (or at least do not
      generate no parse errors) unless they are really expected to fail

2004-02-12  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0b4)
      zend_object_handlers.c:
      - This was too strict.

2004-02-12  Zeev Suraski  <zeev@zend.com>

    * (php_5_0_0b4)
      zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_interfaces.c
      zend_object_handlers.c:
      - Check return-by-reference bit when implementing interface prototypes
      - Add infrastructure for built-in functions to hint whether they
        return by reference or not.  It is NOT currently used for anything,
        except for interface prototypes (you can use it to request that the
        function that implements your prototype returns by reference or
        doesn't return by reference).
        For downwards compatibility - by default, interface prototypes are
        agnostic as to whether the function that implements them returns
        by reference or not.  Use ZEND_BEGIN_ARG_INFO_EX() with
        ZEND_RETURN_VALUE/ZEND_RETURN_REFERENCE to change that.
      - Fix ArrayAccess::getOffset() to conduct additional checks.
        If your getOffset() should work with multidimensional arrays - it
        must return by reference.

2004-02-12  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0b4)
      zend_object_handlers.h:
      - Add comments to read/write property/dimension for extension authors

2004-02-12  Zeev Suraski  <zeev@zend.com>

    * zend_default_classes.h:
      zend_default_classes.h -> zend_exceptions.h

2004-02-12  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0b4)
      Makefile.am:
      - Add zend_exceptions.c

2004-02-12  Zeev Suraski  <zeev@zend.com>

    * (php_5_0_0b4)
      ZendTS.dsp
      zend.c
      zend_default_classes.c
      zend_exceptions.c
      zend_exceptions.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_reflection_api.c:
      Centralize exceptions code in zend_exceptions.[ch].
      Remove zend_default_classes.h (use zend_exceptions.h instead)
      
      NOTE:  This currently breaks the build, fixes to php-src and pecl coming
             soon

2004-02-12  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Use zend_throw_exception_object() in throw_handler to make sure it
      - does all the checks

2004-02-12  Zeev Suraski  <zeev@zend.com>

    * zend_default_classes.c
      zend_default_classes.h
      zend_exceptions.c
      zend_exceptions.h
      zend_execute.h
      zend_execute_API.c:
      Exceptions updates:
      
      - Enforce exceptions to be derived from class Exception.  This allows
        users to perform catch-all.  It's not yet complete, so don't get
        comfortable with it just yet :)  Updates are coming soon.
      - Implement zend_throw_exception() using zend_throw_exception_ex()

2004-02-12  Andi Gutmans  <andi@zend.com>

    * zend_execute.h
      zend_execute_API.c:
      - Add API function to throw exception by using an object

2004-02-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      Must be initialized in ZTS mode

    * ZEND_CHANGES
      ZEND_CHANGES:
      Update

    * zend_compile.c
      zend_language_parser.y:
      Fix: <interface> [extends <interface> [, <ineterface>]* ]

2004-02-11  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix leaks in assignments to overloaded objects

    * zend_execute.c:
      Fix leak with overloaded objects, when they're used just "for the hell
      of it" :)

    * zend_execute.c:
      Fixed a bug the caused overloaded array indices to be converted to strings

    * zend_execute.c:
      Turn off bogus warnings with overloaded dimensions and += (and friends)

    * zend_execute.c:
      Improve the implementation of unset() on array dimensions to be more
      consistent with that of regular variables and string offsets

    * zend_execute_API.c:
      Fix bug #25038

    * zend_reflection_api.c:
      Fix crash (patch by Rob Richards)

    * zend.c
      zend_execute_API.c:
      Fix exceptions thrown without a stack frame
      Always enable set_exception_handler()

    * zend_list.h:
      Change FETCH_RESOURCE to return false on error instead of null, for
      consistency with other error situations

    * zend_compile.c:
      Fix bug #26802 (the right aspects of it found by Marcus, anyway :)

    * tests/bug26802.phpt:
      Fix and clarify the test case

    * zend_execute_API.c:
      Complete the fix for handling of exceptions happening during the
      argument passing phase of function calls (fixes bug #26866)

    * zend_execute_API.c:
      whitespace

2004-02-10  Zeev Suraski  <zeev@zend.com>

    * tests/bug26698.phpt:
      Ignore the memleak in this test

    * zend_execute.c:
      Fix bug #26698 (exceptions handled properly during argument passing to
      functions)

    * zend_default_classes.c:
      Fix bug #27186

    * zend_execute_API.c:
      Fix bug #26869

    * zend_execute.c:
      Fix refcounting of ++/+= overloading (fix leak in __get()/__set()
      based classes)

2004-02-10  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Nuke more unused code

2004-02-10  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix handling in assignment using multidimensional array syntax to string
      offset ($s = "FUBAR"; $s[0][0] = 1;)

2004-02-10  Andi Gutmans  <andi@zend.com>

    * ZEND_CHANGES:
      - We will go with PHP 4 behavior. With the new object model assigning by
        reference has lost a lot of its importance.

    * zend_compile.c:
      - Remove junk

2004-02-10  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix exception handling in opcodes spanned across multiple oplines (fixes
      the crash in __set())

    * zend_execute.c:
      - Fix pre/post increment for overloaded objects
      - Fix binary-assign-op for overloaded objects
      
      NOTE:  This requires the implementation of the 'get' callback!

2004-02-10  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * tests/bug22836.phpt:
      - Correcting test.

2004-02-08  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h:
      Fix write-mode of overloaded objects when using array dimensions

2004-02-08  Andi Gutmans  <andi@zend.com>

    * zend_objects_API.c:
      - Check if free_storage exists

2004-02-05  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * ZEND_CHANGES:
      Committing for Jan.

2004-02-05  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_compile.c
      tests/bug27145.phpt:
      Fixed bug #27145 (Unmangle private/protected property names before printing
      then inside error messages).

2004-02-04  Zeev Suraski  <zeev@zend.com>

    * zend_execute_API.c:
      Fix exceptions happening inside internal functions called through
      zend_user_function()

    * zend_execute_API.c:
      Remove double initialization

2004-02-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.h:
      Add new prototype

    * zend_reflection_api.c:
      Fix reflection

    * zend_iterators.c:
      Fix warnings

2004-02-04  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Fixlet

    * zend_compile.c:
      Fix handling of $this in some cases

    * zend_compile.c:
      Handle additional cases

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_language_parser.y:
      Reinstate early-binding for classes.
      
      Note that this is available for downwards compatibility only - and it
      doesn't
      work if you use new features (namely, interfaces).  Generally, people
      should
      declare their classes before using them, but we just didn't want hell to
      break
      loose (c)

    * zend_opcode.c:
      Optimize

    * zend_compile.c:
      - Improve $this assignment detection and generalize some code in
      zend_compile.c

    * zend_compile.c:
      -Error out when trying to re-assign $this

    * zend_objects_API.c
      zend_objects_API.h:
      The valid bit was necessary after all - restored

    * zend_objects_API.c:
      Fixlets

    * zend_compile.c
      zend_objects.c:
      - Small fixes

    * zend_execute.c:
      - Improve wording

    * zend_execute_API.c
      zend_iterators.c
      zend_objects.c
      zend_objects_API.c
      zend_objects_API.h
      zend_reflection_api.c:
      Change destructor implementation (details will follow on internals@)

2004-02-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug24884.phpt:
      Update tests

    * zend_objects.c:
      Nuke unused variable

    * zend_compile.c:
      Fix Warning

2004-02-03  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * ZEND_CHANGES:
      clone/__clone() related changes.

2004-02-03  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Remove unused variable

    * zend_objects_API.c
      zend_objects_API.h:
      Remove more garbage - valid bit was not really necessary

    * zend_execute_API.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects_API.c
      zend_objects_API.h:
      - Clean garbage (delete was nuked a long time ago)

2004-02-03  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c:
      More unneeded code removed.

2004-02-03  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c
      zend_language_scanner.l:
      Abort on parse error in an include file (patch by Ilia)

    * zend_compile.c:
      Remove redundant code

    * zend_execute.c:
      Fix try/catch block logic

    * zend_compile.c
      zend_objects.c:
      Perform a bitwise copy of the object even when __clone() is defined.
      __clone() is back to not requiring any arguments, as $that is no longer
      needed ($this already contains a copy of the original object, by the time
      we __clone() is executed).
      Calling the parent clone is done using parent::__clone()

    * zend_compile.c
      zend_compile.h
      zend_default_classes.c
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_globals.h
      zend_language_parser.y
      zend_language_scanner.l
      zend_opcode.c:
      Rewrote exception support.  Fixes a few limitations and bugs in the old
      implementation, and allows exceptions to 'fire' much earlier than before.
      
      Instructions on how to use the new mechanism will follow on internals@
      shortly...
      
      Note - this (most probably) breaks the current implementation of
      set_exception_handler()

2004-02-02  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y
      zend_language_scanner.l
      zend_objects.c:
      Redesign the clone() feature to fix some fundamental flaws in the previous
      implementation.
      
      Using clone directly is now done using
      $replica = clone $src;
      
      Clone methods must now be declared as follows:
      function __clone($that)
      {
      }
      
      Clone methods in derived classes can call the __clone method of their
      parent
      classes using parent::__clone($that)

2004-01-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Throw an exception in case a reflection object cannot be found and do not
      override the exception from constructors in static method calls.

2004-01-30  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c:
      Apply the same parse error handling to (include|require)_once as the one
      for
      their non-once counterparts.

2004-01-28  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Tweak checks to detect some additional cases.
      Reorder checks to make more sense.

    * zend_compile.c:
      - Error message fix
      - Prevent inheritance of the same constant from two interfaces

    * zend_compile.c:
      Fixlets

    * zend_compile.c
      zend_compile.h:
      Prevent classes from implementing interfaces that have the same function

    * zend_execute.c:
      Whitespace

    * zend_compile.c:
      Code relayout

    * zend_execute_API.c:
      Forward-port fix for timeouts under Windows

2004-01-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c
      zend_interfaces.h:
      - Export struct zend_user_iterator
      - Ad 'it' to function prefix to prevent naming clashes
      - Export zend_user_it_free_current

2004-01-25  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c:
      Fixed bug #26814 (On parse error include included file, terminate
      execution script).

2004-01-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_iterators.c
      zend_iterators.h:
      Respect proeprty visibility in foreach

    * tests/bug26696.phpt:
      Update test

2004-01-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute_API.c:
      Switch from ZEND_ACC_DYNAMIC to ZEND_ACC_ALLOW_STATIC and disallow calling
      internal non-static methods statically.

2004-01-24  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_execute.c
      zend_execute_API.c:
      Change message as proposed by Jon.

2004-01-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute_API.c:
      Simplify detection of methods that must be called dynamic (with object)

    * zend_execute.c
      zend_execute_API.c:
      Disallow calling __clone/__construct/__destruct static
      Send an E_STRICT when calling a non static method static

    * zend_API.c
      zend_compile.c
      zend_compile.h:
      Disallow static declaration of clone

2004-01-23  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_constants.h
      zend_ini.h:
      Silence some compile warnings

2004-01-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Fix internal access to exception properties

2004-01-19  Andi Gutmans  <andi@zend.com>

    * zend_execute.c
      zend_execute.h:
      - Hopefully fix bug #26696.
      - Please let me know if hell-breaks loose

2004-01-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h:
      Add zend_get_module_started() to quickly check whether a module is present
      and its MINIT function has been called.

2004-01-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.h
      zend_execute_API.c:
      Improove debug capabilities

    * zend_reflection_api.c:
      Fix some casing issues

2004-01-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      

    * zend_interfaces.c:
      Fix inheritance rule for interface Traversable

2004-01-17  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * tests/bug26802.phpt:
      - Renamed all *php4* files to *php5*, changed all php4/PHP4 to php5/PHP5

2004-01-17  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_object_handlers.c
      zend_object_handlers.h:
      Expose zend_std_call_user_call(), needed for implementation of things like
      __call handlers.

2004-01-17  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_compile.c
      zend_language_scanner.h
      zend_language_scanner.l:
      Nuke compile warning by using the LANG_SCNG macro instead

2004-01-16  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_reflection_api.c:
      - Fixed bug #26640 (__autoload() not invoked by Reflection classes)
      

2004-01-15  Zeev Suraski  <zeev@zend.com>

    * zend.c:
      Nice patch Christian, but it wasn't at all enabled? :)
      
      Fix bug #26883

2004-01-14  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Don't allow interfaces to implement anything

2004-01-14  Andi Gutmans  <andi@zend.com>

    * zend_operators.h:
      - Remove bogus macros

2004-01-13  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_ini_parser.y:
      Don't treat strings containing : as potential constant names in
      the .ini parser.
      This fixes Bug #26893

2004-01-12  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Return the PHP 4 behavior of not allowing class declerations within
      - class declerations. This happened when declaring a class within a
      - method.
      class A {
      	function foo() {
      		class B {
      		}
      	}
      }

2004-01-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h:
      Add missing macro

2004-01-11  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_compile.c
      zend_language_scanner.h
      zend_language_scanner.l:
      TSRMLS fix

2004-01-11  Andi Gutmans  <andi@zend.com>

    * zend_language_parser.y:
      - Re-allow conditional class declerations. Needless to say that I also
      - think it's not great coding.. Use polymorphism instead :)

    * zend_compile.c
      zend_language_scanner.h
      zend_language_scanner.l:
      - This should fix the problem of conditional function decleration on the
      - same line of code not to work. You should re-evaluate your coding style
      - if you really code this way :)

2004-01-10  Zeev Suraski  <zeev@zend.com>

    * zend_operators.c:
      Remove conflict

    * zend_builtin_functions.c
      zend_execute_API.c
      zend_globals.h
      zend_operators.c:
      Added error mask to set_error_handler()
      Patch by Christian Schneider <cschneid@cschneid.com>

2004-01-09  Wez Furlong  <wez.php@thebrainroom.net>

    * acconfig.h:
      support for building asm in the unix buildsys.
      Also, when ZEND_ACCONFIG_H_NO_C_PROTOS is defined,
      omit the C prototypes from the configuration header
      so that it can be included into asm files.

2004-01-09  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * RFCs/002.txt:
      this one is declined

2004-01-09  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_object_handlers.h:
      must be extern to avoid problems with some compilers

2004-01-09  Stanislav Malyshev  <stas@zend.com>

    * tests/bug26077.phpt:
      fix expect

    * zend_compile.c:
      Bug #25816 - disallow arrays in class constants

    * tests/bug26077.phpt:
      add test

    * zend_compile.c
      zend_execute.c:
      Fix Bug #26077 - memory leak when new() result is not assigned
      and no constructor defined

2004-01-08  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * acconfig.h
      zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_alloc.c
      zend_alloc.h
      zend_builtin_functions.c
      zend_builtin_functions.h
      zend_compile.c
      zend_compile.h
      zend_config.nw.h
      zend_config.w32.h
      zend_constants.c
      zend_constants.h
      zend_default_classes.c
      zend_default_classes.h
      zend_dynamic_array.c
      zend_dynamic_array.h
      zend_errors.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_extensions.c
      zend_extensions.h
      zend_fast_cache.h
      zend_globals.h
      zend_globals_macros.h
      zend_hash.c
      zend_hash.h
      zend_highlight.c
      zend_highlight.h
      zend_indent.c
      zend_indent.h
      zend_ini.c
      zend_ini.h
      zend_ini_scanner.h
      zend_interfaces.c
      zend_interfaces.h
      zend_istdiostream.h
      zend_iterators.c
      zend_iterators.h
      zend_language_scanner.h
      zend_list.c
      zend_list.h
      zend_llist.c
      zend_llist.h
      zend_mm.c
      zend_mm.h
      zend_modules.h
      zend_multibyte.c
      zend_multibyte.h
      zend_multiply.h
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects.c
      zend_objects.h
      zend_objects_API.c
      zend_objects_API.h
      zend_opcode.c
      zend_operators.c
      zend_operators.h
      zend_ptr_stack.c
      zend_ptr_stack.h
      zend_qsort.c
      zend_qsort.h
      zend_reflection_api.c
      zend_reflection_api.h
      zend_sprintf.c
      zend_stack.c
      zend_stack.h
      zend_static_allocator.c
      zend_static_allocator.h
      zend_stream.c
      zend_stream.h
      zend_ts_hash.c
      zend_ts_hash.h
      zend_types.h
      zend_variables.c
      zend_variables.h:
      - Happy new year and PHP 5 for rest of the files too..

2004-01-08  Andi Gutmans  <andi@zend.com>

    * zend_ini_parser.y
      zend_ini_scanner.l
      zend_language_parser.y
      zend_language_scanner.l:
      -   - A belated happy holidays (by two years)

2004-01-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Reimplement part of Bug #24608 that was reverted too

    * zend_execute.c:
      Revert patch that allowed to call sttaic methods via $method()

2004-01-06  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_mm.c:
      Check if realloc() succeeds or not. (Noticed by Andrey)

2004-01-06  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug26802.phpt:
      Update

2004-01-05  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      tests/bug26802.phpt:
      Fixed bug #26802

    * tests/bug26802.phpt:
      Fix test

    * tests/bug26801.phpt
      tests/bug26802.phpt:
      Add new test

    * tests/bug26696.phpt:
      Update test

2004-01-05  Stanislav Malyshev  <stas@zend.com>

    * zend_API.c:
      Fix bug #26543 - check parent:: and self:: in class names

    * zend_execute.c
      zend_object_handlers.c:
      Bug #24608 - fix interaction between __accessors and get_property_ptr

2004-01-03  Derick Rethans  <php@derickrethans.nl>

    * zend.c
      zend_API.c
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_object_handlers.c
      zend_reflection_api.c:
      - Fixed var_export() to show public, protected and private modifiers
      properly.
      - Exported (un)mangle_property_name.

2004-01-02  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_default_classes.c:
      Do not show exception message if it's empty.
      

2003-12-31  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_default_classes.c:
      Make default message look better.

2003-12-30  Andi Gutmans  <andi@zend.com>

    * ZEND_CHANGES:
      - Fix typos

2003-12-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES:
      Update

2003-12-30  Ilia Alshanetsky  <ilia@prohost.org>

    * tests/bug26696.phpt:
      Added test case for bug #26696.

2003-12-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Fix (string) conversion

    * zend.c:
      Add missing notice

    * zend_execute_API.c:
      Fix __autoload() with derived classes

2003-12-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      WS

    * zend_API.h
      zend_compile.c:
      Fix order of class_entry member initialization (needed for example for DOM)

2003-12-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_parser.y:
      Fixed bug #26065 (Crash when nesting classes)

    * tests/bug26698.phpt:
      Add new test

    * zend_objects.c:
      Simplify

    * zend_object_handlers.c:
      Fix __tostring() and concatenation

2003-12-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_execute.c:
      Fix warning

2003-12-25  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_highlight.c:
      Fixed Bug #26703 (Certain characters inside strings incorrectly treated as
      keywords). Original patch by vrana@php.net.

2003-12-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c
      zend_execute_API.c
      zend_globals.h
      tests/bug26697.phpt:
      Fixed bug #26697 (calling class_exists on a nonexistent class in __autoload
      results in segfault).

2003-12-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/bug26229.phpt
      tests/bug26695.phpt:
      Add more tests

    * tests/bug24884.phpt
      tests/bug26166.phpt:
      Fix tests now that class names are shown in correct casing

    * zend_compile.c:
      Preserve class name casing.

    * zend_reflection_api.c:
      Fixed bug #26695 (Reflection API does not recognize mixed-case class hints)

    * zend_object_handlers.c:
      Fixed bug #26675 (Segfault on ArrayAccess use)
      Update NEWS

2003-12-22  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_API.c
      zend_API.h
      zend_object_handlers.c
      zend_object_handlers.h:
      export these symbols for use by SPL as a shared extension

2003-12-19  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0b3RC2)
      zend_language_parser.y:
      - Nuke another rule (thanks to Jan for noticing this)

2003-12-19  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_0_0b3RC2)
      zend.c:
      Bug #25547 (error_handler and array index with function call) was fixed
      tests/lang/bug25547.phpt

2003-12-19  Andi Gutmans  <andi@zend.com>

    * zend_language_parser.y:
      - Nuke unused code

2003-12-19  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_0_0b3RC2)
      zend_execute.c:
      Error reporting on unset string offset was added (Bug #24773
      Zend/tests/bug24773.phpt)

    * zend_execute.c:
      Assign_op operators (+=) were fixed for elements of overloaded objects

2003-12-18  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Nuke C++ comment

    * zend_execute.c:
      - Revert patch 1.566

2003-12-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h:
      Fixed bug #24837 Incorrect behaviour of PPP using foreach.

2003-12-17  Zeev Suraski  <zeev@zend.com>

    * (php_5_0_0b3RC1)
      zend_execute.c:
      This part of the if was necessary after all.
      Refix bug #22510

2003-12-17  Dmitry Stogov  <dmitry@zend.com>

    * (php_5_0_0b3RC1)
      zend_execute_API.c:
      -** empty log message ***

    * (php_5_0_0b3RC1)
      zend_compile.c:
      Dynamic function call from object's property was fixed
      (See "tests/lang/bug24926.phpt" and "tests/lang/bug25652.phpt")

    * zend_execute_API.c:
      Access to globals/autoglobals from class __destructor was fixed.
      (see "tests/lang/bug24908.phpt" and
      "tests/classes/destructor_and_globals.phpt")

2003-12-16  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_compile.h
      zend_object_handlers.h
      zend_stream.h:
      Sync: Export externally used functions.

2003-12-16  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c:
      export class initialization function

    * zend_object_handlers.c:
      export externally used functions

    * zend_stream.c:
      export function

2003-12-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c
      zend_object_handlers.c
      zend_object_handlers.h:
      Reenable __tostring() magic for print,echo,concatenation,function naming...
      but not for other internal things.

2003-12-15  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_execute.c:
      ws + cs (no c++ comments in c code)

2003-12-15  Dmitry Stogov  <dmitry@zend.com>

    * zend_execute.c:
      Bug #24773 was fixed (Zend/tests/bug24773.phpt)
      Assign_op operators (+=) were fixed for elements of overloaded objects
      Memory leaks during accessing ptoperies/elements of overloaded objects
      were fixed

    * zend_execute_API.c
      zend_reflection_api.c:
      Memory corruptions were fixed in zend_str_tolower_copy()

2003-12-14  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute.h:
      Fix behavior of return-by-reference functions.  Remove erroneous warnings,
      add E_STRICT warnings in case you return something by reference that
      you're
      not supposed to (anything that's not a variable, or a return-value of a
      function that returned by reference).

    * zend.h
      zend_execute.c
      zend_execute.h:
      Some cleanup

2003-12-13  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_operators.c:
      Fixes for POSIX compliancy.

2003-12-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      Free is needed in non ZTS too

    * zend.c:
      Fix memleaks in ZTS mode

    * zend.c:
      Fix memleaks

2003-12-12  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_constants.c:
      Do not copy extra byte.

2003-12-11  Ilia Alshanetsky  <ilia@prohost.org>

    * zend.h:
      Fixed extra byte allocation for TRUE/FALSE/ZEND_THREAD_SAFE/NULL constants.

2003-12-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      Bugfix: #26591 [NEW]: "__autoload threw an exception" during an uncaught
      Exception

2003-12-11  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Refix bug #24773

2003-12-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_object_handlers.c:
      Handle getter failure and allow to bypass thrown exceptions.

    * zend_execute.c:
      read_dimension() handler might return 0, handle this.

2003-12-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      Do not double copy the string

2003-12-09  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * zend_operators.c
      zend_operators.h:
      - Brought ext/bcmath to the new millennium

2003-12-09  Andi Gutmans  <andi@zend.com>

    * zend_constants.c:
      - Fix overallocation (thanks to Ilia)

2003-12-08  Derick Rethans  <php@derickrethans.nl>

    * zend_builtin_functions.c:
      - Make it compile again

2003-12-07  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c:
      Apply Andrey Hristov's patch adding get_declared_interfaces()

2003-12-06  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      This test is against interfaces not abstract classes.

    * zend_default_classes.c:
      Show the exception message again after __toString() magic has been dropped.

2003-12-05  Andi Gutmans  <andi@zend.com>

    * zend_compile.c
      zend_execute.c:
      - Remove two unneeded convert_to_string() (found by Marcus)
      - Change illegal use of string offset to E_ERROR

2003-12-05  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_default_classes.c:
      Fixed crash demonstrated with ext/dom/tests/dom003.phpt test case.

2003-12-04  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_execute.c:
      Revert crap.

    * zend_execute.c:
      Raise error in case dereference is performed on a scalar value.

2003-12-03  Ilia Alshanetsky  <ilia@prohost.org>

    * tests/bug24773.phpt:
      Test case for bug #24773.

2003-12-03  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_execute.c:
      This kind of error should be caught. (suggested by Andi, thanks)

    * zend_execute.c:
      Fix bug #24773 (unset()ing string offsets crashes PHP)

2003-12-03  Derick Rethans  <php@derickrethans.nl>

    * zend_execute.c:
      - Remove newline from error message

2003-12-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_object_handlers.c:
      Remove automatic call to __toString() since it is supposed to cause too
      much trouble. See discussion on the mailing list.

2003-12-02  Andi Gutmans  <andi@zend.com>

    * zend_API.c
      zend_operators.c:
      - Revert the revert of these patches. This overloading can only be used
      - by C extensions such as SimpleXML and *NOT* PHP code. Reasons given
      - on the mailing list and problem with reentrancy inside the opcodes.

    * zend_compile.c:
      - Fix for bug #26182

    * zend_errors.h:
      - Don't include E_STRICT in E_ALL.

2003-12-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h:
      Free the zval container only if it should be freed and was not copied.

2003-12-01  Andi Gutmans  <andi@zend.com>

    * zend_execute.c:
      - Change to E_STRICT so as not to break existing scripts.
      - Thanks Edin

    * zend_builtin_functions.c:
      - Nuke property_exists(). We need to fix isset() and this is already
      - supported in reflection API. In any case, it's best not to add new
      - functions in the general namespace except for keeping engine consistency
      (which would have been true in this case)

    * zend_API.c:
      - Revert auto-conversion in parameter API

    * zend_operators.c:
      - Don't automatically call __toString() in convert_to_string_ex().
      - use __toString() in your code.
      - Keep the auto-case in make_printable_zval.

2003-11-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Check return value of exception::__tostring()

    * tests/bug20240.phpt:
      Fix test

2003-11-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_iterators.c:
      Fix memleak

2003-11-29  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_highlight.c
      zend_language_scanner.l:
      Fixed bug #26463 (Incorrect handling of semicolons after heredoc)

2003-11-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h:
      This takes the address of a zval ptr

    * zend_API.h:
      Add macros to return values of other zvals.
      This is needed because one cannot use REPLACE_ZVAL_VALUE with
      return_value.

2003-11-29  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c:
      Restore original patch for bug #26281.
      

2003-11-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Revert accidential commit until decision

    * zend_compile.c
      zend_default_classes.c:
      Make exception code more robust:
      - Fix error in calculation of trace-string length
      - Allow to overload __strostring() and make it work for uncaught
      exceptions
      - Show exception thrown while displaying exceptions

2003-11-28  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_API.c:
      Add removed lcname, it is still needed.

2003-11-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Convert objects to string if string is required by newer parameter parsing
      since we do this for older parameter parsing does so too.

    * zend_object_handlers.c:
      The macro REPLACE_ZVAL_VALUE cannot be used since we only have zval *
      writeobj. to allow it the api needs to be changed to zval **writeobj.

    * zend_builtin_functions.c:
      Add a support function to check for property existance which is different
      from checking a property from being empty/set.
      Update test #26182.

2003-11-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_interfaces.c
      zend_interfaces.h
      zend_object_handlers.c
      zend_operators.c
      zend_operators.h:
      Add new interface ArrayAccess to use objects as Arrays

2003-11-24  Andi Gutmans  <andi@zend.com>

    * zend_constants.c:
      - Fix newly introduced bug which stopped class constants from working.
      - Thanks to Jan Lehnardt for reporting it.

2003-11-24  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * RFCs/004.txt:
      No longer needed.

2003-11-24  Andi Gutmans  <andi@zend.com>

    * zend_API.c
      zend_builtin_functions.c
      zend_compile.c
      zend_compile.h
      zend_constants.c
      zend_execute.c
      zend_execute_API.c
      zend_reflection_api.c:
      - Fix __autoload() to preserve class case.
      - Heads up, this patch might break stuff so please let me know if you
      - bump into any problems.

2003-11-23  Andi Gutmans  <andi@zend.com>

    * zend_reflection_api.c:
      - Allocation optimizations by Timm Friebe

2003-11-21  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c:
      Cleaner patch for bug #26281.

2003-11-19  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute.c
      tests/bug26281.phpt:
      Possible fix for bug #26281 & test case.

2003-11-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h:
      Add method alias macro

2003-11-18  Andi Gutmans  <andi@zend.com>

    * zend.c
      zend_builtin_functions.c
      zend_constants.c
      zend_errors.h
      zend_language_parser.y:
      - Add E_STRICT, to be used to warn purists (like Jani :)

2003-11-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Backpatch the correct opcode for list(), property overloading needs more
      opcodes (Bugfix #26257).

    * zend_interfaces.c:
      Use correct order

    * zend_interfaces.c:
      Use correct macro/function

2003-11-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      Correct destruction

2003-11-13  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_operators.c:
      Bugfix #26156 (REPLACE_ZVAL_VALUE works on uninit stack-based zvals)

2003-11-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES
      zend_interfaces.c:
      IteratorAggregate::getIterator() cannot return anythingy else than objects

2003-11-13  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Make sure internal clasess are malloced

2003-11-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_iterators.c:
      Don't use zend_class_entry indirection

    * zend_builtin_functions.c:
      Bugfix #26010 (Bug on get_object_vars() function)

    * zend_object_handlers.c:
      Correct default handlers

    * zend_iterators.c:
      Need to update iterators handler table too.

    * zend_execute.c
      zend_object_handlers.c:
      Fix those warnings

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects_API.c:
      Split isset/isempty for object property and object dimension hooking.

    * zend_interfaces.c:
      Little iterator improvement: ability to store index in iterator

2003-11-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Add method reflection_class::implementsInterface()
      Allow string & reflection_class in isSubclassOf()

    * zend_reflection_api.c:
      Fix reflection_class::isSubclassOf()

    * zend.c
      zend_object_handlers.c
      zend_operators.c
      tests/bug26166.phpt:
      Handle exceptions in casting more gracefully.
      This fixes bug #26166

2003-11-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      Make __autoload() faster

    * zend_execute.c
      zend_iterators.h:
      Update Iterators: Call next at the correct point in time.

    * zend_compile.c:
      Add missing initialization.

    * zend_interfaces.h:
      Make these class entries available for inheriting classes

2003-11-06  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_operators.c:
      Fixed bug #26148 (Print the notice before modifying variable on type
      mismatch).
      
      
      Patch by: morten-bugs dot php dot net at afdelingp dot dk

2003-11-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c
      zend_interfaces.c:
      Prevent some SEGV's when Exceptions are thorown inside iterators.

    * zend_builtin_functions.c:
      Removedouble efree call

2003-11-04  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_object_handlers.c:
      __tostring() handler should be binary-safe

    * tests/bug26010.phpt:
      Fix one more test

2003-11-04  Stanislav Malyshev  <stas@zend.com>

    * Makefile.am:
      add zend_iterators.c zend_interfaces.c to make

2003-10-31  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * tests/bug26010.phpt:
      Add test case for bug #26010

2003-10-30  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c:
      make CATCH opcode use "class" T like other opcodes do - via IS_CONST

2003-10-30  Andi Gutmans  <andi@zend.com>

    * (php_5_0_0b2)
      ZEND_CHANGES:
      - Beta 2

2003-10-29  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_operators.h:
      Use pretty macro instead.

2003-10-28  Andi Gutmans  <andi@zend.com>

    * zend_language_parser.y:
      - Head up! I'm reverting the patch which allows for expressions in constant
      - declerations. Allowing the access of other constants in this code is
      - flawed. We are reverting back to PHP 4's static scalars.
      - Don't worry if you get the following msg when compiling:
      - "zend_language_parser.y contains 3 useless nonterminals and 22 useless
      rules"
      - I didn't nuke the code in case we have some brilliant ideas after beta 2

2003-10-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_interfaces.c:
      Give some freedon to c iterators but not in userspace.

2003-10-28  Shane Caraveo  <shane@caraveo.com>

    * zend_compile.c:
      fix crash in do_implement_interface when compiling
      pear/PHPUnit/Framework/TestCase.php line 63
      while only interface_gets_implemented is the issue in this instance, both
      these vars were unitialized, causing potential other issues

2003-10-25  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h:
      Add zend_make_callable() which allows to make zval's callable zval's.
      At the moment this function only converts strings of the form
      class::method
      to an array(class,method).

    * zend_default_classes.c
      zend_reflection_api.c:
      This forces a better error message for non working clone calls.

    * zend_default_classes.c:
      And use things to throw an exception here

    * zend_default_classes.c:
      You shall not clone Exception instances

    * zend_reflection_api.c:
      You shall not clone reflection_xx instances

    * ZEND_CHANGES
      ZEND_CHANGES:
      Update

2003-10-25  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * ZEND_CHANGES:
      Fugbix typo.

    * ZEND_CHANGES:
      s/Throwable/Printable: Exception has become an internal class since I
      initially documented interfaces.

2003-10-24  Andi Gutmans  <andi@zend.com>

    * ZEND_CHANGES:
      - Fix typo

2003-10-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_execute_API.c:
      Revert accidental commit

    * ZEND_CHANGES
      zend_API.c
      zend_execute_API.c:
      Zend/ZEND_CHANGES

2003-10-23  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * Zend.dsp
      ZendTS.dsp:
      Add zend_interfaces.{c|h}.

2003-10-22  Ilia Alshanetsky  <ilia@prohost.org>

    * zend.c:
      Fixed bug #25922 (Crash in error handler when 5th argument is modified).

2003-10-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c
      zend_interfaces.c
      zend_interfaces.h:
      Impement userspace iterator interfaces and tests. See tests for details
      on the names.

    * zend.h
      zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h
      zend_execute.c:
      Expand Interface C API.
      In short: zend_class_entry->interface_gets_implemented()  allows to modify
      the class entry of a class when an interface gets implemented.

    * zend_default_classes.c:
      The string conversion method should be named __toString()

2003-10-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES:
      Make this clear

2003-10-20  Andi Gutmans  <andi@zend.com>

    * ZEND_CHANGES:
      - Add comment from Timm

2003-10-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZEND_CHANGES
      ZEND_CHANGES:
      Update

2003-10-19  Andi Gutmans  <andi@zend.com>

    * zend_language_parser.y:
      - Nuke const in function parameters. I just can't remember why this exists
      - and it seems no one else remembers either. It has no semantic meaning.

2003-10-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.h
      zend_API.h
      zend_compile.c
      zend_iterators.h:
      Fix class/iterator relationship & handling

    * zend_iterators.c:
      Fallback to old behavior until we have a default iterator that respects
      visibility we do the array trick.

    * zend_iterators.h:
      Change order: Optional rewind() to end of structure

2003-10-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * ZendTS.dsp:
      WS

    * zend_reflection_api.c:
      Show if a class/object is iterateable

    * ZendTS.dsp
      zend.h
      zend_API.h
      zend_default_classes.c
      zend_execute.c
      zend_iterators.c
      zend_iterators.h:
      Added c-api for iterators

    * zend_reflection_api.c:
      Fix showing final/abstract for classes

2003-10-17  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_ini_parser.y:
      Fixed formatting issue.

    * zend_alloc.c:
      Fixed if() condition.

2003-10-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h:
      Add oo support function zend_class_implements()

    * zend_default_classes.c:
      Fix cast function

2003-10-14  Andi Gutmans  <andi@zend.com>

    * zend_mm.c:
      - Argh, the suffering copy&paste can cause

    * zend_alloc.c:
      - Fix compile problem.

    * zend_mm.c:
      - Fix the fix by making sure the new block is in the right free list.

2003-10-14  Stanislav Malyshev  <stas@zend.com>

    * zend_execute_API.c:
      The freed one is a hashtable - may matter if Hashtables are allocated
      differently

2003-10-14  Andi Gutmans  <andi@zend.com>

    * zend_mm.c:
      - Support merging free block which was created by reallocing to smaller
      - size. This should fix some performance issues. This code is still not
      - thoroughly tested.

2003-10-09  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_execute.c
      zend_language_parser.y:
      Allow foo::$bar()

2003-10-07  Rasmus Lerdorf  <rasmus@lerdorf.com>

    * Zend.m4:
      MFB bison configure test fix

2003-10-07  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix bug #17997 (Warning when switch & reference are combined)

    * zend_ini_parser.y:
      Fix the fix :)
      Not thoroughly tested, but appears to work fine

2003-10-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_ini_parser.y:
      Bugfix #25770 Segfault with PHP and bison 1.875

2003-10-05  Zeev Suraski  <zeev@zend.com>

    * zend_object_handlers.c:
      Remove unused callback

    * zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects_API.c:
      Remove redundant callback, simplify API

2003-10-05  Shane Caraveo  <shane@caraveo.com>

    * (BEFORE_HANDLERS_RESHUFFLE)
      zend_API.h:
      this little piggy broke lots of things...eg. _function_check_flag in
      reflection api.

2003-10-03  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_API.c:
      Fixed bug #24766 (strange result array from unpack())

    * zend.h:
      Bug #25738 (alloca() related problems on the Darwin platform)

    * zend_API.h:
      Ensure lval to have a *boolean* value.

2003-10-03  Jani Taskinen  <jani.taskinen@kolumbus.fi>

    * Zend.m4:
      Aligned configure help texts.

2003-09-30  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_compile.c:
      Remove redundant '\n'

2003-09-26  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * zend_alloc.c:
      signed/unsigned compiler warning fixes

2003-09-25  Georg Richter  <phpinfo@t-online.de>

    * zend_alloc.c:
      fixed compiler warning
      removed dead code

    * zend_hash.h:
      changed ulong to long to avoid compiler warnings (comparison between signed
      and unsigned)

2003-09-22  Ilia Alshanetsky  <ilia@prohost.org>

    * zend.c
      zend_language_scanner.l:
      Added missing format.

2003-09-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Add public array Reflection_Class::getDefaultProperties()

2003-09-18  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c:
      Nuke vars no longer needed

    * zend_builtin_functions.c
      zend_reflection_api.c:
      Go with studlyCaps

    * zend_reflection_api.c:
      Change tostring() into __toString() to match method name used in casting.

    * zend.c
      zend_operators.c:
      Fallback to default behaviour for unsupported object type conversions

    * zend_object_handlers.c
      zend_object_handlers.h
      zend_operators.c:
      - Allow partial type conversion support for objects.
      - Add support for object to string conversion from userspace by method
        __toString() and add a test.

    * zend_API.c:
      Add missing check

2003-09-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_execute.c:
      Show name of missing function as typed

    * zend_default_classes.c:
      Use studlyCaps in exception class

    * zend_compile.c:
      Go with studlyCaps in error messages/backtrace/reflection output

2003-09-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      - Make it clear whether it is an interface or a class
      - Fix static properties

2003-09-15  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Revert - need to look for a better solution

    * zend_execute.c:
      Bugfix #25547

2003-09-15  Zeev Suraski  <zeev@zend.com>

    * zend_operators.c:
      Simplify / fix

2003-09-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      Bugfix #25335

2003-09-14  Zeev Suraski  <zeev@zend.com>

    * zend_operators.c:
      Commit 64-bit fixes to the standard operators
      by Ard Biesheuvel (abies@php.net)

2003-09-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.h:
      Bugfix #25528 (by Ard Biesheuvel)

2003-09-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_alloc.c:
      Fix warnings

2003-09-11  Stanislav Malyshev  <stas@zend.com>

    * tests/dtor_scope.phpt:
      add test

    * zend_execute_API.c:
      ws

    * zend_execute_API.c:
      Use scope from method, not from object

2003-09-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Use type instead of constant

2003-09-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Fix property inheritance where a derived class inherits a public property
      and owns it as an implicit public property already (noticed by Brad).

    * zend.c:
      Fix registering/derigistering of stdClass in ZTS and NON ZTS mode

2003-09-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Fix foreach() called with non array

2003-09-07  Stanislav Malyshev  <stas@zend.com>

    * Zend.m4:
      check for mach-o/dyld.h - needed for non-PHP ZE build

2003-09-06  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Disallow to changing the backtrace

    * zend_reflection_api.c:
      Add missing newline if no static methods are available

    * zend_reflection_api.c:
      - Internal functions shall be static
      - Fix more nesting

    * zend_reflection_api.c:
      Fix logic

    * zend_reflection_api.c:
      - Fix CS: {{{ / }}}
      - Fix static reflection_*::export()
      - Add class reflection_object which allows to show dynamic properties

    * zend_reflection_api.c:
      Use %s where it makes more sense

2003-09-05  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Simplify reflection_property::__constructor() and fix property factory

    * zend_reflection_api.c:
      - Don't use resorved words as variable names.
      - Improve several exception messages.
      - Fix Reflection_Property::_construct() / getDeclaringClass()

    * zend_reflection_api.c:
      Fix reflection_api::__construct() (noticed by Andrey)

    * zend_default_classes.c:
      Provide string casting for exceptions by calling toString()

2003-09-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_execute.c
      zend_object_handlers.c:
      Tests show updating consts must happen once at runtime (revert
      optimization).
      Add tests for static properties.

    * zend_reflection_api.c:
      Add reflection_class::getstaticproerties()

2003-09-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Partly revert and reintroduce hash table entries for the ctor.

    * zend_compile.c:
      Nuke unused variable, too

    * zend_compile.c:
      - Inheritance applies to __clone() too.
      - No need to add additional functions for the constructor.
        The handler uses the pointer as intended and doesn't look the the name.

    * zend_compile.c:
      Cannot turn a static property into a non static one and vice versa

    * zend_API.c
      zend_API.h
      zend_compile.c
      zend_default_classes.c:
      Fix handling of static properties initialized to arrays

    * zend_compile.c:
      Add missing error messages when violating static property inheritance
      rules.

    * zend_API.c
      zend_compile.c
      zend_execute.c
      zend_object_handlers.c:
      Fix static properties.

    * zend_compile.c:
      Allow redeclareing a protected property as public.

2003-09-03  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Revert bogus patch
      One must *never* use E_CORE_* error levels!

2003-09-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Clearly distinguish between Const, Static and Other members.

2003-09-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Fix error messages

    * zend_API.c:
      Allow redeclaring of protected properties as public (for internal classes).

    * zend_reflection_api.c:
      Use appropriate function for property name unmangling.

    * zend_reflection_api.c:
      Make these static as noticed by Andrey

    * zend_execute.c
      zend_object_handlers.c
      zend_objects.c:
      Synch/Unify error messages related to function/method calls

    * zend_compile.c:
      Fix error level

    * zend_API.c
      zend_compile.c:
      Currently we cannot support static ctor/dtor

    * zend_reflection_api.c:
      These are implicit properties as denoted by the flag. Dynamic properties
      only
      exist in one single object and currently reflection api is not capable of
      showing those.

2003-08-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Don't repeat first const count(consts) time

    * zend_reflection_api.c:
      Beautify output

    * zend_reflection_api.c:
      Add reflection_parameters, patch by Timm Friebe

    * zend_default_classes.c:
      Excluded chars < 32 when displaying string parameters that would obliterate
      output.

2003-08-31  Zeev Suraski  <zeev@zend.com>

    * zend_arg_defs.c
      zend_builtin_functions.c
      zend_modules.h:
      Attempt at fixing the linkage problem in Win32

2003-08-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Synch error message with other one to fix tests

    * zend_reflection_api.c:
      Check whether we may access tat union

    * zend.c:
      Revisited: Replace the non portable code by spprintf

    * zend_reflection_api.c:
      Using zend_spprintf should be faster here

    * zend.c
      zend.h
      zend_default_classes.c:
      Make vspprintf available as zend utility function. Use it in exception
      output.

2003-08-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Actually fetch the parameter

    * zend_default_classes.c
      zend_default_classes.h
      zend_execute.c
      zend_reflection_api.c:
      - Calling abstract methods should be a error for consistency reason.
      - So in reflection_api we use the reflection_exception again.

2003-08-30  Andi Gutmans  <andi@zend.com>

    * zend_default_classes.c:
      - PLEASE stop commiting ^M's

2003-08-30  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Even though it is ignored this should be correct

    * zend_default_classes.c:
      Add frame numer and finally display stack trace in the message.

    * zend_default_classes.c:
      Add exception::traceAsString() and exception::toString()

    * zend_reflection_api.c:
      fci.function_table & fci.function_name are not needed since we use
      zend_fcall_info_cache

    * zend_reflection_api.c:
      Be precise

    * zend_reflection_api.c:
      Actually using fcc would be a good idea

    * zend_default_classes.c
      zend_default_classes.h
      zend_execute.c:
      - The compiler can't detect all abstract function calls so we need to
      check.

    * zend_default_classes.c:
      Make those final (see comment)

2003-08-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h:
      - Add zend_merge_properties() which is designed to serve *_fetch_object().
      - Explain drawbacks of object_and_properties_init and
      zend_merge_properties.

    * zend_reflection_api.c:
      - Use zend_fcall_info_cache in invoke() to improve speed.

2003-08-29  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Fix a problem in implicit public properties and inheritance

2003-08-29  Sascha Schumann  <sascha@schumann.cx>

    * zend_hash.c:
      improve a number of zend_debug format strings

2003-08-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_builtin_functions.c
      zend_builtin_functions.h
      zend_default_classes.c:
      Need to tell zend_fetch_debug_backtrace() whether to skip top function or
      not.

2003-08-28  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c:
      Add public read access to protected

    * zend_default_classes.c
      zend_default_classes.h:
      Add zend_throw_exception_ex() which allows to format exception messages.

    * zend.c:
      Classe tables work this way

    * zend_builtin_functions.c
      zend_builtin_functions.h
      zend_default_classes.c:
      - Split debug_backtrace() into lowlevel c function and php function wrapper
      - Add trace property to default method based on new
      zend_fetch_debug_backtrace

2003-08-28  Sascha Schumann  <sascha@schumann.cx>

    * zend.h:
      older gccs don't understand attribute((format)) on function pointers

    * zend.h:
      ZEND_GCC_VERSION should always be defined to a number so we can use
      simple comparisons all the time.

    * zend.h
      zend_alloc.c
      zend_builtin_functions.c
      zend_compile.c
      zend_execute.c:
      Add format attribute to a number of functions
      
      Kill a few warnings

    * zend.h
      zend_alloc.h:
      cleanup & centralize ZEND_GCC_VERSION and ZEND_ATTRIBUTE_MALLOC so that
      they can be used by downstream applications

    * zend_alloc.h:
      Enable attribute((malloc)) for GCC 2.96

    * zend_alloc.h:
      GCC 2 does not know about malloc yet.

    * zend_alloc.h:
      provide attribute((malloc)) where appropiate

2003-08-27  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Nuke unused variable

    * zend_reflection_api.c:
      Fix reflection_class::newInstance()

2003-08-25  Jani Taskinen  <sniper@iki.fi>

    * zend.h:
      - Fixed bug #25240 (spaces before pre-processor directives)

2003-08-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Add missing check

    * zend_API.c:
      Fix memory source of string duplication for non internal properties

    * zend_API.c
      zend_API.h
      zend_compile.c
      zend_default_classes.c
      zend_execute_API.c
      zend_variables.c
      zend_variables.h:
      - Provide appropriate way to destroy internal zval's.
      - Allow internal zval's of type string and disallow complex types.
      - Define the default string for extensions at class level instead of ctor.

    * zend_API.h
      zend_compile.h
      zend_reflection_api.c:
      Don't identify alias'ed functions

2003-08-24  Zeev Suraski  <zeev@zend.com>

    * zend_API.c:
      Use ""'s if you want empty strings.  We want to crash on errors.

    * zend_compile.c:
      Use pemalloc()

2003-08-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Allow NULL, too

2003-08-24  Zeev Suraski  <zeev@zend.com>

    * zend_API.c:
      Get rid of more ^M's - Marcus, please check your CVS client!

    * zend_default_classes.c:
      Get rid of more ^M's

    * zend_compile.c:
      line endings fix

    * zend_execute.c:
      Never, ever, overwrite the refcount element of a connected zval!

2003-08-24  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Add dedicated reflection_exception

    * zend_default_classes.c
      zend_default_classes.h:
      Allow to throw instances of classes derived from exception

    * zend.c
      zend_default_classes.c
      zend_default_classes.h
      zend_execute.h
      zend_execute_API.c:
      - Provide a unified way to display uncaught exceptions, which shows
        file/line/message info if possible.
      - Add zend_eval_string_ex() to be able to handle exceptions in eval'd
      code.
      - Use above function to fix memleaks in CLI.

    * zend_reflection_api.c:
      Make invoke() work

    * zend_reflection_api.c:
      zend_parse_parameters 'O' works the way we need here

    * zend_reflection_api.c:
      Not needed

    * zend_default_classes.c:
      Make use method macros

    * zend_API.h:
      One of PPP is needed, too

    * zend_reflection_api.c:
      - Add Reflection_Function::isAlias
      - Use ZEND_ME/ZEND_METHOD
      - Fix static entries

    * zend_API.h
      zend_compile.h:
      - Add fn_flag ZEND_ACC_ALIAS
      - Unify way of function_entry generation by new macro ZEND_FENTRY

    * zend_API.c:
      Fix fn_flags handling

    * zend_API.c
      zend_API.h
      zend_default_classes.c:
      Add property read code and use that in default exception class

2003-08-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c
      zend_default_classes.h
      zend_reflection_api.c:
      Allow zend_throw_exception() to also set the exception code

    * zend_default_classes.c:
      Exception has 4 protected default properties (message,code,file,line).
      They are all initialized at c-level constructor correctly.

    * zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h:
      Internal classes can now have default properties.

    * zend_reflection_api.c:
      Show ctor/dtor information and those don't return anything

    * zend_API.c
      zend_compile.c
      zend_compile.h
      zend_execute.c:
      - Flag ctor/dtor methods
      - Use this to prevent memleaks when an exception gets thrown in ctors.

    * zend_default_classes.c:
      Make exception code more robust

2003-08-22  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_builtin_functions.c
      zend_constants.h:
      Replace *magic number* with a much nicer define.

    * zend_builtin_functions.c:
      Set 2147483647 as the module number of user defined constants
      Fixed a few bugs and cleaned up get_defined_constants().

2003-08-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_default_classes.c
      zend_default_classes.h
      zend_reflection_api.c:
      Add function 'zend_throw_exception(char *message, int duplicate
      TSRMLS_DC);'
      to provide an easy way to throw exceptions for extension developers.

    * zend_API.c:
      If ce not given than any object would do

    * zend_API.c:
      Paramspec 'O' / zend_parse_method_params(): only if given check the class
      type

2003-08-20  Zeev Suraski  <zeev@zend.com>

    * zend_alloc.c:
      adhere to silence

2003-08-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_alloc.c:
      Fix counting number of leaks

2003-08-19  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_execute.c:
      fix build

2003-08-18  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_ini.h:
      linkage for C++

2003-08-18  Zeev Suraski  <zeev@zend.com>

    * ZendTS.dsp
      zend_execute.c
      zend_execute_locks.h:
      Prevent access to internal engine functionality

    * zend.h
      zend_alloc.c
      zend_compile.h
      zend_execute.c:
      - Improve tracking
      - Fix several overloading issues

    * zend_API.c
      zend_alloc.h
      zend_hash.c
      zend_hash.h
      zend_ts_hash.c
      zend_ts_hash.c
      zend_ts_hash.h
      zend_ts_hash.h:
      Improve tracking

    * zend_compile.c:
      ws

2003-08-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h
      zend_builtin_functions.c
      zend_execute.c
      zend_object_handlers.c
      zend_operators.c
      zend_reflection_api.c:
      Fix warnings

2003-08-17  Sascha Schumann  <sascha@schumann.cx>

    * zend.h:
      One bit fields need to be unsigned, otherwise there is no storage for
      the sign bit
      
      "A signed bit field has a length of 1 bit."

    * zend_API.h:
      explicitly cast size_t to zend_uint to avoid warnings on 64 bit platforms.

2003-08-17  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Remove unnecessary if

    * zend_execute.c:
      Put the code where it belongs - fixes a warning and confusion

    * zend_compile.c
      zend_execute.c:
      Implement a TBD: JMP to the end of foreach

    * zend_compile.c:
      WS

    * zend_API.c:
      - Show class names in error messages when dealing with methods
      - Mark class as abstract if it gets an abstract method

2003-08-16  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_API.h
      zend_reflection_api.c:
      Simplify abstract method declaration

    * zend_object_handlers.h:
      WS

2003-08-15  Sascha Schumann  <sascha@schumann.cx>

    * zend_execute.c
      zend_object_handlers.c:
      Restrict scope of inline functions to compile unit
      
      Submitted by: Jason Greene <jason@inetgurus.net>

2003-08-13  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects_API.c:
      Add missing entry

    * zend_API.c:
      - Show classes in case of methods
      - Using sprintf here was a bad idea

2003-08-12  Zeev Suraski  <zeev@zend.com>

    * zend_hash.c:
      Remove bogus patch - the number of elements is unrelated

2003-08-12  Zeev Suraski  <zeev@zend.com>

    * zend_hash.c:
      Remove bogus patch - the number of elements is unrelated

2003-08-12  Zeev Suraski  <zeev@zend.com>

    * zend_hash.c:
      Remove bogus patch - the number of elements is unrelated

2003-08-12  Zeev Suraski  <zeev@zend.com>

    * zend_hash.c:
      Remove bogus patch - the number of elements is unrelated

2003-08-12  Zeev Suraski  <zeev@zend.com>

    * zend_hash.c:
      Remove bogus patch - the number of elements is unrelated

2003-08-11  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_hash.c
      zend_hash.h:
      Bugfix 21918

2003-08-11  Masaki Fujimoto  <masaki-f@fides.dti.ne.jp>

    * Zend.m4
      flex.skl
      zend_compile.c
      zend_globals.h
      zend_highlight.c
      zend_language_scanner.h
      zend_language_scanner.l
      zend_multibyte.c
      zend_multibyte.h:
      - added script encoding support to Zend Engine 2.
        this enables ZE2 to gracefully parse scripts written in UTF-8 (with
      BOM),
        UTF-16, UTF-32, Shift_JIS, ISO-2022-JP etc... (when configured with
        '--enable-zend-multibyte' and '--enable-mbstring')

2003-08-10  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Bugfix #24637 __destruct not called

2003-08-09  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * zend_compile.c:
      Fix segfault when a referenced parameter is specified with typehint.
      Result of the node will never be used because verify_instanceof handler
      has
      been eliminated.

2003-08-09  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c:
      Precise destructor errors

2003-08-07  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * tests/bug21478.phpt:
      Add missing right parensis

2003-08-07  Zeev Suraski  <zeev@zend.com>

    * zend_execute_API.c:
      Clarify use of original_function_state_ptr

2003-08-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      - Fix warnings
      - Fix code

2003-08-06  Zeev Suraski  <zeev@zend.com>

    * zend_execute_API.c:
      clarify :)

2003-08-05  Jani Taskinen  <sniper@iki.fi>

    * zend_execute_API.c:
      Fix the build

2003-08-05  Zeev Suraski  <zeev@zend.com>

    * zend_API.h
      zend_execute_API.c
      zend_reflection_api.c:
      Try to put an end to the endless number of call_user_function variants.
      zend_call_function() now takes a structure that should contain all of the
      necessary information.  If further information is necessary in the future,
      then we'll be able to add it without having to introduce a new function.
      
      As for caching - the 2nd, optional argument is a struct that can hold all
      of the information that's necessary to invoke the function, including its
      handler, scope and object it operates on (if any).  Note that you may only
      use a cache if the arguments you provide to zend_call_function() are
      identical to the ones of the last call, except for the argument and return
      value information.
      
      
      The recently introduced fast_call_user_function() was removed
      
      I fixed most of the places that used fast_call_user_function() to use
      caching
      but there are still some that need to be fixed (XML and reflection)

2003-08-05  Stanislav Malyshev  <stas@zend.com>

    * tests/bug24699.phpt:
      fix syntax

    * zend_execute_API.c:
      remove stack clean - it makes trouble

2003-08-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Fix ZTS

    * zend_execute_API.c:
      Nuke unused variables

    * zend_reflection_api.c:
      Add function/method parameter reflection

2003-08-04  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_execute_API.c
      tests/bug23104.phpt:
      Fixed bug #23104 (hash position of static arrays not being reset)

2003-08-04  Stanislav Malyshev  <stas@zend.com>

    * zend_execute_API.c:
      oops. forgot function

    * zend_execute_API.c:
      fix crash #24842

    * zend_compile.c:
      fix leaks: bug #24831

    * zend_execute.c:
      use get_obj_zval_ptr

    * tests/bug24884.phpt:
      add test

    * zend_execute.c:
      Fix #24884 - clone $this

2003-08-04  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Simplify code using XOR

    * zend.h:
      Add logical XOR, proves to be quite useful lately

    * zend_opcode.c:
      This check shouldn't be necessary

2003-08-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_opcode.c:
      Fix crash

    * zend_compile.c:
      Fix test and add missing initialization

2003-08-03  Zeev Suraski  <zeev@zend.com>

    * zend_API.c:
      Ensure functions have a valid access level

    * zend_API.c:
      Default to public

2003-08-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Not needed, will be copied from ptr->flags later

    * zend_builtin_functions.c:
      Add missing arg info

2003-08-03  Moriyoshi Koizumi  <moriyoshi@at.wakwak.com>

    * tests/bug24635.phpt
      tests/bug24699.phpt:
      Style & WS fixes

2003-08-03  Zeev Suraski  <zeev@zend.com>

    * (BEFORE_ARG_INFO)
      zend_API.c:
      No need for this initialization - this function initializes all of the
      elements of zend_internal_function

    * (BEFORE_ARG_INFO)
      zend_execute.c:
      Clean up.  extended_value can only contain either ZEND_UNSET_DIM or
      ZEND_UNSET_OBJ.

    * (BEFORE_ARG_INFO)
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c:
      Generalize fetch_class

2003-08-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Initialize all struct members: Necessary for reflection

    * zend_reflection_api.c:
      Show interfaces

2003-08-02  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_API.c:
      fix usage of instanceof here too

2003-08-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Fix warning

2003-08-01  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_API.c:
      better fix...

    * zend_API.c:
      Fix "O" format for zend_parse_parameters

2003-07-31  Zeev Suraski  <zeev@zend.com>

    * zend_API.c:
      Use instanceof_function()

    * zend_compile.c
      zend_execute.c:
      Finish the array overloading patch

    * zend_execute.c:
      Cleanup

2003-07-31  Andi Gutmans  <andi@zend.com>

    * zend_hash.c:
      - Fix logic. It was the wrong way around.

2003-07-30  Andi Gutmans  <andi@zend.com>

    * zend_execute.c
      zend_hash.c:
      - Fix problem with hash when updating same bucket with data of different
        sizes one after another.
      - Fix number of arguments to read_dimension.

2003-07-30  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_execute.c:
      Get rid of an opcode

    * zend_compile.c
      zend_execute.c:
      Support overloading of $foo["bar"] += "baz"

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h:
      Improve array overloading - support unset($foo["bar"])

    * zend_compile.h:
      Remove garbage

    * zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_compile.h
      zend_modules.h:
      Add exec_finished() callback for modules - this is the last place where the
      modules may touch the symbol table reliably

2003-07-29  Ilia Alshanetsky  <ilia@prohost.org>

    * tests/bug22836.phpt:
      Test case for bug #22836.

2003-07-29  Jani Taskinen  <sniper@iki.fi>

    * zend.c:
      Remove the obfuscation caused by the double "#ifdef ZTS"

2003-07-27  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c:
      fix compare

    * zend_compile.c:
      use zend_binary_strncasecmp

    * zend_execute_API.c:
      change shutdown order so that dtors would coexist with object error
      handlers

    * zend_execute.c:
      clean the right one

    * zend_execute_API.c:
      make shutdown more granular so in case some dtor goes ape we still
      can shut down cleanly

    * zend_compile.c
      zend_execute.c
      zend_objects.c:
      make clone and throw coexist peacefully

    * tests/bug24635.phpt
      tests/bug24699.phpt:
      add test

    * zend_execute.c:
      fix #24635: clean hash before putting into cache

    * zend_language_scanner.l:
      fix crash #24550

    * zend_compile.c
      zend_constants.c:
      fix leaks with class constants (bug #24699)

    * zend_compile.c:
      make __clone call case insensitive, just as other calls are

2003-07-24  Jani Taskinen  <sniper@iki.fi>

    * tests/bug19859.phpt
      tests/bug20240.phpt
      tests/bug20242.phpt
      tests/bug21478.phpt
      tests/bug21888.phpt
      tests/bug22725.phpt
      tests/bug24436.phpt:
      cleanup (CS+ws)

2003-07-24  Zeev Suraski  <zeev@zend.com>

    * tests/bug24436.phpt:
      Fix expectations :)

    * zend_execute.c:
      Fix logic and comments in ASSIGN_DIM

    * zend_compile.c:
      Fix another HANDLE_NUMERIC bug.  Looks like you opened Pandora's box,
      Sterling ;)

    * zend_builtin_functions.c:
      Fix each() binary safety for keys

    * zend_execute.c:
      Fix assignments to numeric array indices

    * zend_compile.c:
      Remove useless code

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_language_parser.y:
      Support references in foreach()
      Syntax:
        foreach ($arr as &$val)
        foreach ($arr as $key => &$val)

    * zend_execute.c:
      Fix binary safety in foreach() keys (fixes bug #24783)

    * zend.c:
      Make print_r() binary safe with keys

2003-07-23  Stanislav Malyshev  <stas@zend.com>

    * zend.h
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_globals.h
      zend_opcode.c:
      Remove namespace leftovers

2003-07-23  Zeev Suraski  <zeev@zend.com>

    * zend_hash.c
      zend_hash.h:
      Go back to ZE1-like code

2003-07-23  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      Fix segfault. Patch by Timm Friebe <thekid@thekid.de>.

2003-07-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_hash.h:
      Fix for the moment

2003-07-22  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c
      zend_hash.c
      zend_hash.h
      zend_operators.c
      zend_operators.h:
      Improve infrastructure of numeric handling of elements in symbol tables.
      
      When you want to work with a symbol table, and you don't know whether you
      have a numeric ("string that looks like a number") or a string element in
      your hands, use zend_symtable_*() functions, in place of zend_hash_*()
      functions.

    * zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects_API.c:
      Fix isset()/empty() for non-trivial object elements
      (API change - read_property now accepts an extra element)
      Fixes bug #24436

2003-07-21  Zeev Suraski  <zeev@zend.com>

    * zend_object_handlers.c:
      Fix bug #24499

    * zend_execute.c:
      Revert fix for #24729, and refix

2003-07-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Go with a better fix for #24729

2003-07-21  George Schlossnagle  <george@omniti.com>

    * zend_API.h:
      reverted at Andi's request.  replaced with more generic wrapper.

2003-07-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Bugfix #24729  = new ; causes crash when  is not set

2003-07-20  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      should nt here

2003-07-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_reflection_api.c:
      Fix warnings and whitespace in output

    * zend_reflection_api.c:
      Add support for instances in Reflection_Class.

2003-07-20  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      removed references to smart_str, replaced with private string management
      function.  When snprintf is integrated into the engine, string_printf
      should be altered to use that.

2003-07-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects_API.c:
      More informative errors here and these are real core errors

    * zend_execute.c:
      Fix uncloneable objetcs

2003-07-20  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      more of Timm's implementation.

2003-07-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_hash.c
      zend_hash.h:
      Make it a macro

2003-07-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_hash.c:
      This is meant to be used in for(;has_more;next)

    * zend_hash.c
      zend_hash.h:
      Add missing function to ease implementations

2003-07-19  Jani Taskinen  <sniper@iki.fi>

    * zend.h:
      Fix the HPUX alloca fix as suggested by Sascha

2003-07-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c
      zend_objects.h:
      Shuffle code to ease writing clone handlers

2003-07-19  Andi Gutmans  <andi@zend.com>

    * zend.h:
      - Don't use alloca on HP-UX (Moriyoshi Koizumi <moriyoshi@at.wakwak.com>)

2003-07-16  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Fix bug in the verification of interface-function implementation

    * zend_compile.c
      zend_compile.h
      zend_execute.c:
      More cleanup for assign-op handling of objects

    * zend_alloc.c:
      Fix warning

2003-07-12  Andi Gutmans  <andi@zend.com>

    * zend_API.c:
      - WS

2003-07-11  Andi Gutmans  <andi@zend.com>

    * zend_API.c:
      - Add support for Z in zend_parse_parameters(). It will allow the extension
      - to retreive the zval **, thus allowing it to use the convert_to_*_ex()
      - family of functions to do type conversions without effecting the value
      in
      - the engine itself. (Josh Fuhs <fuhs@purdue.edu>)

2003-07-08  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      initial refactoring for assign-op handling of objects

2003-07-07  Zeev Suraski  <zeev@zend.com>

    * zend_API.c
      zend_API.h
      zend_compile.c
      zend_compile.h:
      Rework zend_do_declare_property and related code into one code base

    * zend_API.c:
      Fix bug

    * zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects_API.c:
      Add get_dim callback

    * zend_execute.c:
      Fix naming convention

2003-07-07  Derick Rethans  <d.rethans@jdimedia.nl>

    * zend_execute.c:
      - Help Zeev fixing ghosts :)

2003-07-07  Zeev Suraski  <zeev@zend.com>

    * zend_object_handlers.c
      zend_object_handlers.h:
      whitespace

    * zend_objects_API.c:
      Fix & whitespace

    * zend_object_handlers.c:
      fixlet

    * zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_object_handlers.c
      zend_object_handlers.h:
      Initial support for overloading of array syntax for objects (very initial)

2003-07-06  George Schlossnagle  <george@omniti.com>

    * zend_API.c
      zend_API.h:
      add convenience functions or adding class properties.  Ok'd for commit by
      Andi.

2003-07-04  Andi Gutmans  <andi@zend.com>

    * zend_alloc.c
      zend_mm.c
      zend_mm.h:
      - Add heap to memory manager. This should improve performance.
      - Enabling it by default so that it gets tested. We should decide before
      beta 2 if we want to revert back to malloc or not.
      - Thanks to Sebastian for benchmarking it

2003-07-04  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      2 * TSRMLS_FETCH() -> 1 * TSRMLS_DC

2003-07-04  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      ws fix

2003-07-03  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Allow final private methods

2003-07-03  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      win build fixes  (Rob Richards)

    * zend_reflection_api.c:
      can't forget Andrei

2003-07-03  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c
      zend_execute.c:
      enable Classname() constructor to be called via parent::__constructor()

    * tests/bug19859.phpt:
      add test for Bug #19859

    * zend_API.c
      zend_execute_API.c:
      Fix bug #19859 - allow fast_call_user_function to support __call

    * zend_builtin_functions.c:
      fix the get_parent_class fix

2003-07-03  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      more of Timm's patches, and mod authors line to give credit where credit is
      due.

2003-07-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c:
      Temporairy solution to overcome shutdown propbelms with objects that have
      hidden destructors.

    * zend_objects.c:
      Reorganize this a bit to ensure the object memory is destructed before
      showing the error.

    * zend_builtin_functions.c:
      Bug #24399: is_subclass_of(): fix memleak, too

2003-07-02  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Throughly fix scoping change.  Fixes, among other things, bug #24403

2003-07-02  Andi Gutmans  <andi@zend.com>

    * zend_compile.c
      zend_globals.h:
      - Nuke CG(in_clone_method)

2003-07-02  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix for bug #22367.
      Heads up - this will break syntactical compatiblity, return($foo) will
      not work with functions that return references - return $foo should be
      used
      instead.  It never worked well before, and caused all sorts of odd bugs.
      It *might* be possible to support this specifically, albeit unlikely

2003-07-02  Sterling Hughes  <sterling@bumblebury.com>

    * zend_execute_API.c:
      optimize the case where the object is really a class name, as we don't need
      to set EX(object) here.

    * zend_execute_API.c:
      Timm Friebe points out that object detection should be done regardless of
      the function pointer

2003-07-02  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c:
      Finally fix property cloning and fix the tests accordingly.
      

2003-07-02  Sterling Hughes  <sterling@bumblebury.com>

    * zend_builtin_functions.c:
      Fix bug #24445

2003-07-01  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_objects.c:
      Fix __clone().
      

    * tests/bug20240.phpt:
      Use both destructor and shutdown

    * zend_execute_API.c:
      small bugfix

    * tests/bug24436.php
      tests/bug24436.phpt:
      Rename  test to correct  extension

    * zend_execute.c:
      __clone might not be defined

    * zend_execute.c:
      Fix __clone visibility

    * zend_object_handlers.c
      zend_object_handlers.h
      zend_objects.c:
      Fix destructor visibility

2003-07-01  Derick Rethans  <d.rethans@jdimedia.nl>

    * tests/bug24436.php:
      - Added test for bug #24436

2003-07-01  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      Timm Friebe's patches for code celanup and additional functions.

2003-07-01  Jani Taskinen  <sniper@iki.fi>

    * tests/.cvsignore
      tests/bug21478.phpt
      tests/zend2.php
      tests/zend2.php.txt:
      Missing .cvsignore, broken test, renamed zend2.php -> zend2.php.txt

2003-07-01  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      ZTS fixes.

2003-07-01  George Schlossnagle  <george@omniti.com>

    * zend_reflection_api.c:
      more incremental changes.  add anything that needs a class factory.

    * zend_reflection_api.c:
      all the easy parts of Reflection_Class

2003-06-30  Shane Caraveo  <shane@caraveo.com>

    * zend_operators.h:
      this fixes including this header in a c++ file (vs6)

2003-06-30  Sterling Hughes  <sterling@bumblebury.com>

    * zend_compile.c:
      nuke "main" as a reserved keyword

2003-06-30  Andi Gutmans  <andi@zend.com>

    * zend.c
      zend_API.c
      zend_compile.c
      zend_constants.c
      zend_execute.c
      zend_execute_API.c
      zend_mm.c
      zend_opcode.c
      zend_reflection_api.c:
      - ZE coding style requires if ( instead of if(

2003-06-30  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_reflection_api.c:
      ZTS fixes. Remove unused local variables.

2003-06-30  George Schlossnagle  <george@omniti.com>

    * Makefile.am
      Zend.dsp
      ZendTS.dsp
      zend_default_classes.c
      zend_reflection_api.c
      zend_reflection_api.h:
      added support for Reflection_Function, the first part of
      the reflection api

2003-06-30  Sterling Hughes  <sterling@bumblebury.com>

    * zend_builtin_functions.c:
      move the check down a little so it catches all cases

    * zend_builtin_functions.c:
      Fix bug #24399 from an excellent test case by edin

2003-06-30  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Semantically it's a refcount increase, not a lock...

    * zend_execute.c:
      Fix 'global' implementation (fixes, at least, bug #24396

2003-06-30  Sterling Hughes  <sterling@bumblebury.com>

    * zend_operators.c:
      revert back the optimization for now.

2003-06-29  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_object_handlers.c:
      Fixed bug #24279 (__get() crash when no value is returned)

2003-06-29  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * ZEND_CHANGES:
      Remove namespace references.

2003-06-29  Sterling Hughes  <sterling@bumblebury.com>

    * zend_operators.c:
      Very simple, but very effective optimization.  Provides a signifigant speed
      improvement to matches done via '=='.  This checks that the lengths of two
      strings are equal before performing a memcmp() on them.

2003-06-23  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix crash :)

2003-06-23  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      FIx leak

2003-06-22  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c
      zend_language_parser.y:
      Fix complex expressions for class names in NEW

    * zend_language_parser.y:
      Simplify

2003-06-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_parser.y:
      WS

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y:
      Add final classes

2003-06-16  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      no need to init zval - assignment will init

    * zend_execute.c:
      Fix bug #22592 - cascading assignments to string offsets

    * zend_constants.c:
      support for self:: and parent:: constants

    * zend_builtin_functions.c:
      fix lambda function static vars (related to #17115)

2003-06-15  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_constants.c:
      Fix ZTS build.

2003-06-15  Stanislav Malyshev  <stas@zend.com>

    * zend.c:
      Fix bug #23279 - exception handler exits after first function call

    * zend_execute_API.c:
      No need to duplicate code - zend_get_constant() knows to
      handle class constants now

    * zend_execute_API.c:
      Fix bug #18872 - Improper handling of class constants used as default
      function argument values

    * zend_constants.c:
      set ending \0 for string

    * zend_compile.c
      zend_constants.c
      zend_language_parser.y:
      Fix bug #23384 - static class::constant constants should now
      work in static & array expressions.

    * zend_execute_API.c:
      Fix bug #21800 - initialize opcode handlers in interactive mode

2003-06-14  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_hash.c:
      ecalloc doesn't return NULL

    * zend.c:
      Bugfix #24182: va_arg macro error in Zend/zend.c

2003-06-10  Jani Taskinen  <sniper@iki.fi>

    * zend_multiply.h:
      - Missing $Id: ChangeLog,v 1.745 2005/08/06 05:37:51 changelog Exp $ tag

2003-06-10  James Cox  <james@imajes.info>

    * acconfig.h
      zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_alloc.c
      zend_alloc.h
      zend_builtin_functions.c
      zend_builtin_functions.h
      zend_compile.c
      zend_compile.h
      zend_config.nw.h
      zend_config.w32.h
      zend_constants.c
      zend_constants.h
      zend_default_classes.c
      zend_default_classes.h
      zend_dynamic_array.c
      zend_dynamic_array.h
      zend_errors.h
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_execute_locks.h
      zend_extensions.c
      zend_extensions.h
      zend_fast_cache.h
      zend_globals.h
      zend_globals_macros.h
      zend_hash.c
      zend_hash.h
      zend_highlight.c
      zend_highlight.h
      zend_indent.c
      zend_indent.h
      zend_ini.c
      zend_ini.h
      zend_ini_parser.y
      zend_ini_scanner.h
      zend_ini_scanner.l
      zend_istdiostream.h
      zend_language_parser.y
      zend_language_scanner.h
      zend_language_scanner.l
      zend_list.c
      zend_list.h
      zend_llist.c
      zend_llist.h
      zend_mm.c
      zend_mm.h
      zend_modules.h
      zend_multiply.h
      zend_object_handlers.c
      zend_object_handlers.h
      zend_objects.c
      zend_objects.h
      zend_objects_API.c
      zend_objects_API.h
      zend_opcode.c
      zend_operators.c
      zend_operators.h
      zend_ptr_stack.c
      zend_ptr_stack.h
      zend_qsort.c
      zend_qsort.h
      zend_sprintf.c
      zend_stack.c
      zend_stack.h
      zend_static_allocator.c
      zend_static_allocator.h
      zend_stream.c
      zend_stream.h
      zend_ts_hash.c
      zend_ts_hash.h
      zend_types.h
      zend_variables.c
      zend_variables.h:
      updating license information in the headers.

2003-06-09  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_execute_API.c:
      Fix for Bug #23951

2003-06-09  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      remove NS leftover

2003-06-09  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y:
      Fix bogus implicit declarations of properties (squash bug #23671)

2003-06-09  Stanislav Malyshev  <stas@zend.com>

    * zend_API.c
      zend_execute_API.c:
      Support 'self' and 'parent' in call_user_func()

2003-06-09  Zeev Suraski  <zeev@zend.com>

    * zend_execute.c:
      Fix indirect reference calls to bogus function names

2003-06-09  Jani Taskinen  <sniper@iki.fi>

    * zend_builtin_functions.c:
      ws

2003-06-08  Zeev Suraski  <zeev@zend.com>

    * zend_object_handlers.c:
      Fix casing issues in access level checks

    * zend.c
      zend_compile.c
      zend_compile.h:
      Nicer handling of protected/private members in print_r()

    * zend_execute.c:
      Fix handling of object property assignments in switch expressions
      (bug #23925)

    * zend_builtin_functions.c:
      Fix set_error_handler()

2003-06-06  Sascha Schumann  <sascha@schumann.cx>

    * zend_multiply.h:
      mfb #24025 fix

2003-06-04  Stanislav Malyshev  <stas@zend.com>

    * zend.c:
      fix non-ZTS build

2003-06-04  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend.c:
      Fix segfault. Again.

2003-06-04  Stanislav Malyshev  <stas@zend.com>

    * zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_builtin_functions.c
      zend_object_handlers.c:
      rm namespace leftovers

2003-06-04  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend.c:
      Fix segfault. #Hopefully not a Voodoo Fix[TM].

2003-06-02  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend.c
      zend_execute.h:
      Leftover.

2003-06-02  Stanislav Malyshev  <stas@zend.com>

    * zend.c
      zend.h
      zend_API.c
      zend_API.h
      zend_builtin_functions.c
      zend_compile.c
      zend_compile.h
      zend_constants.c
      zend_execute.c
      zend_execute.h
      zend_execute_API.c
      zend_globals.h
      zend_language_parser.y
      zend_language_scanner.l
      zend_object_handlers.c
      zend_opcode.c:
      MEGA-patch: namespaces are R.I.P.

2003-06-01  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * tests/zend2.php:
      No nested classes

    * tests/bug20240.phpt
      tests/bug20242.phpt
      tests/bug21478.phpt
      tests/bug21888.phpt
      tests/bug22725.phpt:
      Add some ZE2 bug tests

    * zend_opcode.c:
      Bugfix #23670: implements and extends cause Apache 2 crash

    * zend_constants.c:
      Do it correct always

    * zend_compile.h:
      Defining it once is enough

2003-05-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend.c:
      Fix init shutdown

2003-05-31  Sterling Hughes  <sterling@bumblebury.com>

    * zend_compile.c
      zend_execute.c:
      revert the function call caching patch until a new solution is decided
      upon.

2003-05-31  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_constants.c:
      Fix constants (noticed by David Brown <dave@codewhore.org>)

    * zend_constants.c:
      c->name_len already contains the '\0'

2003-05-30  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      fix crash on exceptions when return value of the inside function is used

2003-05-29  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c
      zend_language_parser.y:
      Fix ~ operator in class constants.

    * zend_compile.c
      zend_compile.h
      zend_operators.c:
      Faster interface inheritance & faster inheritance checks

    * zend_language_scanner.l:
      CS

2003-05-29  Wez Furlong  <wez.php@thebrainroom.net>

    * zend_compile.c:
      Fix Bug #23285 (Potential Stack Overflow in zendlex).

2003-05-28  Sterling Hughes  <sterling@bumblebury.com>

    * zend_alloc.c:
      no reason to do this at runtime

    * zend_compile.c
      zend_execute.c:
      Cache function call lookups with loops (store in a temporary variable on
      the
      result opline).
      Assuming lazy concensus on message that GeorgeS sent to the list last week

2003-05-27  Sterling Hughes  <sterling@bumblebury.com>

    * zend.c
      zend_object_handlers.c
      zend_object_handlers.h
      zend_operators.c:
      Assume lazy consensus regarding the cast_object() patch.  *Only*
      implemented
      from a internals perspective.  This callback has been very useful for both
      ext/mono and ext/simplexml

2003-05-26  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_language_scanner.l:
      Add pseudo constant __METHOD__ to easily report namespace::class::method.
      

2003-05-23  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.h:
      Revert to sizeof()

2003-05-23  Sterling Hughes  <sterling@bumblebury.com>

    * zend_execute.c
      zend_hash.c
      zend_operators.c
      zend_operators.h:
      move HANDLE_NUMERIC() from the hash table implementation upstream to the
      places that actually need to use it.

2003-05-22  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      No need to copy here unless implicit_clone is active (noticed by rob)

2003-05-21  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c
      zend_builtin_functions.c
      zend_constants.c
      zend_object_handlers.c:
      Make use optimized string lowering

    * zend_operators.c
      zend_operators.h:
      Use same parameter order as strcpy()

    * zend_API.c
      zend_execute.c
      zend_execute_API.c
      zend_operators.c
      zend_operators.h:
      Make zend_str_tolower_copy() a copy function (like stccpy).
      Supply a dup version (like estrdup).
      Fix tolower() handling.

2003-05-21  Jani Taskinen  <sniper@iki.fi>

    * zend_builtin_functions.c:
      Fixed bug #23619 (set_error_handler() registered handler not called for
      object instances). (Jani, waboring@qualys.com)

2003-05-21  Sterling Hughes  <sterling@bumblebury.com>

    * zend_operators.c:
      optimize loops.  The check only exists for integers because that's the more
      common optimization, and you actually lose performance if you check for
      a double too (wierd but true).

    * zend_mm.h:
      add some logic to detect zend_mm, which is really only useful when thread
      safety support is enabled.

    * zend_mm.h:
      leave this off until its more ready/stable
      php5 actually beats php4.3.* in my benchmarks now
      

    * zend_API.c:
      use zend_str_tolower_copy()

    * zend_execute.c:
      Bottom drawer optimization to avoid this comparison, but this OP is
      executed
      quite often (all of the fetch_* ops)

2003-05-20  Sterling Hughes  <sterling@bumblebury.com>

    * zend_operators.c:
      bah humbug, use the pointer based version, which turns out to be an
      instruction
      faster

    * zend_operators.c:
      use pointer arithmetic for the normal zend_str_tolower()

2003-05-20  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      No need to copy the zval unless __clone() is called

2003-05-20  Sterling Hughes  <sterling@bumblebury.com>

    * zend_operators.c:
      make this faster and sexier

    * zend_execute.c:
      use the new zend_str_tolower_copy() function

    * zend_operators.c:
      doesn't need to be register

    * zend_execute_API.c
      zend_operators.c
      zend_operators.h:
      optimize the lookups by avoiding a copy and then another pass
      
      Naked Dancing Girls should be given to: Myself, Zeev, Marcus,
      and George Schlossnagle (in no particular order)

    * zend_API.h
      zend_execute_API.c:
      add fast_call_user_function()

2003-05-20  Hartmut Holzgraefe  <hartmut@php-groupies.de>

    * zend_API.h
      zend_constants.h
      zend_operators.h:
      C++ compile fixes

2003-05-19  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute.c:
      Fix exception memleak

2003-05-19  Stanislav Malyshev  <stas@zend.com>

    * zend_compile.c
      zend_execute.c:
      fix __clone

2003-05-12  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_execute_API.c:
      One function  call is enough

2003-05-08  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Inheritance fix

2003-05-07  Edin Kadribasic  <edink@proventum.net>

    * zend_compile.c:
      Reverting Marcus' incomplete patch which broke the build.

2003-05-07  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_compile.c:
      Inheritance fixes

2003-05-04  Marcus Boerger  <marcus.boerger@post.rwth-aachen.de>

    * zend_API.c:
      Fix namespace issue: Only CG is needed here

    * zend_API.c
      zend_API.h:
      Allow functions in internal namespaces (for example factories)

    * zend_execute.c:
      Modify the abstract error message so that it shows up to three methods not
      implemented.

    * zend_execute.c:
      Fix warnings

    * zend_compile.c:
      Don't inherit twice what is needed only once

    * zend.c:
      Fix bug #23162 user_error() crashs if  > 1024 bytes (Marcus, Moriyoshi)

2003-05-04  Sterling Hughes  <sterling@bumblebury.com>

    * zend_default_classes.h:
      semicolon

2003-05-03  Sterling Hughes  <sterling@bumblebury.com>

    * zend_default_classes.h:
      proto

    * zend_default_classes.c:
      add an accessor for the default exception

2003-04-29  Sascha Schumann  <sascha@schumann.cx>

    * zend_multiply.h:
      Fix the *= operator
      
      Slightly modified patch by Wez Furlong

2003-04-25  Jani Taskinen  <sniper@iki.fi>

    * zend_language_scanner.l:
      Fixed bug #21820 ("$arr[foo]" generates bogus E_NOTICE, should be E_PARSE)

2003-04-24  Sascha Schumann  <sascha@schumann.cx>

    * zend_alloc.c
      zend_alloc.h
      zend_multiply.h:
      add safe_emalloc

2003-04-21  Stanislav Malyshev  <stas@zend.com>

    * zend.c
      zend_API.c
      zend_API.h
      zend_builtin_functions.c
      zend_object_handlers.c:
      Change get_class() so that it returns qualified names for namespaced
      classes.
      
      *HEADS UP*: get_class_name() handler interface is changed, now it should
      allocate the space it returns with emalloc, and the users free it. If
      anyone has problems with it or has suggestions how to do it without this -
      please tell.
      
      Also: make function_exists() understand namespaces.

    * zend_execute.c:
      make import * fail if such classes or functions already there

2003-04-20  Sterling Hughes  <sterling@bumblebury.com>

    * zend_compile.c:
      Add check for final properties

2003-04-20  Stanislav Malyshev  <stas@zend.com>

    * zend_execute_API.c:
      Check name before '::' so that it would be a namespace in
      zend_lookup_ns_class

    * zend_builtin_functions.c:
      refine the set_error_handler fix

    * zend_builtin_functions.c:
      Fix for bug #21094 (set_error_handler can not accept methods),
      by Timm Friebe

2003-04-19  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend.c:
      Corrected patch by Marcus Börger <helly@php.net>.

2003-04-18  Sterling Hughes  <sterling@bumblebury.com>

    * zend.c
      zend_opcode.c:
      Patch by Marcus Börger to fix some memleaks

2003-04-18  Derick Rethans  <d.rethans@jdimedia.nl>

    * zend.h
      zend_extensions.c:
      - Revert my symbol fix patch, and merge in Stas' fixes to Zend Engine 1.

    * zend.h:
      - MacOSX also prepends the _ before symbols in bundles

2003-04-17  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend.c:
      Patch by Marcus Börger <helly@php.net>.

2003-04-11  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_compile.c
      zend_compile.h:
      Fix warnings.

2003-04-10  Sterling Hughes  <sterling@bumblebury.com>

    * zend_compile.c:
      satisfy andi's switch fetish ;-)

2003-04-10  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_compile.c:
      Fix ZTS build. Fix warning.

    * ZEND_CHANGES:
      Document 'const' keyword.

2003-04-10  Sterling Hughes  <sterling@bumblebury.com>

    * zend_compile.c
      zend_compile.h
      zend_language_parser.y:
      allow expressions within constants, so the following is possible
      
      class foo {
      	const a = 1<<0;
      	const b = 1<<1;
      	const c = a | b;
      }
      
      this makes const a compile-time expression.  all other operators are
      unaffected.

2003-04-10  Zeev Suraski  <zeev@zend.com>

    * zend_language_parser.y
      zend_language_scanner.l:
      Revert Harald's commit

2003-04-10  George Schlossnagle  <george@omniti.com>

    * zend_language_parser.y:
      One line fix so that it will compile

2003-04-09  Harald Radi  <harald.radi+coding.php@nme.at>

    * zend_language_parser.y
      zend_language_scanner.l:
      removing the *syntactical sugar* again
      

2003-04-08  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_builtin_functions.c:
      Switch some functions to use new zend_lookup_ns_class() methods. This
      means that they will accept both simple and fully qualified class names.

    * zend_API.c
      zend_API.h:
      Rename zend_register_internal_class_in_ns() to a better, less filling,
      but with the same great taste zend_register_internal_ns_class().

    * zend_execute.h
      zend_execute_API.c:
      Add zend_lookup_ns_class() function.

    * zend_operators.h:
      Move memnstr into Zend and make an alias for BC in PHP.

2003-04-07  Jani Taskinen  <sniper@iki.fi>

    * zend_language_scanner.l:
      Fixed bug #23093 (highlight_string() crashed with __FUNCTION__)

2003-04-07  Sterling Hughes  <sterling@bumblebury.com>

    * zend_compile.h:
      add markers that make this file easy to parse for external sources

2003-04-04  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_API.h:
      Introduce ZEND_ME() and ZEND_METHOD() macros. Use these for declaring
      class methods to avoid name collisions.

2003-04-04  Stanislav Malyshev  <stas@zend.com>

    * zend_API.c
      zend_API.h:
      Fix namespace issues

2003-04-03  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_API.c:
      Patch from Timm Friede for when EG(active_namespace) is NULL initially.

    * zend.c
      zend_API.c
      zend_compile.c:
      Initialize all relevant zend_class_entry fields to avoid accidental
      crashes.

2003-04-03  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_list.c:
      Leftover.

2003-04-03  Sterling Hughes  <sterling@bumblebury.com>

    * zend_list.c
      zend_list.h:
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00
      i will not commit before 12:00

2003-04-02  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_API.c
      zend_API.h:
      - Add zend_register_internal_namespace() API function.
      - Add zend_register_internal_class_in_ns() API function.

    * zend_compile.h:
      Simplify.

2003-04-02  Derick Rethans  <d.rethans@jdimedia.nl>

    * zend_list.c:
      - Fix whitespace

2003-04-02  Sterling Hughes  <sterling@bumblebury.com>

    * zend_list.c
      zend_list.h:
      add the ability for curl_multi_info to introspect the handles.
      

2003-04-02  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_compile.c
      zend_compile.h
      zend_globals.h
      zend_language_parser.y
      zend_language_scanner.l:
      Implement a different way to catch documentation comments.

    * zend_compile.c
      zend_compile.h
      zend_highlight.c
      zend_language_parser.y
      zend_language_scanner.l:
      Revert portions of the doc comment patch. There should be no parser
      errors now.

2003-04-02  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c
      zend_compile.h
      zend_execute.c:
      allow class_exists() to work with namespaces too.
      add CLASS_IS_NAMESPACE macro

    * zend_builtin_functions.c:
      fix typo

    * zend_builtin_functions.c:
      fix parameterless get_declared_classes call

2003-04-01  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_execute.c:
      Stas's patch on zend_execute.c (1.448 -> 1.449) resulted in a bug where
      the namespaced member accesses didn't work. This should hopefully
      correct it.

    * zend_builtin_functions.c
      zend_compile.c
      zend_compile.h
      zend_execute.c
      zend_object_handlers.c
      zend_opcode.c:
      Split ZEND_NAMESPACE into user and internal namespaces. Hope this is
      okay with engine folks.

2003-04-01  Stanislav Malyshev  <stas@zend.com>

    * zend_builtin_functions.c:
      improve namespace name hanfling

    * zend_builtin_functions.c:
      fix get_declared_classes()

    * zend_language_parser.y
      zend_language_scanner.l:
      Add __NAMESPACE__ auto-constant.

    * zend_builtin_functions.c:
      make get_declared_classes() work with namespaces (based on Tal Peer's
      patch)

2003-03-31  Andrei Zmievski  <andrei@gravitonic.com>

    * zend.h
      zend_compile.c
      zend_compile.h
      zend_globals.h
      zend_language_parser.y
      zend_language_scanner.l
      zend_opcode.c:
      Multi-purpose patch:
       - The fields of zend_namespace were not completely initialized which
         led to a variety of problems.
       - The occurrence of class/interface/namespace definition is now
         captured.
       - Functions/classes/interfaces/namespaces can be preceded by doc
         comments which are stored for use by extensions.

2003-03-31  Stanislav Malyshev  <stas@zend.com>

    * zend.c:
      Use strncpy instead of sprintf

2003-03-30  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_language_parser.y:
      Since zend_do_begin_class_member_function_call assumes the previous
      opcode is FETCH_CONSTANT, swap the calls around.

2003-03-30  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_execute.c:
      ZTS fix.

2003-03-30  Stanislav Malyshev  <stas@zend.com>

    * zend.c:
      Try to report class name of the exception

    * zend_execute.c:
      Fix namespace switch

2003-03-29  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Add missing initialization

    * zend_compile.c:
      Fix crash

    * zend_API.c
      zend_compile.c
      zend_compile.h:
      Initial support for enforcing prototype of abstract/interface method
      implementations

2003-03-29  Sterling Hughes  <sterling@bumblebury.com>

    * zend.c:
      remove unused variable

2003-03-27  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      fix fetch_class buglet

2003-03-26  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c
      zend_language_parser.y:
      Un-nest namespaces - now namespace X { namespace Y {} } is a parse error
      Also refine namespaced includes

2003-03-26  Ilia Alshanetsky  <ilia@prohost.org>

    * zend_compile.c:
      Fixed bug #22900 (declaration of namespaces with same name results in
      leaks).

2003-03-26  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend.c
      zend_API.c
      zend_API.h
      zend_builtin_functions.c
      zend_compile.h
      zend_execute.c
      zend_execute_API.c
      zend_opcode.c
      zend_operators.h:
      Eliminate TSRMLS_FETCH() calls in destroy_op_array() and
      zend_get_class_entry().

    * zend_API.c
      zend_object_handlers.c
      zend_objects.c
      zend_objects.h:
      Eliminate TSRMLS_FETCH() calls in zend_objects_new() and
      zend_objects_get_address().

2003-03-25  Andi Gutmans  <andi@zend.com>

    * zend_compile.c:
      - Temporarily fix problem with inheriting from an internal class. This
      might
      - need some rework in the future (thanks to Marcus)

2003-03-24  Stanislav Malyshev  <stas@zend.com>

    * zend_execute.c:
      Fix {include|require}_once error message - if open
      fails, don't use tream, use original name.

2003-03-23  Andi Gutmans  <andi@zend.com>

    * zend.c:
      - Fix win32 build

2003-03-23  Stanislav Malyshev  <stas@zend.com>

    * zend.c:
      resore namespace on shutdown - since some functions use
      EG() and CG() pointers

2003-03-23  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * zend_default_classes.c:
      ZTS fix.

2003-03-23  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c:
      Another fix for implicit public, perhaps it was not such a good idea :I

2003-03-23  Sebastian Bergmann  <sb@sebastian-bergmann.de>

    * Zend.dsp
      ZendTS.dsp
      zend_default_classes.c:
      Add new files to ZendTS.dsp. Sync list of files in Zend.dsp with
      ZendTS.dsp. ZTS fixes.

2003-03-23  Sterling Hughes  <sterling@bumblebury.com>

    * zend_default_classes.h:
      DEFAULT_CLASSES_H not DEFAULT_INTERFACES_H

    * Makefile.am
      zend.c
      zend_default_classes.c
      zend_default_classes.h:
      add a standard Exception class.

2003-03-22  Shane Caraveo  <shane@caraveo.com>

    * zend_compile.h:
      export functions needed by cli

    * zend_language_scanner.l:
      fix crash in win32 debug build

2003-03-20  Stanislav Malyshev  <stas@zend.com>

    * Zend.m4:
      Add stdlib.h too - it is needed fot strto{ld}

2003-03-19  Andrei Zmievski  <andrei@gravitonic.com>

    * zend_compile.c
      zend_compile.h
      zend_globals.h
      zend_highlight.c
      zend_language_parser.y
      zend_language_scanner.l:
      - Keep track of starting/ending line numbers for user functions.
      - Store last parsed doc comment in a compiler global for future use.

    * zend_API.c:
      Lowercase the function name when used as key in the function name. The
      original case is still preserved in zend_function structure.

2003-03-18  Zeev Suraski  <zeev@zend.com>

    * zend_compile.c
      zend_object_handlers.c:
      - Fix situation where a derived class declares a public (or implicit
      public)
        with the same name as a private in the parent
      - Optimize 'static binding' of private properties a bit

2003-03-18  Stig Bakken  <ssb@fast.no>

    * RFCs/002.txt:
      - email address change

2003-03-17  Stanislav Malyshev  <stas@zend.com>

    * zend_extensions.c:
      MFZE1

2003-03-17  Jani Taskinen  <sniper@iki.fi>

    * Makefile.am:
